--CDKEY活动
--2017-01-04 00:00:00 iorinie

ActCDKeyRwdPane = class();

function ActCDKeyRwdPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

function ActCDKeyRwdPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    
    self.btnComfirm = nil

    self:initPanel();
    self:initListener();
end

function ActCDKeyRwdPane:initPanel ()
    self.btnComfirm = GetGameObject(self.transform, "BtnComfirm");
    self.inputArea = GetPathComponent(self.transform, "FG/InputArea", "UIInput")
end

function ActCDKeyRwdPane:initListener ()
    ViewUtil.AddClickEvent(self.btnComfirm, function () self:getRwd() end)
end

function ActCDKeyRwdPane:request ()
    
end

function ActCDKeyRwdPane:setData (_sd)
    
end

function ActCDKeyRwdPane:getRwd ()
    local mapData, buf = Map.new(), nil;
    
    local cdkey = self.inputArea.value
    mapData:put("cdkey", cdkey);
    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.Act_CDKEY_Get, nil, function (sd) self:getRwdHandle(sd); end, nil ,doNthFunc)
end

function ActCDKeyRwdPane:getRwdHandle (_sd, _val)
    local defData = nil;
    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        -- ViewUtil.showMsg(GetWord(defData.code));
        ViewUtil.showMsg("领取失败！");
        return ;
    end

    ViewUtil.showMsg("领取成功，请于背包中查看！");
end