--活动奖励条基类
--2016-10-26 15:40:23 library

ActContentBaseBar = class();

--[[

]]
function ActContentBaseBar:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

--[[

]]
function ActContentBaseBar:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.propBase = nil;
    self.grid = nil;
    self.condition = nil;
    self.progress = nil;
    self.btn = nil;
    self.complete = nil;

    self.curDay = 0;--当前进度
    self.state = 0;--当前按钮状态
    self.data = nil;--tab
    self.btnClickCallBack = nil;--function

    self:initPanel();
    self:initListener();
end

--[[

]]
function ActContentBaseBar:initPanel ()
    self.grid = GetGameObject(self.transform, "Scroll View/Panel/Grid");
    self.propBase = GetGameObject(self.grid.transform, "PropItemNPBase");
    self.btn = GetGameObject(self.transform, "BtnObtain");
    
    self.condition = GetGameObject(self.transform, "Condition");
    self.progress = GetGameObject(self.transform, "Progress");
    self.complete = GetGameObject(self.transform, "complete");
end

--[[

]]
function ActContentBaseBar:initListener ()
    -- UIEventListener.Get(self.btn).onClick = function ()
    --     if (nil ~= self.btnClickCallBack) then
    --         self.btnClickCallBack(self.data);
    --     end
    -- end
    ViewUtil.AddClickEvent(self.btn, function ()
        if (nil ~= self.btnClickCallBack) then
            self.btnClickCallBack(self.data);
        end
    end)
end

--[[

]]
function ActContentBaseBar:setCondition (_str)
    GetComponent(self.condition, "UILabel").text = _str;
end

--[[

]]
function ActContentBaseBar:setProgress (_str)
    GetComponent(self.progress, "UILabel").text = _str;
end

--[[
    _data table 当前条的基础信息
    _btnCallBack 按钮事件回调
]]
function ActContentBaseBar:setData (_data, _btnCallBack)
    self.data = _data;
    self.btnClickCallBack = _btnCallBack;

    self:showProps();
end

--[[

]]
function ActContentBaseBar:showProps ()
    local propShowItem, propTab, propTmp = nil, nil, nil;
    
    for i = 1, #self.data[3] do
        propTab = self.data[3][i];
        propTmp = CreateObject(self.propBase);
        propTmp:SetActive(true);
        propShowItem = ActPropShow.new(); --因为奖励可能有英雄，id和item不同，因此不使用PropShowItem类 by iorinie
        propShowItem:Awake(propTmp, propTab[1], propTab[2]);
        propShowItem:Start();
        HangObject(propTmp, self.grid);
    end
--    propTmp = CreateObject(self.propBase);
--    propTmp:SetActive(true);
--    propShowItem = PropShowItem.new();
--    propShowItem:Awake(propTmp, self.data[3], 1);
--    propShowItem:Start();
--    HangObject(propTmp, self.grid);
      ResetGrid(self.grid);
end

--[[
    设置按钮的状态
]]
function ActContentBaseBar:setBtn ()
    if (0 == self.state) then
        self.btn:SetActive(true);
        self.complete:SetActive(false);
        if (self.curDay >= tonumber(self.data[2][1][1])) then
            Util.EnableButton2D(self.btn, 0, true);
        else
            Util.EnableButton2D(self.btn, 3, false);
        end
    else
        self.btn:SetActive(false);
        self.complete:SetActive(true);
    end
end