--红包活动
--2016-11-22 00:00:00 iorinie

local const_isTime = "抢红包啦！"
local const_isNotTime = "时辰未到"
local const_rule = [[活动期间，系统会在每晚20点、22点发放红包，玩家需要在线才能抢到红包。
1. 领取红包时间有限，20点放出的红包，只能在20:00-21：00之间才可以领取，超时则无法领取。
2. 红包单次发放总血钻5万，抢完为止。
3. 每个红包最多开出1000血钻。]]
local const_oprateSuccess = "操作成功";

ActRedPacketRwdPane = class();

function ActRedPacketRwdPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.actId = ConstantNames.Act_RedPacketRwd;
end

function ActRedPacketRwdPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    
    self.btnRule = nil;
    self.btnRob = nil;
    self.showStatNight = nil;
    self.showStatLateNight = nil;
    self.rpaMain = nil;
    self.obtainStatus = nil

    self:initPanel();
    self:initListener();
end

function ActRedPacketRwdPane:initPanel ()
    self.btnRule = GetGameObject(self.transform, "BtnRule");
    self.btnRob = GetGameObject(self.transform, "BtnRob");

    self.showStatNight = GetPathComponent(self.transform, "Night/Tip", "UILabel")
    self.showStatLateNight = GetPathComponent(self.transform, "LateNight/Tip", "UILabel")
end

function ActRedPacketRwdPane:initListener ()
    UIEventListener.Get(self.btnRule).onPress = function (_go, _isPress) 
        if (_isPress) then
            ViewUtil.showCommonTips(self.btnRule, const_rule);
        else
            ViewUtil.removeTips();
        end
    end

    ViewUtil.AddClickEvent(self.btnRob, function () self:getRwd() end)
end

function ActRedPacketRwdPane:request ()
    local mapData, buf = nil, nil;

    mapData = Map.new();
    mapData:put("id", ConstantNames.Act_RedPacketRwd);
    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.Act_RedPacket_Ety, nil, function (sd) self:setData(sd); end, nil, doNthFunc);
end

function ActRedPacketRwdPane:setData (_sd)
    self.rpaMain = GetProtoTable("RedPacketActiveMain", _sd);

    if self.rpaMain.step == -1 then --未开启
        self.showStatNight.text = const_isNotTime
        self.showStatLateNight.text = const_isNotTime
    elseif self.rpaMain.step == 0 then --晚八点
        self.showStatNight.text = const_isTime
    elseif self.rpaMain.step == 1 then--晚九点
        self.showStatLateNight.text = const_isTime
    end
end

function ActRedPacketRwdPane:getRwd ()
    -- local cfg = ActDataProxy.getActCfgById(ConstantNames.Act_ExchangeRwd)
    -- local cfgTab = LogicUtil.nSplitStrCfgs(cfg)

    -- for i = 1, #cfgTab do
        
    -- end

    local mapData, buf = Map.new(), nil;
    
    mapData:put("id", ConstantNames.Act_RedPacketRwd);
    -- mapData:put("step", 0)
    buf = Network.reqParamEncode(mapData);

    if self.rpaMain.step == -1 then
        self:setObtainStatus(0)
    else
        self:setObtainStatus(1)
    end

    NetManager:SendData(self, buf, ServerID.Act_RedPacket_Get, nil, function (sd) self:getRwdHandle(sd, self.obtainStatus); end, nil ,doNthFunc)
end

function ActRedPacketRwdPane:getRwdHandle (_sd, _val)
    -- if _val == 0 then
    --     ViewUtil.showMsg("已经领取!")
    --     return
    -- end

    local defData = nil;
    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end

    ViewUtil.showMsg(const_oprateSuccess);
end

function ActRedPacketRwdPane:setObtainStatus(_val)
    self.obtainStatus = _val
end