--2016-10-27 16:09:32 library

ActivityView = class(BaseView)

function ActivityView:ctor()
end  

function ActivityView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform

    self.actIdList = List.new();
    -- self.tabLuaList = List.new();
    self.tabLuaList = {}
    self.tabSlt = nil;--标签选中框
    self.tabGrid = nil;--标签页的父对象
    self.tabGridPane = nil;
    self.scrollBG = nil;
    self.tabBase = nil;
    self.curActId = -1;

    self:setActData();
	self:initPanel()
    self:drawActTabs();
    -- self:tabClick(self.actIdList[1]);

    -- HangObject(self.tabSlt, self.tab_0);
    -- self.tabSlt:SetActive(true);
    -- self:setTabSltDepth(self.tab_0); 
    -- self:ShowActivityContent(0)
    self:tabClick(0)

    if AudioConst:GetBgmName() ~= "activity" then
        SimpleAudio.StopMusic(doNthFunc)
        SimpleAudio.PlayMusic("activity")
        AudioConst:SetBgmName("activity")
    end
end

function ActivityView:Update()
    if self.scrollVIewPl.clipOffset.x <= 0 then
        self.shiftLeft:SetActive(false)
    elseif self.scrollVIewPl.clipOffset.x >= 656 then
        self.shiftRight:SetActive(false)
    else
        self.shiftLeft:SetActive(true)
        self.shiftRight:SetActive(true)
    end
end

--[[

]]
function ActivityView:setActData ()
    self.actIdList:clear();

    -- for i = 1, 

    for i = 1, #ActDataProxy.actData.activeList do
        if ActDataProxy.actData.activeList[i].id ~= 11 then --不取id为11的活动配置，后面需要优化 by iorinie
            self.actIdList:add(ActDataProxy.actData.activeList[i].id);
        end
    end
end

function ActivityView:initPanel()
	local topPath = "Mode/Top/Panel/";
	local centerPath = "Mode/Center/Panel/";
	local bottomPath = "Mode/Bottom/Panel/";

 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")

    self.tabGridPane = GetGameObject(self.transform, topPath .. "ActivityTag/ScrollViewBG/Scroll View/Panel");
    self.tabGrid = GetGameObject(self.transform, topPath .. "ActivityTag/ScrollViewBG/Scroll View/Panel/Grid");
	self.tabSlt = GetGameObject(self.transform, topPath .. "ActivityTag/ScrollViewBG/Scroll View/Panel/Grid/tabSlt");
    self.tabSlt:SetActive(true);
    self.tabBase = GetGameObject(self.tabGrid.transform, "ActivityTag");
    self.scrollBG = GetGameObject(self.transform, bottomPath .. "ScrollViewBG");
    self.shiftLeft = GetGameObject(self.transform, bottomPath .. "BtnShiftLeft");
    -- self.shiftLeft:SetActive(false)
    self.shiftRight = GetGameObject(self.transform, bottomPath .. "BtnShiftRight");
    -- self.shiftRight:SetActive(false)
    self.scrollView = GetPathComponent(self.transform, topPath .. "ActivityTag/ScrollViewBG/Scroll View", "UIScrollView");
    self.scrollVIewPl = GetPathComponent(self.transform, topPath .. "ActivityTag/ScrollViewBG/Scroll View", "UIPanel");

    self.tab_0 = GetGameObject(self.tabGrid.transform, "Act_0");

    local function doClick(obj)
        if obj == self.shiftLeft then
            self.scrollView:MoveRelative(Vector3.New(self.scrollVIewPl.clipOffset.x, 0, 0))
            self.shiftLeft:SetActive(false)
            self.shiftRight:SetActive(true)
        elseif obj == self.shiftRight then
        	self.scrollView:MoveRelative(Vector3.New(-660 + self.scrollVIewPl.clipOffset.x, 0, 0))
            self.shiftRight:SetActive(false)
            self.shiftLeft:SetActive(true)
        -- elseif obj == self.tab_0 then
        --     HangObject(self.tabSlt, self.tab_0);
        --     self.tabSlt:SetActive(true);
        --     self:setTabSltDepth(self.tab_0); 
        --     self:ShowActivityContent(0)
        end
    end
    ViewUtil.AddClickEvent(self.shiftLeft, doClick)
    ViewUtil.AddClickEvent(self.shiftRight, doClick)
    -- ViewUtil.AddClickEvent(self.tab_0, doClick)
end

--[[

]]
function ActivityView:drawActTabs ()
    local tabLua, tab = nil, nil;
	local bottomPath = "Mode/Bottom/Panel/";
    
	--活动内容table
	self.content = {}
    for i = 1, self.actIdList.size do
        self.content[self.actIdList[i]] = GetGameObject(self.transform, bottomPath .. "ActivityContent_" .. self.actIdList[i]);
    end
    self.content[12] = GetGameObject(self.transform, bottomPath .. "ActivityContent_1");
    self.content[0] = GetGameObject(self.transform, bottomPath .. "ActivityContent_0");

    HangObject(self.tabSlt, self.tabGrid);
    self.tabSlt:SetActive(false);
    for i = #self.tabLuaList, 1, -1 do
        tabLua = self.tabLuaList[i];
        tab = tabLua.gameObject;
        HangObject(tab, self.tabGridPane);
        DestroyObject(tab);
    end

    -- self.tabLuaList:clear();
    self.tabLuaList = {}

    local tabLua_0 = ActTab.new()
    tabLua_0:Awake(self.tab_0)
    tabLua_0:initData(0)
    self.tabLuaList[0] = tabLua_0

    for i = 1, #self.actIdList do
        tab = CreateObject(self.tabBase);
        tab.name = "Act_" .. self.actIdList[i];
        HangObject(tab, self.tabGrid);
        tab:SetActive(true);
        tabLua = ActTab.new();
        tabLua:Awake(tab, self.tabSlt);
        PanelManager:BindPanelScript(tabLua, tab, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        tabLua:initData(self.actIdList[i]);
        -- self.tabLuaList:add(tabLua);
        self.tabLuaList[i] = tabLua
    end
    
    ResetGrid(self.tabGrid);
end

--[[
    _actId number ActId
]]
function ActivityView:tabClick (_actId, _tp)
    local idxTmp = 0;
    -- if (self.tabLuaList.size < 1 or self.actIdList.size < 1 or (nil == tp and self.curActId == _actId)) then
    if (#self.tabLuaList < 1 or self.actIdList.size < 1 or (nil == tp and self.curActId == _actId)) then
        return ;
    end
    if self.curActId ~= -1 then
        GetPathComponent(GetGameObject(self.tabGrid.transform, "Act_"..self.curActId).transform, "Sprite", "UISprite").color = Color.New(225/255, 200/255, 150/255, 1)
    end

    self.curActId = _actId;
    idxTmp = self:getActIdx(_actId);

    GetPathComponent(GetGameObject(self.tabGrid.transform, "Act_"..self.curActId).transform, "Sprite", "UISprite").color = Color.New(1, 1, 1, 1)

    if (idxTmp > -1) then
        HangObject(self.tabSlt, self.tabLuaList[idxTmp].gameObject);
        self.tabSlt:SetActive(true);
        self:setTabSltDepth(self.tabLuaList[idxTmp].gameObject);            
	    self:ShowActivityContent(_actId);
    end
end

--[[

]]
function ActivityView:setTabSltDepth (_tags)
    local tagsSprite = nil;

    tagsSprite = GetPathComponent(_tags.transform, "Sprite", "UISprite");
    if (nil ~= tagsSprite) then 
        GetComponent(self.tabSlt, "UISprite").depth = tagsSprite.depth + 1;
    end
end

--[[

]]
function ActivityView:ShowActivityContent(_actId)
    if (self.lastContent) then
	    DestroyObject(self.lastContent);
        self.lastContent = nil;
        self.curActId = 0;
    end
	self:initContentPanel(_actId)
end

--[[

]]
function ActivityView:initContentPanel(_actId)
	local paneBase, pane, luaBhvi, luaTmp = nil, nil, nil, nil;
    
    paneBase = self.content[_actId];
    self.curActId = _actId;
    pane = CreateObject(paneBase);
    HangObject(pane, paneBase.transform.parent.gameObject);
    pane.transform.localPosition = paneBase.transform.localPosition;
    pane:SetActive(true);
    self.lastContent = pane;
    
    if _actId == ConstantNames.Act_LoginRwd then
        luaTmp = ActLoginRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane, self.scrollBG, _actId); --活动1和活动12都是同一个活动 by iorinie
        luaTmp:request();
	end

    if _actId == ConstantNames.Act_ArenaRwd then
        luaTmp = ActArenaRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane, self.scrollBG);
        luaTmp:request();
	end

    if _actId == ConstantNames.Act_DiamondRwd then
        luaTmp = ActDiamondRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane, self.scrollBG);
        luaTmp:request();
	end

    if _actId == ConstantNames.Act_FriendGiftRwd then
        luaTmp = ActFriendGiftRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane, self.scrollBG);
        luaTmp:request();
	end

    if _actId == ConstantNames.Act_ExploreFightBoss then
        luaTmp = ActExploreFightBossRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane, self.scrollBG);
        luaTmp:request();
	end

	if _actId == ConstantNames.Act_RedPacketRwd then
        luaTmp = ActRedPacketRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane);
        luaTmp:request();
	end

    if _actId == ConstantNames.Act_ExploreRwd then
        luaTmp = ActExploreRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane);
        luaTmp:request();
    end

    if _actId == ConstantNames.Act_ExchangeRwd then
        luaTmp = ActExchangeRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane);
        luaTmp:request();
    end

    if _actId == ConstantNames.Act_HangUpRwd then
        luaTmp = ActHangUpRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane);
        luaTmp:request();
    end

    if _actId == ConstantNames.Act_CollectRwd then
        luaTmp = ActCollectRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane);
        luaTmp:request();
    end

    if _actId == 12 then --活动1和活动12都是同一个活动 by iorinie
        luaTmp = ActLoginRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane, self.scrollBG, _actId);
        luaTmp:request();
    end

    if _actId == 0 then --常驻活动，兑换DCKEY。 by iorinie
        luaTmp = ActCDKeyRwdPane.new();
        PanelManager:BindPanelScript(luaTmp, pane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        luaTmp:Awake(pane);
        luaTmp:request();
    end
end

--[[

]]
function ActivityView:flushCurActPane ()
    local luaBhvi, luaPane = nil, nil;

    if (self.lastContent) then
        luaBhvi = GetComponent(self.lastContent, "LuaBehaviour");
        if (nil ~= luaBhvi) then
            luaPane = luaBhvi.sourceLuaObj;
            if (self:checkAct(luaPane.actId)) then
                luaPane:request();
            else
                self.tabClick(self.actIdList[1], 1);
            end
        end
    end
end

--[[

]]
function ActivityView:checkAct (_actId)
    local isExsit = false;

    for i = 1, self.actIdList.size do
        if (_actId == self.actIdList[i]) then
            isExsit = true;
            break ;
        end
    end
    return isExsit;
end

--[[

]]
function ActivityView:getActIdx (_actId)
    local idx = 0;

    for i = 1, self.actIdList.size do
        if (_actId == self.actIdList[i]) then
            idx = i;
            break ;
        end
    end
    return idx;
end