--解雇英雄的单个英雄GO逻辑类
--2016-7-6 15:12:56 library

local const_heroBGPre = "class";
local const_herosInTeam = "阵容中的英雄不能解雇";

BatFirePerHero = class();

--[[

]]
function BatFirePerHero:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.heroBG = nil;
    self.heroSprite = nil;
    self.heroBGUISprt = nil;
    self.heroSpriteUISprt = nil;
    self.sltGO = nil;

    self.heroData = nil;
    self.hCfg = nil;
    self.bfView = nil;
    self.callBack = nil;
end

--[[

]]
function BatFirePerHero:Awake (_go, _heroData, _hCfg, _sltGO, _bfView, _callBack)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    
    self.heroData = _heroData;
    self.hCfg = _hCfg;
    self.sltGO = _sltGO;
    self.bfView = _bfView;
    self.callBack = _callBack;
end

--[[

]]
function BatFirePerHero:Start ()
    self:initPanel();
    self:initHeroBaseInfo(); 
    self:initListener();
end

--[[
    
]]
function BatFirePerHero:initPanel ()
    self.heroBG = GetGameObject(self.transform, "BG");
    self.heroSprite = GetGameObject(self.transform, "Sprite");
    self.heroBGUISprt = GetComponent(self.heroBG, "UISprite");
    self.heroSpriteUISprt = GetComponent(self.heroSprite, "UISprite");
    HangObject(self.sltGO, self.gameObject);
    self:showSlt(false);
    ViewUtil.sortLayerOrder(self.sltGO, LayerName.UI);
end

--[[
    添加事件
    return nil
]]
function BatFirePerHero:initListener ()
    UIEventListener.Get(self.gameObject).onClick = function () self:clickHandle(); end;
end

--[[

]]
function BatFirePerHero:clickHandle ()
    local addHero = 0;--0，不解雇；1，解雇
    local fireState = 0;
    
    if (self.sltGO.activeInHierarchy) then
        self:showSlt(false);
    else
        fireState = self.bfView:heroFireState(self.heroData.id);
        if (0 ~= fireState) then
            ViewUtil.showMsg(const_herosInTeam);
            return ;
        end
        self:showSlt(true);
        addHero = 1;
    end

    if (nil ~= self.callBack) then
        self.callBack(self.heroData.id, addHero);
    end
end

--[[
    初始化英雄面板
    return nil
]]
function BatFirePerHero:initHeroBaseInfo ()
    self.heroBGUISprt.spriteName = const_heroBGPre .. HeroDataProxy.getHeroQuality(self.hCfg);
    self.heroSpriteUISprt.spriteName = HeroDataProxy.getHeroAtlasName(self.hCfg);
end

--[[
    控制是否选中解雇的显示
    _isSlt boolean 
    return nil
]]
function BatFirePerHero:showSlt (_isSlt)
    _isSlt = _isSlt or false;
    if (nil ~= self.sltGO) then
        self.sltGO:SetActive(_isSlt);
    end
end

--[[
    当前的删除图标是否显示
    return boolean
]]
function BatFirePerHero:isShowSlt ()
    local isVisible = false;

    if (nil ~= self.sltGO) then
        isVisible = self.sltGO.activeInHierarchy;
    end

    return isVisible;
end
