--批量解雇 一行英雄的显示（5个）
--2016-11-25 10:50:08

local COLNUM = 5;
local const_heroBGPre = "class";
local const_herosInTeam = "阵容中的英雄不能解雇";

BatFireHerosRow = class();


--[[

]]
function BatFireHerosRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

--[[

]]
function BatFireHerosRow:Awake (_go, _fireSlt, _callBack, _ctl)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.fireSlt = _fireSlt;--删除标识
    self.callBack = _callBack;
    self.ctl = _ctl;

    self.herosGOList = List.new();--英雄GO列表 List<GameObject>
    self.herosDataList = List.new();--英雄数据列表 List<{isFire, HeroData, hCfg}>

    self:initPanel();
end

--[[

]]
function BatFireHerosRow:initPanel ()
    local heroTmp = nil;

    for i = 1, COLNUM do
        heroTmp = GetGameObject(self.transform, "Hero_" .. (i - 1));
        self.herosGOList:add(heroTmp);
    end
end

--[[
    _list List<{isFire, HeroData, hCfg}>
]]
function BatFireHerosRow:setData (_list)
    _list = _list or List.new();

    self.herosDataList = _list;

    self:showHeros();
end

--[[

]]
function BatFireHerosRow:showHeros ()
    local isFireTmp, hDataTmp, hCfgTmp, heroTmp = false, nil, nil, nil;
    local len = self.herosDataList.size;
    local heroBGUISprt, heroSpriteUISprt, heroFightNumUILbl = nil, nil, nil;
    local sltTmp = nil;

    if (len > self.herosGOList.size) then
        len = self.herosGOList.size;
    end
    
    for i = 1, len do
        heroTmp = self.herosGOList[i];
        heroTmp:SetActive(true);
        isFireTmp = self.herosDataList[i][1];
        hDataTmp = self.herosDataList[i][2];
        hCfgTmp = self.herosDataList[i][3];
        heroBGUISprt = GetPathComponent(heroTmp.transform, "BG", "UISprite");
        heroSpriteUISprt = GetPathComponent(heroTmp.transform, "Sprite", "UISprite");
        heroFightNumUILbl = GetPathComponent(heroTmp.transform, "FightNum", "UILabel")
        sltTmp = GetGameObject(heroTmp.transform, "HeroFireSlt");
        if (nil == sltTmp) then
            sltTmp = CreateObject(self.fireSlt);
            sltTmp.name = "HeroFireSlt";
            HangObject(sltTmp, heroTmp);
        end
        UIEventListener.Get(heroTmp).onClick = function () self:clickHandle(i); end;
        sltTmp:SetActive(isFireTmp);
        heroBGUISprt.spriteName = const_heroBGPre .. HeroDataProxy.getHeroQuality(hCfgTmp);
        heroSpriteUISprt.spriteName = HeroDataProxy.getHeroAtlasName(hCfgTmp);
        heroFightNumUILbl.text = LogicUtil.getShowNum(HeroDataProxy.getHeroAbility(hDataTmp.heroId, hDataTmp.level, hDataTmp.wiseup, hDataTmp.strengthen))
        GetComponent(heroTmp.transform, "UIButton").normalSprite = const_heroBGPre .. HeroDataProxy.getHeroQuality(hCfgTmp);
    end

    for i = len + 1, COLNUM do
        self.herosGOList[i]:SetActive(false);
    end
end

--[[

]]
function BatFireHerosRow:clickHandle (_idx)
    local addHero = 0;--0，不解雇；1，解雇
    local fireState = 0;
    local heroTmp, sltGOTmp, hIdTmp = nil, nil, nil;
    
    heroTmp = self.herosGOList[_idx];
    hIdTmp = self.herosDataList[_idx][2].id;
    sltGOTmp = GetGameObject(heroTmp.transform, "HeroFireSlt");
    if (sltGOTmp) then
        if (sltGOTmp.activeInHierarchy) then
            sltGOTmp:SetActive(false);
            self.herosDataList[_idx][1] = false;
        else
            fireState = self.ctl.view:heroFireState(hIdTmp);
            if (0 ~= fireState) then
                ViewUtil.showMsg(const_herosInTeam);
                return ;
            end
            sltGOTmp:SetActive(true);
            self.herosDataList[_idx][1] = true;
            addHero = 1;
        end
    end

    if (nil ~= self.callBack) then
        self.callBack(hIdTmp, addHero);
    end
end
