local const_delayTime = 0.1;
local const_lackOfCond = "尚未开启";

ComView = class(BaseView)

 function ComView:ctor()
	self.showShade = false
	self.sumTime = 0
	self.preTime = 0
    self.propPreTime = 0;
end  

function ComView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.curPower = 0
	self:initPanel()
    self:showRedTips();
end

function ComView:OnFocus()
	if ViewUtil.getTopModule() == ModuleName.MAIN then
		self.topBG:SetActive(false)
	else
		self.topBG:SetActive(true)
	end
end

function ComView:Start(data)
	self:initData(data)
end

function ComView:initPanel()
 	self.top = GetPathComponent(self.transform, "Top", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom = GetPathComponent(self.transform, "Bottom", "UIWidget")
	self.bottom:SetAnchor(self.root.transform)
	self.scvObj = GetGameObject(self.transform, "Bottom/Panel1/ScrollView")
 	self.scv = self.scvObj:GetComponent(UIScrollView.GetClassType())
	self.scvPanel = self.scvObj:GetComponent(UIPanel.GetClassType())
	self.gridObj = GetGameObject(self.transform, "Bottom/Panel1/ScrollView/Grid")
	self.message1 = GetGameObject(self.gridObj.transform, "message1")
	self.message2 = GetGameObject(self.gridObj.transform, "message2")
	self.wrap = self.gridObj:GetComponent(UIWrapContent.GetClassType())
	ResetGrid(self.gridObj)
	
 	self.lblPower = GetPathComponent(self.top.transform, "Panel/Grid/powerNum", "UILabel")
 	self.redUp = GetGameObject(self.top.transform, "Panel/Grid/powerNum/Effect/RedUp")
 	self.greenDown = GetGameObject(self.top.transform, "Panel/Grid/powerNum/Effect/GreenDown")
 	self.lblGold = GetPathComponent(self.top.transform, "Panel/Grid/goldNum", "UILabel")
 	self.lblExp = GetPathComponent(self.top.transform, "Panel/Grid/expNum", "UILabel")
 	self.lblGem = GetPathComponent(self.top.transform, "Panel/Grid/gemNum", "UILabel")

	local topPath = "Top/Panel"
 	self.addGem = GetGameObject(self.transform, topPath.."/Grid/gemNum/AddGem")
 	self.addGem:SetActive(false);

    self.topBG = GetGameObject(self.transform, topPath.."/TopBG")

	local centerPath = "Center/Panel"
-- 	self.shade = GetGameObject(self.transform, centerPath.."/BlackScreen")
--	NGUITools.SetActive(self.shade, false)

	local bottomPath = "Bottom/Panel2"
 	self.btn01 = GetGameObject(self.transform, bottomPath.."/Grid/btn01")
 	self.btn02 = GetGameObject(self.transform, bottomPath.."/Grid/btn02")
 	self.btn03 = GetGameObject(self.transform, bottomPath.."/Grid/btn03")
 	self.btn04 = GetGameObject(self.transform, bottomPath.."/Grid/btn04")
 	self.btn05 = GetGameObject(self.transform, bottomPath.."/Grid/btn05")
    self.mailRedIcon = GetGameObject(self.btn05.transform, "RedIcon");
 	self.btn06 = GetGameObject(self.transform, bottomPath.."/Grid/btn06")
	
    local function doClickTop(obj)
		if obj == self.addGem then
--			for i = 1, 5 do
--				plog(FBData.IsPassedGate(10200+i, 1), " Pass = "..10200+i)
--			end
			ViewUtil.goto(ModuleName.PAY);
		end
	end
    local function doClickBottom(obj)
		if PlayerData.guideNotEnd() then
			ViewUtil.closeView(ModuleName.COM)
		end
		if obj == self.btn01 then
			ViewUtil.openView(ModuleName.MAIN)
			-- if GameCfgDataProxy.GetEffectStatus() == AudioConst.effectOn then
			-- 	SimpleAudio.PlayEffect("turn")
			-- end
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
		elseif obj == self.btn02 then
            ViewUtil.goto(ModuleName.FB);
   --          if GameCfgDataProxy.GetEffectStatus() == AudioConst.effectOn then
			-- 	SimpleAudio.PlayEffect("turn")
			-- end
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
		elseif obj == self.btn03 then
            if (FBData.IsPassedGate(FBData.OpenData.SecOpen[1], 1)) then
                local isExsit = ViewManager.isExistView(ModuleName.EXPLORE);
                ViewUtil.goto(ModuleName.EXPLORE, false, function () 
                    if (isExsit) then
                        Facade:sendNotification(MVCConst.EXPLORE_RESETMAPCENTER, {});
                    end
                end);
                
            else
                ViewUtil.showMsg(FBData.OpenData.SecOpen[2]);
            end
           -- if (PlayerData.guideNotEnd()) then
           --     Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
           -- end
--			ViewUtil.goto(ModuleName.SHOP) -- 审核版本
		elseif obj == self.btn04 then
            ViewUtil.goto(ModuleName.PVP)
   --          if GameCfgDataProxy.GetEffectStatus() == AudioConst.effectOn then
			-- 	SimpleAudio.PlayEffect("turn")
			-- end
            if (PlayerData.guideNotEnd()) then
                    Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
                end
--            if (FBData.IsPassedGate(10203, 1)) then
--			    ViewUtil.goto(ModuleName.PVP)
--                if (PlayerData.guideNotEnd()) then
--                    Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
--                end
--            else
--                ViewUtil.showMsg(const_lackOfCond);
--            end
		elseif obj == self.btn05 then
            --修改抽卡界面，抽到多个新英雄时，点击该按钮，HP模块的层被LUCK模块的层覆盖的问题
            HeroDataProxy.newHeroList:clear();
            ViewUtil.closeView(ModuleName.HP);

			ViewUtil.goto(ModuleName.LUCK)
			-- if GameCfgDataProxy.GetEffectStatus() == AudioConst.effectOn then
			-- 	SimpleAudio.PlayEffect("turn")
			-- end

            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
--			ViewUtil.goto(ModuleName.MAIL) -- 审核版本
		elseif obj == self.btn06 then
			ViewUtil.openView(ModuleName.HERO)
			-- if GameCfgDataProxy.GetEffectStatus() == AudioConst.effectOn then
			-- 	SimpleAudio.PlayEffect("turn")
			-- end
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
		end
    end
	-- UIEventListener.Get(self.addGem).onClick = doClickTop
	-- UIEventListener.Get(self.btn01).onClick = doClickBottom
	-- UIEventListener.Get(self.btn02).onClick = doClickBottom
	-- UIEventListener.Get(self.btn03).onClick = doClickBottom
	-- UIEventListener.Get(self.btn04).onClick = doClickBottom
	-- UIEventListener.Get(self.btn05).onClick = doClickBottom
	-- UIEventListener.Get(self.btn06).onClick = doClickBottom
	ViewUtil.AddClickEvent(self.addGem, doClickTop)
	ViewUtil.AddClickEvent(self.btn01, doClickBottom)
	ViewUtil.AddClickEvent(self.btn02, doClickBottom)
	ViewUtil.AddClickEvent(self.btn03, doClickBottom)
	ViewUtil.AddClickEvent(self.btn04, doClickBottom)
	ViewUtil.AddClickEvent(self.btn05, doClickBottom)
	ViewUtil.AddClickEvent(self.btn06, doClickBottom)
end

---- 设置背景阴影
--function ComView:SetShadow(show)
--	NGUITools.SetActive(self.shade, show and true or false)
--end

function ComView:Update()
	-- 挂机
	self.sumTime = Time.timeSinceLevelLoad
	if not self.preTime or self.preTime <= 0 then
		self.preTime = self.sumTime
	end
    if self.propPreTime <= 0 then
        self.propPreTime = self.sumTime;
    end
	local deltaTime = self.sumTime - self.preTime
	if deltaTime > 1 then
		self.preTime = self.sumTime
		local hu = FBData.GetHangUpGate()
		local gold = FBData.GetGateGold(hu.chapterId, hu.hardLevel, hu.houseId)
		local exp = FBData.GetGateExp(hu.chapterId, hu.hardLevel, hu.houseId)
		TeamData.AddGold(gold)
		TeamData.AddExp(exp)
        self.lblGold.text = LogicUtil.getShowNum(TeamData.GetGold())
        self.lblExp.text = LogicUtil.getShowNum(TeamData.GetExp())
	end

    --处理限时道具 2016-11-22 19:56:46 library
    deltaTime = self.sumTime - self.propPreTime;
    if deltaTime > 3 then
        self.propPreTime = self.sumTime;
        PropDataProxy.clearOutOfDateProps();
    end

	-- 广播
	self.scvObj.transform.localPosition = self.scvObj.transform.localPosition + Vector3.New(-100 * Time.deltaTime, 0, 0)
	self.scvPanel.clipOffset = self.scvPanel.clipOffset + Vector2.New(100 * Time.deltaTime, 0)
	self.wrap:WrapContent()
end

function ComView:initData(data)
	self.lblPower.text = LogicUtil.getShowNum(TeamData.GetPower())
	self.curPower = TeamData.GetPower()
	self.lblGold.text = LogicUtil.getShowNum(TeamData.GetGold())
	self.lblExp.text = LogicUtil.getShowNum(TeamData.GetExp())
	self.lblGem.text = TeamData.GetGem()

	self:showGameTip()
end

--[[
    刷新我的货币显示
    _tp number 八位二进制的int值，1，金币；2，经验；4，钻石。八位二进制从低位到高位，依次代表：第一位，金币；第二位，经验，第三位，钻石
    return nil
]]
function ComView:updateMny (_tp)
    _tp = _tp or 1;
    
    if (tonumber(self.lblGem.text) < PlayerData.getMyDiamond()) then
    	Facade:sendNotification(MVCConst.REFRESH_PAY, {})
    end

    if (1 == _tp) then
        self.lblGold.text = LogicUtil.getShowNum(PlayerData.getMyGold());
    elseif (2 == _tp) then
        self.lblExp.text = LogicUtil.getShowNum(PlayerData.getMyExp());
    elseif (4 == _tp) then
        self.lblGem.text =PlayerData.getMyDiamond();
    elseif (7 == _tp) then
        self.lblGold.text = LogicUtil.getShowNum(PlayerData.getMyGold());
        self.lblExp.text = LogicUtil.getShowNum(PlayerData.getMyExp());
        self.lblGem.text = PlayerData.getMyDiamond();
    end

	self.lblPower.text = LogicUtil.getShowNum(TeamData.GetPower())
	--增加战力变动特效 by iorinie
	if TeamData.GetPower() > self.curPower then
		if self.redUp.activeSelf then
			self.redUp:SetActive(false)
		elseif self.greenDown.activeSelf then
			self.greenDown:SetActive(false)
		end
		self.redUp:SetActive(true)
		DelayCall(function() self.redUp:SetActive(false) end, 3)
	elseif TeamData.GetPower() < self.curPower then
		if self.redUp.activeSelf then
			self.redUp:SetActive(false)
		elseif self.greenDown.activeSelf then
			self.greenDown:SetActive(false)
		end
		self.greenDown:SetActive(true)
		DelayCall(function() self.greenDown:SetActive(false) end, 3)
	end
	self.curPower = TeamData.GetPower()
end

--[[
    _callBack Function
--]]
--function ComView:ScreenShadowEvt (_callBack)
--    ViewUtil.AddButtonClickEvent(self.shade, function () 
--        NGUITools.SetActive(self.shade, false);
--        ViewUtil.RemoveButtonClickEvent(self.shade);
--        if (nil ~= _callBack) then
--            _callBack();
--        end
--    end);
--end

--[[
    红点提示的显示
    数据以PlayerData.playerData.status为准
]]
function ComView:showRedTips ()
    -- self.mailRedIcon:SetActive(PlayerData.playerData.status.mail);
    self.mailRedIcon:SetActive(false);
end

--[[
    新手使用，对最下面的按钮的depth重新赋值
]]
function ComView:sortBottomBtnDepth ()
    local tab = {self.btn01, self.btn02, self.btn03, self.btn04, self.btn05, self.btn06};
    local baseDepth = 0;

    for i = 1, #tab do
        if (1 == i) then
            baseDepth = GetPathComponent(tab[i].transform, "Sprite", "UISprite").depth;
        else
            GetPathComponent(tab[i].transform, "Sprite", "UISprite").depth = baseDepth + i - 1;
        end
    end
end

function ComView:showGameTip()
	local broadcastLen = string.len(GameCfgDataProxy.GetBroadcast())
	self.wrap.itemSize = broadcastLen * 10
	GetComponent(self.gridObj.transform, "UIGrid").cellWidth = broadcastLen * 10
	self.message1.transform.localPosition = Vector3.New(-broadcastLen * 5, 0, 0)
	self.message2.transform.localPosition = Vector3.New(broadcastLen * 5, 0, 0)
	GetComponent(self.message1.transform, "UILabel").text = GameCfgDataProxy.GetBroadcast()
	GetComponent(self.message2.transform, "UILabel").text = GameCfgDataProxy.GetBroadcast()
end