--[[
模块名字定义类
]]

ModuleName = {
	ENGINE = "Engine",							-- 引擎
	LOGIN = "Login",							-- 登录
	REG = "Register",							-- 注册
	ENTER = "Enter",							-- 进入游戏
	SR = "SelectRole",							-- 选择角色
	COM = "Com",								-- 通用
	MAIN = "Main",								-- 主城
	FIGHT = "Fight",							-- 战斗
	FB = "FB",									-- 副本
	HERO = "Hero",								-- 布阵
	SPACE = "Space",							-- 时空章
	FC = "FightCamp",							-- 出战
	MH = "MyHero",								-- 我的英雄
	TJ = "HeroGuide",							-- 图鉴
	BF = "BatFire",								-- 批量解雇
	HU = "HeroUpgrade",							-- 英雄升级
	HI = "HeroInherit",							-- 英雄继承
	HP = "HeroProp",							-- 英雄属性
	HC = "HeroChange",							-- 英雄更换
	SC = "SortCond",							-- 筛选排序
	LOAD = "Loading",							-- Loading
	FAIL = "FightFailure",						-- 战斗失败
	WIN = "FightVictory",						-- 战斗胜利
	PVP = "PVP",								-- PVP
    GM = "GM",									-- GM管理
	TR = "Treasure",							-- 宝藏
	LUCK = "Lucky",								-- 幸运抽卡
	AR = "Arena",								-- 竞技场
	WB = "WorldBattle",							-- 大乱斗
	SIGN = "SignIn",							-- 签到
	PROP = "Prop",								-- 背包
	MAIL = "Mail",								-- 邮件
	HEROSTORY = "HeroStory",					-- 英雄传说

	Friend = "Friend",								-- 好友
	FriendNotice = "FriendNotice",					-- 好友通知

	LeagueApply = "LeagueApply",							-- 联盟申请(未加入)
	LeagueJoined = "LeagueJoined",							-- 联盟界面(已加入)
	LeagueBadge = "LeagueBadge",							-- 联盟徽章
	LeagueMember = "LeagueMember",							-- 联盟成员
	LeagueNotice = "LeagueNotice",							-- 联盟通知
	LeagueManager = "LeagueManager",						-- 联盟管理
	LeagueLeaderTransfer = "LeagueLeaderTransfer",			-- 联盟盟主转让
	LeagueWeal = "LeagueWeal",								-- 联盟福利
	LeaguePVP = "LeaguePVP",								-- 联盟军团战
	LeaguePVPPre = "LeaguePVPPre",							-- 联盟军团战预选赛匹配
	LeaguePVPFinal = "LeaguePVPFinal",						-- 联盟军团战决赛
	LeaguePVPReadyFight = "LeaguePVPReadyFight",			-- 联盟军团战军略布置
	LeaguePVPFighting = "LeaguePVPFighting",				-- 联盟军团战战斗移动
	LeaguePVPFightOver = "LeaguePVPFightOver",				-- 联盟军团战结算
	LeaguePVE = "LeaguePVE",								-- 联盟PVE
	LeaguePVEMap = "LeaguePVEMap",							-- 联盟PVE狩猎BOSS
	-- LeaguePVEMap = "LeaguePVEMap",						-- 联盟PVE地图
	-- LeagueRanking = "LeagueRanking",						-- 联盟排名
	-- League14 = "LeaguePVE1",								-- 联盟PVE报名
	-- League15 = "LeaguePVE2",								-- 联盟PVE小BOSS
	-- League16 = "LeaguePVE3",								-- 联盟PVE大BOSS
	-- League17 = "LeaguePVE4",								-- 联盟PVE战斗
	-- League18 = "LeaguePVE5",								-- 联盟PVE结算

	EXPLORE = "Explore",                -- 探险
    SETTING = "Setting",                -- 设置
	ROLE = "Role",						-- 主角
	EQUIP = "RoleEquip",				-- 主角武具
    SHOP = "Shop",                      -- 商城
    GUIDE = "Guide",                    -- 新手引导
    HONOR = "Achievement",              -- 成就
    ACT = "Activity",                   -- 活动
    MONTHCARD = "MonthCard",			-- 月卡
    PAY = "Pay" 						-- 充值
 }
