--ZBS = "F:/Develop/ZeroBraneStudio/ZeroBraneStudio/";
--LuaPath = "F:/XFClient/Assets/Volatile/Lua/"
--package.path = package.path..";./?.lua;"..ZBS.."lualibs/?/?.lua;"..ZBS.."lualibs/?.lua;"..LuaPath.."?.lua;"
--require("mobdebug").start()

require "Define/define"

GameManager = { };

local this = GameManager;
GameManager.localBgVerison = nil;
GameManager.net = NetManager;
GameManager.loader = LoadManager;
GameManager.facade = Facade.GetInstance();
GameManager.loadState = LoadState.notInit;
GameManager.lastState = LoadState.notInit;
GameManager.asset = AssetManager;
GameManager.version = VersionManager;
GameManager.viewMgr = ViewManager
GameManager.progress = 0;
GameManager.devicePlatform = nil;
GameManager.userType = 0;
GameManager.inited = false;
GameManager.lastProgress = 0;
GameManager.state = 1;
GameManager.gameConnected = false;
GameManager.gameConnected = false;
GameManager.pauseCurTime = 0;

function GameManager.Start()
	AssetManager:AddPermanentMoudle(ModuleName.COM) -- 必须常驻
	AssetManager:AddPermanentMoudle(ModuleName.FB)
end

function GameManager.regiesterModuleController()
    ModuleManager.AddCtrl(ModuleName.LOAD, LoadingControler.New())
    ModuleManager.AddCtrl(ModuleName.FIGHT, FightControler.New())
    ModuleManager.AddCtrl(ModuleName.MAIN, MainControler.New())
    ModuleManager.AddCtrl(ModuleName.FB, FBControler.New())
    ModuleManager.AddCtrl(ModuleName.HERO, HeroControler.New())
    ModuleManager.AddCtrl(ModuleName.SPACE, SpaceControler.New())
    ModuleManager.AddCtrl(ModuleName.COM, ComControler.New())
    ModuleManager.AddCtrl(ModuleName.FC, FightCampControler.New())
    ModuleManager.AddCtrl(ModuleName.MH, MyHeroControler.New())
    ModuleManager.AddCtrl(ModuleName.TJ, HeroGuideControler.New())
    ModuleManager.AddCtrl(ModuleName.BF, BatFireControler.New())   
    ModuleManager.AddCtrl(ModuleName.HU, HeroUpgradeControler.New())
    ModuleManager.AddCtrl(ModuleName.HI, HeroInheritControler.New())
    ModuleManager.AddCtrl(ModuleName.HP, HeroPropControler.New())
    ModuleManager.AddCtrl(ModuleName.HC, HeroChangeControler.New())
	ModuleManager.AddCtrl(ModuleName.SC, SortCondControler.New())
    ModuleManager.AddCtrl(ModuleName.FAIL, FightFailureControler.New())
    ModuleManager.AddCtrl(ModuleName.WIN, FightVictoryControler.New())
    ModuleManager.AddCtrl(ModuleName.GM, GMControler.New())
    ModuleManager.AddCtrl(ModuleName.TR, TreasureControler.New())
    ModuleManager.AddCtrl(ModuleName.LUCK, LuckyControler.New())
	ModuleManager.AddCtrl(ModuleName.LOGIN, LoginControler.New())
	ModuleManager.AddCtrl(ModuleName.REG, RegisterControler.New())
	ModuleManager.AddCtrl(ModuleName.ENTER, EnterControler.New())
	ModuleManager.AddCtrl(ModuleName.SR, SelectRoleControler.New())
    ModuleManager.AddCtrl(ModuleName.PVP, PVPControler.New())
    ModuleManager.AddCtrl(ModuleName.AR, ArenaControler.New())
    ModuleManager.AddCtrl(ModuleName.WB, WorldBattleControler.New())
    ModuleManager.AddCtrl(ModuleName.SIGN, SignInControler.New())
    ModuleManager.AddCtrl(ModuleName.PROP, PropControler.New())
    ModuleManager.AddCtrl(ModuleName.MAIL, MailControler.New())
    ModuleManager.AddCtrl(ModuleName.HEROSTORY, HeroStoryControler.New())
    ModuleManager.AddCtrl(ModuleName.Friend, FriendControler.New())
    ModuleManager.AddCtrl(ModuleName.FriendNotice, FriendNoticeControler.New())
    ModuleManager.AddCtrl(ModuleName.LeagueApply, LeagueApplyControler.New())
    ModuleManager.AddCtrl(ModuleName.LeagueJoined, LeagueJoinedControler.New())
    ModuleManager.AddCtrl(ModuleName.LeagueBadge, LeagueBadgeControler.New())
    ModuleManager.AddCtrl(ModuleName.LeagueMember, LeagueMemberControler.New())
    ModuleManager.AddCtrl(ModuleName.LeagueNotice, LeagueNoticeControler.New())
    ModuleManager.AddCtrl(ModuleName.LeagueManager, LeagueManagerControler.New())
    ModuleManager.AddCtrl(ModuleName.LeagueLeaderTransfer, LeagueLeaderTransferControler.New())
    ModuleManager.AddCtrl(ModuleName.LeagueWeal, LeagueWealControler.New())
    ModuleManager.AddCtrl(ModuleName.LeaguePVP, LeaguePVPControler.New())
    -- ModuleManager.AddCtrl(ModuleName.LeagueRanking, LeagueRankingControler.New())
    ModuleManager.AddCtrl(ModuleName.LeaguePVPPre, LeaguePVPPreControler.New())
    ModuleManager.AddCtrl(ModuleName.LeaguePVPFinal, LeaguePVPFinalControler.New())
    ModuleManager.AddCtrl(ModuleName.LeaguePVPReadyFight, LeaguePVPReadyFightControler.New())
    ModuleManager.AddCtrl(ModuleName.LeaguePVPFighting, LeaguePVPFightingControler.New())
    ModuleManager.AddCtrl(ModuleName.LeaguePVPFightOver, LeaguePVPFightOverControler.New())
    ModuleManager.AddCtrl(ModuleName.LeaguePVE, LeaguePVEControler.New())
    ModuleManager.AddCtrl(ModuleName.LeaguePVEMap, LeaguePVEMapControler.New())
    ModuleManager.AddCtrl(ModuleName.EXPLORE, ExploreControler.New())
    ModuleManager.AddCtrl(ModuleName.SETTING, SettingControler.New())
    ModuleManager.AddCtrl(ModuleName.ROLE, RoleControler.New())
    ModuleManager.AddCtrl(ModuleName.EQUIP, RoleEquipControler.New())
    ModuleManager.AddCtrl(ModuleName.SHOP, ShopControler.New())
    ModuleManager.AddCtrl(ModuleName.GUIDE, GuideControler.New())
    ModuleManager.AddCtrl(ModuleName.HONOR, AchievementControler.New())
    ModuleManager.AddCtrl(ModuleName.ACT, ActivityControler.New())
    ModuleManager.AddCtrl(ModuleName.MONTHCARD, MonthCardControler.New())
    ModuleManager.AddCtrl(ModuleName.PAY, PayControler.New())
end

--Mono Lua相关初始换完成，开始Lua内部初始化
function GameManager.OnInitOK(_devicePlatform, _userType)
	if Application.isMobilePlatform then -- UMeng
		GA.StartWithAppKeyAndChannelId("5850c73a1061d25012000a86" , ChannelName[Global.chIndex] or "FTX")
		GA.SetLogEnabled(Global.showLog and true or false)
	end

    devicePlatform = _devicePlatform;

    userType = _userType;
	
	Global.Init()
	GameManager.Init()

    --warn("GameManager.OnInitOK.");
    this.regiesterModuleController();
    
    this.DoSelfInit();
	
	Network.Start()
end

function GameManager.UserType()
    return userType;
end

function GameManager.UserTypeStr()
    return Util.enumIntToString(userType);
end

--ios,windows,android
function GameManager.DevicePlatform()
    return devicePlatform;
end

-- 销毁 --
function GameManager.OnDestroy()
end

function GameManager.responeToUpdateVersion(str)
    if str ~= nil then
        GameDefine.UpdateVersion = str;
    end
    --warn("GM.responeToUpdateVersion----------strLen=" .. (str == nil and -1 or string.len(str)));
end

function GameManager.responeToInitGame(url)
    GameDefine.ResourcesUrl = url;
    
    this.initGame();
end

function GameManager.initGame()
    if not this.inited then
    
        this.inited = true;
       
        this.InitVersion();
    end
end

--[[
-- 初始化版本文件
--]]
function GameManager.InitVersion()
    if not GameDefine.Use_Version then

        this.initGlobal();

        return;
    end
    
    this.version:initVersion(this.LoadedVersion);
end

function GameManager.LoadedVersion()
    --warn("LoadedVersion,net.Connected()=" .. tostring(this.net:Connected(false,1)));

    this.facade:sendNotification(MVCConst.ON_INITED_VERSION, nil, nil);
    
    this.version:loadCom(this.initGlobal);
end

function GameManager.initGlobal()
    --warn("initGlobal--------------begin");
 
    this.setLoadState(LoadState.initGlobal);

    this.setProgress(0.1);

    this.initLang();
     
    this.setProgress(0.2);

    ComDataProxy.InitConfig();

    this.Init();
     
    this.setProgress(0.9);

    GameDefine.GameInited = true;

    this.facade:sendNotification(MVCConst.ASSETS_INITED, nil, nil);

    this.autoLogin();

    --warn("initGlobal--------------end");
end

function GameManager.autoLogin()
 
    if not this.net:Connected(false,1) then
 
        this.net:connet();

    else
        this.net:login(false);
    end
end

function GameManager.initLang()
end

function GameManager.connetErrorCode(code)
    local codes = ComDataProxy.getErrorCode(tostring(code));

    --warn("GM.connetError,code=" .. code .. ",codes=" .. codes);

    this.connetErrorMsg(codes);
end

function GameManager.connetErrorMsg(msg)
    --warn("connetError=========lastState=" .. this.lastState .. ",gm.inited=" .. tostring(this.inited));

--	ViewUtil.openView(ModuleName.MAIN) -- test

--    ModuleManager.GetCtrl(ModuleName.LOGIN).getloginTempCall():gameConnectError(msg);

--    this.changeAccount();
end

function GameManager.disConnect(msg)
	--error("DisConnect = %s", msg)
	Network.isConnected = false
	ViewUtil.CreateLostBoard(0)
end

function GameManager.connectSucceed()
	--plog("[From Lua] connetSucceed")
    this.gameConnected = true
end

function GameManager.reconnectSucceed()
	--plog("[From Lua] reconnetSucceed")
	EnterControler.Login()
end

--返回当前资源的版本,不保证正确,不可作为游戏逻辑
function GameManager.getSourceVersion()
    return PlayerPrefs:GetString("login_source_version");
end

function GameManager.Step()
    this.facade:Step()
    this.net:Step()
    this.version:Step()
    this.loader:Step()
--    this.asset:Step()

--    this.viewMgr.Step()
end

function GameManager.Init()
    this.facade:Init()
    this.net:Init()
    this.asset:Init()
    this.version:Init()
    this.loader:Init()
end

function GameManager.Clear()
    this.facade:Clear()
    this.net:Clear()
    this.asset:Clear()
    this.version:Clear()
    this.loader:Clear()

    GameManager.clear()
    GameSpaceTimer.clear()
    ComDataProxy.clear()

    Global.Reset()
end

function GameManager.clear()
    this.gameConnected = false;

    this.inited = false;

    --this.loadState = LoadState.notInit;

    this.setLoadState(LoadState.notInit);

    this.lastState = LoadState.notInit;
end

function GameManager.DoSelfInit()
	this.PreloadAssets()

    --初始化ui需要用到的文字语言文件
    UILang.init(AssetManager:loadLang("TextString"));

    --游戏运行总控单例对象,不需要注册,常驻程序
    this.viewMgr.init();

    local _gmObj = GameObject.Find("GameManager");
    if not _gmObj:GetComponent("Logger") then
        _gmObj:AddComponent(Logger.GetClassType());
    end
--    if not GameDefine.IsRelease and not _gmObj:GetComponent("ShowFPS") then
--        _gmObj:AddComponent(ShowFPS.GetClassType());
--    end

--    if Global.isRelease then
--        this.initGame();
--    end
end

-- 预加载
function GameManager.PreloadAssets()
    InitActorPrefabs()
	PreloadActorObjects()
	Util.PreloadAssetAsync("UI/FBMain", "UIRoot", function(go) end)
end

--游戏暂停到后台
function GameManager.OnApplicationPause(pause)
--    local ltime = 0
--    if pause then
--        pauseCurTime = GameDefine.serverTime
--    else
--        ltime = tonumber(GameDefine.serverTime - pauseCurTime)
--    end
--    Logger:Info("GM.OnApplicationPause,pause=" .. pause .. ",Global.enterGame=" + Global.enterGame .. ",ltime=" .. ltime);

--    if not pause then
--        if GameDefine.EnterGame then
--            net:checkConnect()
--        end
--    end
end

function GameManager.Update()
    for i = 1, UpdateHelper.updateFunctionList:getSize() do
        UpdateHelper.updateFunctionList[i]();
    end
    this.Step();
    this.checkExit();
end

function GameManager.checkExit()
	if Application.platform == RuntimePlatform.Android and Input.GetKeyDown(KeyCode.Escape) then
		Access.DoExit()
--		if not this.exitObj then
--			local uiRoot = GameObject.Find("UIRoot")
--			this.exitObj = CreateObjectByPath("UI/BoardExit")
--			local shade = ViewUtil.CreateShadeView()
--			HangObject(shade, this.exitObj)
--			HangObject(this.exitObj, uiRoot)
--			ViewUtil.sortLayerOrder(this.exitObj, LayerName.Top)
--			SortUIPanelDepth(this.exitObj, 10000, false)
--			SortUIWidgetDepth(this.exitObj, 10000, false)
--			SetCameraLayer(this.exitObj, CameraLayer.GameTop, true)
--			SetCameraLayer(shade, CameraLayer.GameTop, true)

--			local content = GetPathComponent(this.exitObj.transform, "Panel/Content", "UILabel")
--			local cancel = GetGameObject(this.exitObj.transform, "Panel/Cancel")
--			local confirm = GetGameObject(this.exitObj.transform, "Panel/Confirm")
--			content.text = "你确定要离我而去吗?"

--			local function doClick(obj)
--				if obj == confirm then
--					GameManager.exit()
--				end
--				DestroyObject(this.exitObj)
--				this.exitObj = nil
--			end
--			UIEventListener.Get(cancel).onClick = doClick
--			UIEventListener.Get(confirm).onClick = doClick
--		 end
	 end
end
  
function GameManager.exit()
    --warn("Application.Quit")
    Application.Quit()
end

function GameManager.setLoadState(v) 
    this.loadState = v;

    GameDefine.GameLoadState = v;
end

function GameManager.setProgress(v) 
    progress = v;
end

function GameManager.showEnterReConnects(msg , flg)
--    UIManager.showAlert(msg, function() 
--        if flg then
--            this.changeAccount();
--        else
--            NetManager:doReConnectDelay(2);
--            showLoading();
--        end
--      end  

--     , function() 
--         if flg then
--            this.changeAccount();
--         end
--        end
--     , "重试", nil, nil, nil ,true, nil);
end

function GameManager.showExitAlert(msg) 
--    UIManager.showAlert(msg, function()
--        Application:Quit();
--        end
--     , nil, nil, nil, nil, nil ,true, nil);
end

function GameManager.clearLoading()
    --UIManager.clearLoading();
end    

function GameManager.showLoading(flg)
    --UIManager.clearLoading(flg);
end
