--[[
-- 模块管理类
--]]
 
ModuleManager = {}

local this = ModuleManager

-- 控制器列表
local ctrlList = {}

-- 添加控制器
function ModuleManager.AddCtrl(ctrlName, ctrlObj)
	ctrlList[ctrlName] = ctrlObj
end

-- 获取控制器
function ModuleManager.GetCtrl(ctrlName)
	return ctrlList[ctrlName]
end

-- 移除控制器
function ModuleManager.RemoveCtrl(ctrlName)
	ctrlList[ctrlName] = nil
end

-- 关闭控制器
function ModuleManager.Close()
end
