--带有数量可变的确认框
--2016-8-9 09:22:41 library

CfmNumChgePanel = class();

--[[

]]
function CfmNumChgePanel:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.comCfmPanel = nil;--ComCfmPanel
    self.numChgePanel = nil;--NumChgePanel

    self.showMsg = "";
    self.okFunc = nil;
    self.cancelFunc = nil;
    self.numChgeFunc = nil;
    self.okWords = nil;
    self.cancelWords = nil;

    self.buyNum = 1;
end

--[[
    _okFunc function 用.号调用的方法，如local或者Controler中的方法
    _cancelFunc function 用.号调用的方法，如local或者Controler中的方法
    _numChgeFunc function 接收1个参数 arg[1]，数量
]]
function CfmNumChgePanel:Awake (_showMsg, _okFunc, _cancelFunc, _numChgeFunc, _okWords, _cancelWords)
    self.showMsg = _showMsg;
    self.numChgeFunc = _numChgeFunc;
    self.okWords = _okWords;
    self.cancelWords = _cancelWords;

    self.okFunc = function () 
        self.numChgePanel:OnDestroy(); 
        if (nil ~= _okFunc) then
            _okFunc(self.buyNum);
        end
    end;

    self.cancelFunc = function () 
        self.numChgePanel:OnDestroy();
        if (nil ~= _cancelFunc) then
            _cancelFunc();
        end
    end

    self:initPanel();
end

--[[

]]
function CfmNumChgePanel:initPanel ()
    self.gameObject = CreateObject(Util.LoadPrefab("UI/CfmPanel", AssetBundleInfo.assetBundles));
    self.transform = self.gameObject.transform;

    self:getPanel();
end

--[[

]]
function CfmNumChgePanel:getPanel ()
    self.comCfmPanel = ComCfmPanel.new();

    self.comCfmPanel:Awake(self.gameObject);
    self.comCfmPanel:initInfo(self.showMsg, self.okFunc, self.cancelFunc, self.okWords, self.cancelWords);

    self.numChgePanel = NumChgePanel.new();
    self.numChgePanel:Awake(function (_num) 
        self:setTxt(self.numChgeFunc(_num)); 
        self.buyNum = _num;
    end);

    HangObject(self.numChgePanel.gameObject, self.transform);
    self.numChgePanel.transform.localPosition = Vector3.New(-59, 0, 0);
end

--[[

]]
function CfmNumChgePanel:setTxt (_str)
    self.comCfmPanel:setTxt(_str);
end