--登录时的全服公告
--2016-12-27 19:41:47 iorinie

ComAnnouncePanel = class();

--[[

]]
function ComAnnouncePanel:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.cfmWords = "";
    self.okWords = "";
    self.okFunc = nil;
end

--[[
    _go GameObject
]]
function ComAnnouncePanel:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self:initPanel();
end

--[[

]]
function ComAnnouncePanel:initPanel ()
    self.text = GetGameObject(self.transform, "MainPanel/text");
    self.okBtn = GetGameObject(self.transform, "MainPanel/OkBtn");
    self.okText = GetGameObject(self.okBtn.transform, "Text");
end

--[[
    初始化信息
    _cfmWords string 确认内容
    _okFunc function 确认按钮事件
    _okWords string 确认按钮内容
    return nil
]]
function ComAnnouncePanel:initInfo (_cfmWords, _okFunc, _okWords)
    self.cfmWords = _cfmWords or "";
    self.okFunc = _okFunc;
    self.okWords = _okWords or "";

    self:addInfos();
end

--[[

]]
function ComAnnouncePanel:addInfos ()
    GetComponent(self.text, "UILabel").text = self.cfmWords;
    if ("" ~= self.okWords) then
        GetComponent(self.okText, "UILabel").text = self.okWords;
    end

    ViewUtil.AddButtonClickEvent(self.okBtn, function () 
        if (nil ~= self.okFunc) then
            self.okFunc();
        end
        self:closePanel();
    end, true);
end

--[[
    关闭面板
]]
function ComAnnouncePanel:closePanel ()
    DestroyObject(self.gameObject);
end
