--通用玩家排行条
--2016-10-31 11:40:27 library

local const_rankBG = "rank_";
local const_class = "class";

ComPlayerRankRow = class();

--[[

]]
function ComPlayerRankRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.rankNum = 0;
    self.heroId = 0;
    self.pName = "";
    self.pAbility = "";
    self.cfg = nil;
end

--[[

]]
function ComPlayerRankRow:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.rank = GetGameObject(self.transform, "rank");
    self.hero = GetGameObject(self.transform, "Hero");
    self.playerName = GetGameObject(self.transform, "playerName");
    self.playerAbility = GetGameObject(self.transform, "playerAbility");
end

--[[

]]
function ComPlayerRankRow:setData (_rank, _heroId, _name, _ability)
    self.rankNum = tonumber(_rank);
    self.heroId = _heroId;
    self.pName = _name;
    self.pAbility = _ability;
    self.cfg = HeroDataProxy.getHeroCfgById(self.heroId);
    
    GetPathComponent(self.hero.transform, "BG", "UISprite").spriteName = const_class .. HeroDataProxy.getHeroQuality(self.cfg);
    GetPathComponent(self.hero.transform, "Sprite", "UISprite").spriteName = HeroDataProxy.getHeroAtlasName(self.cfg);
    GetComponent(self.playerName, "UILabel").text = self.pName;
    GetComponent(self.playerAbility, "UILabel").text = self.pAbility .. "";

    GetComponent(self.rank, "UILabel").text = self.rankNum .. "";
    if (self.rankNum < 4) then
        GetComponent(self.rank, "UILabel").enabled = false;
        GetPathComponent(self.rank.transform, "BG", "UISprite").spriteName = const_rankBG .. self.rankNum;
    else
        GetGameObject(self.rank.transform, "BG"):SetActive(false);
    end
end