--探险的常量配置
--2016-7-22 14:42:42 library

ExploreConstant = {
    mapCntSize = nil;
    unitSize = nil;
    muSize = nil;--全地图中地图单元的数量
    mapSize = nil;--全地图
    mapUnitSize = nil;--地图单元
    mapSquSize = nil;--地图单元的单元格
};

local this = ExploreConstant;

this.mapSize = Vector2.New(2480, 3200);
this.mapUnitSize = Vector2.New(160, 160);
this.mapSquSize = Vector2.New(80, 80);

--[[
    地图单元的大小
    return Vector2
]]
function ExploreConstant.getUnitMap ()
    return this.mapUnitSize;
end

--[[

]]
function ExploreConstant.getHoleMap ()
    return this.mapSize;
end

--[[

]]
function ExploreConstant.getMapSqu ()
    return this.mapSquSize;
end

--[[
    每个地图单元中，单元格数量的二维值
    return Vector2
]]
function ExploreConstant.getUnitSize ()
    if (nil == this.unitSize) then
        this.unitSize = Vector2.New(math.ceil(this.mapUnitSize.x / this.mapSquSize.x), math.ceil(this.mapUnitSize.y / this.mapSquSize.y));
    end

    return this.unitSize;
end

--[[
    整张地图的单元格数量的二维值
    return  Vector2
]]
function ExploreConstant.getMapCntSize ()
    if (nil == this.mapCntSize) then
        this.mapCntSize = Vector2.New(math.ceil(this.mapSize.x / this.mapSquSize.x), math.ceil(this.mapSize.y / this.mapSquSize.y));
    end

    return this.mapCntSize;
end

--[[
    整张地图中，地图单元数量的二维值
    return Vector2
]]
function ExploreConstant.getMapUnitSize ()
    if (nil == this.muSize) then
        this.muSize = Vector2.New(math.ceil(this.mapSize.x / this.mapUnitSize.x), math.ceil(this.mapSize.y / this.mapUnitSize.y));
    end

    return this.muSize;
end