--我的补给、支援信息
--2016-7-29 15:09:31 library

local const_addBuJi = "购买 {1} 个补给，需要消耗 {2}";
local const_addZhiYuan = "购买 {1} 个支援，需要消耗 {2}";

ExploreMyPropRow = class();

--[[

]]
function ExploreMyPropRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.buJiInfoWord = nil;
    self.addBuJi = nil;
    self.zhiYuanInfoWord = nil;
    self.addZhiYuan = nil;
end

--[[

]]
function ExploreMyPropRow:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self:initPanel();
    self:addListener();
end

--[[

]]
function ExploreMyPropRow:initPanel ()
    self.buJiInfoWord = GetGameObject(self.transform, "BuJiInfo/BuJiInfoWord");
    self.addBuJi = GetGameObject(self.transform, "BuJiInfo/AddBuJi");
    self.zhiYuanInfoWord = GetGameObject(self.transform, "ZhiYuanInfo/ZhiYuanInfoWord");
    self.addZhiYuan = GetGameObject(self.transform, "ZhiYuanInfo/AddZhiYuan");

    self.zhiYuan = GetGameObject(self.transform, "ZhiYuan");
    self.zhiYuan:SetActive(false);
    self.zhiYuanInfo = GetGameObject(self.transform, "ZhiYuanInfo");
    self.zhiYuanInfo:SetActive(false);
    self.addBuJi:SetActive(false);
end

--[[

]]
function ExploreMyPropRow:addListener ()
    ViewUtil.AddClickEvent(self.addBuJi, function () self:addBuJiFunc(); end)
    ViewUtil.AddClickEvent(self.addZhiYuan, function () self:addZhiYuanFunc(); end)
end


--[[
    _data ArcTeamData
]]
function ExploreMyPropRow:setData (_data)
    self.data = _data;
    self:showBuJi(self.data.supply, self.data.maxSupply);
    self:showZhiYuan(self.data.npcLeveL, self.data.maxNpcLevel);
end

--[[

]]
function ExploreMyPropRow:addBuJiFunc ()
    local cfmWords = string.gsub(const_addBuJi, "{1}", 1);

    ViewUtil.comNumChgePanel();
end

--[[

]]
function ExploreMyPropRow:addZhiYuanFunc ()
    
end

--[[

]]
function ExploreMyPropRow:showBuJi (_curBuJi, _maxBuJi)
    GetComponent(self.buJiInfoWord, "UILabel").text = _curBuJi .. "/" .. _maxBuJi;
end

--[[

]]
function ExploreMyPropRow:showZhiYuan (_curZhiYuan, _maxZhiYuan)
    GetComponent(self.zhiYuanInfoWord, "UILabel").text = _curZhiYuan .. "/" .. _maxZhiYuan;
end
