--探险默认面板 领奖面板
--2016-7-30 11:45:55 library

ExploreRwdPanel = class();

--[[

]]
function ExploreRwdPanel:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.scrollView = nil;
    self.grid = nil;
    self.baseRow = nil;
    self.enterMap = nil;
    
    self.ctl = nil;

    self.arcTeamData = nil;
    self.rowList = List.new();--ExploreGetRwdRow
end

--[[

]]
function ExploreRwdPanel:Awake (_go, _ctl)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.ctl = _ctl;
end

--[[

]]
function ExploreRwdPanel:Update ()
    local row = nil;

    for i = 1, #self.rowList do
        row = self.rowList[i];
        if (nil ~= row) then
            row:Update();
        end
    end
end

--[[

]]
function ExploreRwdPanel:Start ()
    self:initPanel();
    self:initListener();
end

--[[

]]
function ExploreRwdPanel:initPanel ()
    self.scrollView = GetGameObject(self.transform, "ScrollView");
    self.grid = GetGameObject(self.scrollView.transform, "Grid");
    self.baseRow = GetGameObject(self.grid.transform, "RwdRow");
    self.baseRow:SetActive(false);
    
    self.enterMap = GetGameObject(self.transform, "EnterMap");
end

--[[

]]
function ExploreRwdPanel:initListener ()
    ViewUtil.AddClickEvent(self.enterMap, function () self:enterMapSearch(); end)
end

--[[

]]
function ExploreRwdPanel:enterMapSearch ()
    local buf, mapData = nil, Map.new();
    
    mapData:put("mapLvl", self:getMapLvl());
    buf = Network.reqParamEncode(mapData);
    NetManager:SendData(self, buf, ServerID.ExploreSltMap, nil, function (sd) self:enterMapSuccess(sd) end, "", doNthFunc);
end

--[[

]]
function ExploreRwdPanel:getMapLvl ()
    local lvl = 1;

    return lvl;
end

--[[
    进入地图
]]
function ExploreRwdPanel:enterMapSuccess (sd)
    local ammData = nil;

    ammData  = GetProtoTable("ArcMapMainData", sd);
    self.ctl.exploreView:initData(ammData, ExploreDefine.ExploreEtyType.ExploreMapPanel);
end

--[[

]]
function ExploreRwdPanel:setData (_data)
    self.arcTeamData = _data;
    self:drawPanel();
end

--[[

]]
function ExploreRwdPanel:drawPanel ()
    local row, gift, rowLua, myPropRow, luaBhvi = nil, nil, nil, nil, nil;
    local transTmp, posTmp = nil, nil;
    
    if (nil ~= self.arcTeamData.gifts and 0 ~= self.arcTeamData.gifts.propId) then
        row  = CreateObject(self.baseRow);
        row:SetActive(true);
        HangObject(row, self.grid);
        rowLua = ExploreGetRwdRow.new();
        rowLua:Awake(row, self);
        PanelManager:BindPanelScript(rowLua, row, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        rowLua:Start();
        rowLua:setData(self.arcTeamData.gifts);
        self.rowList:add(rowLua);
--        for i = 1, #self.arcTeamData.gifts do
--            gift = self.arcTeamData.gifts[i];
--            row  = CreateObject(self.baseRow);
--            row:SetActive(true);
--            HangObject(row, self.grid);
--            rowLua = ExploreGetRwdRow.new();
--            rowLua:Awake(row, self);
--            PanelManager:BindPanelScript(rowLua, row, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
--            rowLua:Start();
--            rowLua:setData(gift);
--            self.rowList:add(rowLua);
--        end
    end
    
--    luaBhvi = GetComponent(self.bzGO, "LuaBehaviour");
--    if (nil ~= luaBhvi) then
--        myPropRow = luaBhvi.sourceLuaObj;
--        if (nil ~= myPropRow) then
--            myPropRow:showBuJi(self.arcTeamData.supply, self.arcTeamData.maxSupply);
--            myPropRow:showZhiYuan(self.arcTeamData.npcLeveL, self.arcTeamData.maxNpcLevel);
--        end
--    end
end

--[[
    删除一次性领奖的已领奖条目
]]
function ExploreRwdPanel:removeItems ()
    local rwdRow = nil;
    local giftTmp = nil;

    for i = self.rowList:getSize(), 1, -1 do
        rwdRow = self.rowList[i];
        if (rwdRow.isRemove) then
            self.rowList:removeAt(i);
            --数据删除
            for j = #self.arcTeamData.gifts, 1, -1 do
                giftTmp = self.arcTeamData.gifts[i];
                if (rwdRow.gift.propId == giftTmp.propId) then
                    table.remove(self.arcTeamData.gifts, j);
                    break ;
                end
            end
        end
    end
end