--[[
-- Desc: 
-- Author: kenny
-- Date: 2016
--]]
ScaleActorAction = class(BaseAction)

function ScaleActorAction:ctor()
end

function ScaleActorAction:onBegin()
	self.super.onBegin(self)
	self:doAction()
end

function ScaleActorAction:onEnd()
	self.super.onEnd(self)
end

function ScaleActorAction:doAction()
    self.super.doAction(self)
	
	local targets = self:getActors()
	if targets ~= nil then
		for i = 1 , targets.size do
			local target = targets[i]
			if target.getActorRender then
				local render = target:getActorRender()
				self:scaleObjectSize(render)
			end
		end
	end
end
