
FightFailureView = class(BaseView)

 function FightFailureView:ctor()
	self.shadeOpacity = true
end  

function FightFailureView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
	SimpleAudio.StopMusic(doNthFunc)
	SimpleAudio.PlayEffect("failure")
end

function FightFailureView:Start(data)
	self:initData(data)
end

function FightFailureView:OnFocus()
	if Application.isMobilePlatform then -- UMeng
		GA.FailLevel(FBData.GetCurGateTitle())
	end
	
    local function doClick(obj)
		ViewUtil.closeAllViews()

		SimpleAudio.PlayMusic("main")
		AudioConst.SetBgmName("main")

		ViewUtil.openLastView(function () 
            --10105֮ǰFBʧ2Σ
            if (not FBData.IsPassedGate(10105, 1)) then
                local failCnt = SimpleCache.getCacheVal(SimpleCache.simpleCacheFBPkFail, 2);

                if (2 >= failCnt) then
                    ViewUtil.showEasyGuide(ConstantNames.EasyGuide_FBPKFail);
                end
            end
            if (ModuleName.LeaguePVPFighting == ViewManager.lastModule) then
				Network.ReqLeaguePVPJoin()
			end
        end)
        
        if (PlayerData.guideNotEnd()) then
	        Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
        end
    end
	local shade = GetGameObject(self.transform, "ShadeView")
	if shade ~= nil then 
		self.shade = GetGameObject(shade.transform, "Panel/Collider")
		if self.shade ~= nil then
			-- UIEventListener.Get(self.shade).onClick = doClick
			ViewUtil.AddClickEvent(self.shade, doClick)
		end
	end
end

function FightFailureView:initPanel()
    --10105֮ǰFBʧ2Σ
    if (not FBData.IsPassedGate(10105, 1)) then
        local failCnt = SimpleCache.getCacheVal(SimpleCache.simpleCacheFBPkFail, 2);
        
        failCnt = failCnt + 1;
        SimpleCache.setCache(SimpleCache.simpleCacheFBPkFail, failCnt, 2);
    end
end

function FightFailureView:initData(data)
	if IsEmpty(data) then return end
end
