--[[
-- ֪ͨ
--]]
require "Game/Friend/View/FriendNoticeView"
 
FriendNoticeControler = {}

local this = FriendNoticeControler

function FriendNoticeControler.New()
	return this
end

function FriendNoticeControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = FriendNoticeView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	this.request()
end

function FriendNoticeControler.Awake()
end

function FriendNoticeControler.Start()
end

function FriendNoticeControler.Update()
end

function FriendNoticeControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function FriendNoticeControler.initListener()
end

function FriendNoticeControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function FriendNoticeControler.handleNotification(notification)
end

function FriendNoticeControler.request()
	Network.SendMoData(ServerID.FriendNotice, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("FriendNotifyMainData", session)
		this.accept(mo)
	end, {})
end

function FriendNoticeControler.accept(data)
	ViewUtil.initData(this, data)
end
