--好友英雄详情
--2016-11-22 00:00:00 iorinie

--拖动时背景一起动（可做）

FriendHeroInfoView = class(BaseView)

local teamId = nil

function FriendHeroInfoView:ctor()
end

function FriendHeroInfoView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.fhimain = nil

	self:initPanel()
end

function FriendHeroInfoView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")

	local topPath = "Mode/Top/Panel"
	local centerPath = "Mode/Center/Panel"
	local bottomPath = "Mode/Bottom/Panel"

    local btnClose = GetGameObject(self.transform, bottomPath.."/BtnClose")
    local function doClick(obj)
        if obj == btnClose then
            DestroyObject(self.gameObject)
        end
    end
    ViewUtil.AddClickEvent(btnClose, doClick)
end

function FriendHeroInfoView:setTeamId(_sd)
	teamId = _sd
end

function FriendHeroInfoView:request ()
    local mapData, buf = nil, nil

    mapData = Map.new();
    mapData:put("teamId", teamId);
    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.FriendInfo, nil, function (sd) self:setData(sd); end, nil, doNthFunc);
end

function FriendHeroInfoView:setData (_sd)
    local heroeIds = nil;
    local heroes = {}

    local gridPath = nil
    local gridObj = nil

    local positionX = -195
    local positionY = 160
    local rowMax = 5
    local index = 1

    self.fhimain = GetProtoTable("TeamInfoData", _sd)
    heroeIds = StrSplit(self.fhimain.heroIds, ",")

    gridPath = "Mode/Center/Panel/ScrollViewBG/ScrollView/Panel"
  	gridObj = GetGameObject(self.transform, gridPath.."/Grid")

    local shadow = GetGameObject(gridObj.transform, "Shadow")
    -- local heroShadow = nil

    for i = 1, math.modf(#heroeIds/rowMax + 1) do
        for j = 1, rowMax do
            if heroeIds[index] ~= nil then
                heroes[index] = ViewUtil.CreateFriendHeroes(heroeIds[index], gridObj)
                heroes[index].transform.localPosition = Vector3.New(positionX, positionY, 0)
                heroes[index].transform.localScale = Vector3.New(0.8, 0.8, 0)
                GetPathComponent(heroes[index].transform, "", "BoxCollider2D").enabled = false
                GetGameObject(heroes[index].transform, "BG"):SetActive(false)

                local heroShadow = CreateObject(shadow)
                heroShadow:SetActive(true)
                HangObject(heroShadow, heroes[index])
                heroShadow.transform.localPosition = Vector3.New(0, -35, 0)
                GetComponent(heroShadow.transform, "UI2DSprite").depth = GetPathComponent(heroes[index].transform, "Sprite", "UISprite").depth - 1

                positionX = positionX + 90
                index = index + 1
            end
        end
        
        local oushu = nil
        oushu = math.mod(i, 2)
        if tonumber(oushu) ~= 1 then
            positionX = -195
        else
            positionX = -160
        end
        positionY = positionY - 90
    end
    -- ResetGrid(gridObj)
    local topPath = "Mode/Top/Panel"
    local friendNameLabel = GetPathComponent(self.transform, topPath.."/FriendName", "UILabel")
    friendNameLabel.text = self.fhimain.name

    ablilty = self.fhimain.ability

    local bottomPath = "Mode/Bottom/Panel"
    local prop = {}
    local propLabel = {}

    for i = 1, 5 do
        prop[i] = GetGameObject(self.transform, bottomPath.."/propBG/Prop"..i)
        propLabel[i] = GetPathComponent(prop[i].transform, "", "UILabel")
    end

    propLabel[1].text = ""..ablilty.xg
    propLabel[2].text = ""..ablilty.fy
    propLabel[3].text = ""..ablilty.sb
    propLabel[4].text = ""..ablilty.wz
    propLabel[5].text = ""..LogicUtil.getShowNum(ablilty.power)
end