--新手引导的详细步骤
--配置时，每一个bStep必须配置一个sStep为0的步骤
--2016-8-15 10:25:22 library

require "Game/Guide/Logic/GuideMouseGuideStep"
require "Game/Guide/Logic/GuideTimeShowStep"
require "Game/Guide/Logic/GuideWordStep"

GuideStep = {
    stepList = List.new();
}

local this = GuideStep;

do
    this.stepList:add(GuideWordStep.new(10, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_0, 0, 1));
    this.stepList:add(GuideWordStep.new(10, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_1, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 2, GuideConst.GuideType.Player, GuideConst.GuideWordInfo.const_2, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 3, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_3, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 4, GuideConst.GuideType.Player, GuideConst.GuideWordInfo.const_4, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 5, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_5, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 6, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_6, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 7, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_7, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 8, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_8, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 9, GuideConst.GuideType.Player, GuideConst.GuideWordInfo.const_9, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 10, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_10, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 11, GuideConst.GuideType.Player, GuideConst.GuideWordInfo.const_11, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 12, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_12, 0, 0));
    this.stepList:add(GuideWordStep.new(10, 13, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_13, 0, 0));
    this.stepList:add(GuideMouseGuideStep.new(20, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_14, 0, 0, ModuleName.MAIN));
    this.stepList:add(GuideWordStep.new(20, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_15, 0, 1));
    this.stepList:add(GuideWordStep.new(20, 2, GuideConst.GuideType.Player, GuideConst.GuideWordInfo.const_16, 0, 0));
    this.stepList:add(GuideMouseGuideStep.new(30, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_17, 0, 0, ModuleName.FB));
    this.stepList:add(GuideTimeShowStep.new(31, 0, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_18_0, GuideConst.GuideWordInfo.const_18_1, 0, 1, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(40, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_20, 0, 0, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(40, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_22, 0, 2, ModuleName.FB));
    this.stepList:add(GuideWordStep.new(60, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_25, 0, 1));
    this.stepList:add(GuideWordStep.new(61, 0, GuideConst.GuideType.Player, GuideConst.GuideWordInfo.const_26, 0, 1));
    this.stepList:add(GuideWordStep.new(61, 2, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_27, 0, 1));
    this.stepList:add(GuideTimeShowStep.new(70, 0, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_30_0, GuideConst.GuideWordInfo.const_30_1, 0, 0, ModuleName.COM));
    this.stepList:add(GuideWordStep.new(70, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_32, 0, 1));
    this.stepList:add(GuideTimeShowStep.new(80, 0, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_33_0, GuideConst.GuideWordInfo.const_33_1, 0, 0, ModuleName.FB));
    this.stepList:add(GuideWordStep.new(80, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_35, 0, 1));
    this.stepList:add(GuideWordStep.new(80, 2, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_36, 0, 1));
    this.stepList:add(GuideWordStep.new(80, 3, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_37, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(90, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_38, 0, 0, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(90, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_39, 0, 0, ModuleName.HU));
    this.stepList:add(GuideMouseGuideStep.new(91, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_39, 0, 0, ModuleName.HU));
    this.stepList:add(GuideMouseGuideStep.new(92, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_39, 0, 0, ModuleName.HU));
    this.stepList:add(GuideMouseGuideStep.new(93, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_39, 0, 0, ModuleName.HU));
    this.stepList:add(GuideWordStep.new(93, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_40, 0, 0));
    this.stepList:add(GuideMouseGuideStep.new(93, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_41, 0, 0, ModuleName.HU));
    this.stepList:add(GuideMouseGuideStep.new(100, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_42, 0, 0, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(102, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_43_1, 0, 1, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(102, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_46, 0, 2, ModuleName.FB));
    this.stepList:add(GuideWordStep.new(103, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_49, 0, 0));
    this.stepList:add(GuideWordStep.new(103, 1, GuideConst.GuideType.Player, GuideConst.GuideWordInfo.const_50, 0, 1));
    this.stepList:add(GuideWordStep.new(103, 2, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_55, 0, 0));
    this.stepList:add(GuideMouseGuideStep.new(110, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_56, 0, 0, ModuleName.COM));
    this.stepList:add(GuideTimeShowStep.new(120, 0, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_58_0, GuideConst.GuideWordInfo.const_58_1, 0, 0, ModuleName.COM));
    this.stepList:add(GuideMouseGuideStep.new(130, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_59, 0, 0, ModuleName.LUCK));
    this.stepList:add(GuideMouseGuideStep.new(130, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_60, 0, 0));
    this.stepList:add(GuideMouseGuideStep.new(130, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_61, 0, 1));
    this.stepList:add(GuideWordStep.new(140, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_62, 0, 1));
    this.stepList:add(GuideTimeShowStep.new(141, 0, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_63_0, GuideConst.GuideWordInfo.const_63_1, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(142, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_64, 0, 0, ModuleName.LUCK));
    this.stepList:add(GuideMouseGuideStep.new(142, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_65, 0, 0, ModuleName.LUCK));
    this.stepList:add(GuideMouseGuideStep.new(142, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_66, 0, 0));
    this.stepList:add(GuideMouseGuideStep.new(142, 3, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_67, 0, 1));
    this.stepList:add(GuideWordStep.new(160, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_68, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(170, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_69, 0, 0, ModuleName.COM));
    this.stepList:add(GuideMouseGuideStep.new(170, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_70, 0, 0, ModuleName.HERO));
    this.stepList:add(GuideMouseGuideStep.new(170, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_71, 0, 0, ModuleName.FC));
    this.stepList:add(GuideMouseGuideStep.new(170, 3, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_72, 0, 0, ModuleName.FC));
    this.stepList:add(GuideMouseGuideStep.new(170, 4, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_73, 0, 2));
    this.stepList:add(GuideMouseGuideStep.new(180, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_74, 0, 0, ModuleName.FC));
    this.stepList:add(GuideMouseGuideStep.new(180, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_75, 0, 0));
    this.stepList:add(GuideMouseGuideStep.new(210, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_76, 0, 1, ModuleName.FC));
    this.stepList:add(GuideWordStep.new(220, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_77, 0, 1));
    this.stepList:add(GuideWordStep.new(220, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_78, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(220, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_79, 1, 1, ModuleName.COM));--暂停，1-3关卡后继续
    this.stepList:add(GuideMouseGuideStep.new(230, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_42, 0, 0, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(231, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_43_1, 0, 0, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(231, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_46, 0, 2, ModuleName.FB));
    this.stepList:add(GuideWordStep.new(240, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_81, 0, 1, ModuleName.FB));
    this.stepList:add(GuideWordStep.new(240, 2, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_82, 0, 1));
    this.stepList:add(GuideWordStep.new(240, 3, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_83, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(250, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_84, 0, 0, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(250, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_85, 0, 0, ModuleName.FB));
    this.stepList:add(GuideWordStep.new(260, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_86, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(260, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_87, 0, 0, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(270, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_88, 0, 0, ModuleName.PROP));
    this.stepList:add(GuideWordStep.new(270, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_89, 0, 0));
    this.stepList:add(GuideTimeShowStep.new(270, 2, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_90_0, GuideConst.GuideWordInfo.const_90_1, 0, 1, ModuleName.PROP));
    -- this.stepList:add(GuideMouseGuideStep.new(270, 3, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_92, 0, 0, ModuleName.PROP));
    -- this.stepList:add(GuideMouseGuideStep.new(270, 4, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_94, 0, 1, ModuleName.HP));
    this.stepList:add(GuideMouseGuideStep.new(270, 5, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_95, 0, 1, ModuleName.PROP));
    this.stepList:add(GuideWordStep.new(300, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_96, 0, 1, ModuleName.FB));
    this.stepList:add(GuideTimeShowStep.new(301, 0, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_97_0, GuideConst.GuideWordInfo.const_97_1, 0, 1, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(310, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_99, 0, 0, ModuleName.FB));
    this.stepList:add(GuideWordStep.new(310, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_100, 0, 1, ModuleName.FB));
    this.stepList:add(GuideMouseGuideStep.new(310, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_101, 1, 1, ModuleName.SPACE));--暂停，1-5关卡后继续
    this.stepList:add(GuideWordStep.new(330, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_103, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(330, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_104, 0, 0, ModuleName.COM));
    this.stepList:add(GuideMouseGuideStep.new(350, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_105, 0, 0, ModuleName.MAIN));
    this.stepList:add(GuideWordStep.new(350, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_106, 0, 0));
    this.stepList:add(GuideMouseGuideStep.new(350, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_107, 0, 0, ModuleName.HONOR));
    this.stepList:add(GuideWordStep.new(360, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_108, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(360, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_110, 0, 0, ModuleName.HONOR));
    this.stepList:add(GuideMouseGuideStep.new(370, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_111, 0, 0, ModuleName.MAIN));
    this.stepList:add(GuideTimeShowStep.new(370, 1, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_112_0, GuideConst.GuideWordInfo.const_112_1, 0, 0, ModuleName.ROLE));
    this.stepList:add(GuideTimeShowStep.new(370, 2, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_113_0, GuideConst.GuideWordInfo.const_113_1, 0, 0, ModuleName.ROLE));
    this.stepList:add(GuideWordStep.new(380, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_114, 0, 1));
    this.stepList:add(GuideWordStep.new(381, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_115, 1, 1));--暂停，2-2关卡后继续
    this.stepList:add(GuideWordStep.new(390, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_116, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(400, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_117, 0, 0, ModuleName.COM));
     this.stepList:add(GuideTimeShowStep.new(409, 0, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_119, GuideConst.GuideWordInfo.const_118, 0, 1, ModuleName.EXPLORE));
    this.stepList:add(GuideMouseGuideStep.new(410, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_121, 0, 0, ModuleName.EXPLORE));
    this.stepList:add(GuideWordStep.new(410, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_123, 0, 1, ModuleName.EXPLORE));
    this.stepList:add(GuideMouseGuideStep.new(410, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_122, 0, 1, ModuleName.EXPLORE));
    this.stepList:add(GuideTimeShowStep.new(411, 0, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_125, GuideConst.GuideWordInfo.const_124, 0, 1, ModuleName.EXPLORE));
     this.stepList:add(GuideWordStep.new(412, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_129, 0, 1, ModuleName.EXPLORE));
     this.stepList:add(GuideWordStep.new(412, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_130, 0, 0, ModuleName.EXPLORE));
     this.stepList:add(GuideWordStep.new(412, 2, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_131, 0, 0, ModuleName.EXPLORE));
    this.stepList:add(GuideMouseGuideStep.new(420, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_135, 0, 0, ModuleName.COM));
    this.stepList:add(GuideMouseGuideStep.new(420, 1, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_136, 0, 0, ModuleName.HERO));
    this.stepList:add(GuideMouseGuideStep.new(420, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_137, 0, 0, ModuleName.HU));
    this.stepList:add(GuideMouseGuideStep.new(420, 3, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_138, 0, 0, ModuleName.HU));
    this.stepList:add(GuideTimeShowStep.new(420, 4, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_140, GuideConst.GuideWordInfo.const_139_1, 0, 0, ModuleName.HU));
    this.stepList:add(GuideMouseGuideStep.new(420, 5, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_141, 0, 0, ModuleName.HU));
    this.stepList:add(GuideMouseGuideStep.new(440, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_142, 0, 1, ModuleName.HU));
    this.stepList:add(GuideWordStep.new(441, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_143, 1, 1));--暂停，2-5关卡后继续
    this.stepList:add(GuideMouseGuideStep.new(450, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_144, 0, 0, ModuleName.COM));
    this.stepList:add(GuideMouseGuideStep.new(460, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_145, 0, 0, ModuleName.PVP));
    this.stepList:add(GuideWordStep.new(470, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_146, 0, 1));
    this.stepList:add(GuideWordStep.new(470, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_147, 0, 1));
    this.stepList:add(GuideTimeShowStep.new(480, 0, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_148_0, GuideConst.GuideWordInfo.const_148_1, 0, 0, ModuleName.AR));
    this.stepList:add(GuideMouseGuideStep.new(480, 2, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_150, 0, 2, ModuleName.AR));
    this.stepList:add(GuideWordStep.new(480, 3, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_151, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(481, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_152, 0, 0, ModuleName.AR));
    this.stepList:add(GuideWordStep.new(481, 6, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_153, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(481, 7, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_152, 0, 0, ModuleName.AR));
    this.stepList:add(GuideMouseGuideStep.new(490, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_155, 0, 0, ModuleName.AR));
    this.stepList:add(GuideTimeShowStep.new(490, 1, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_156_0, GuideConst.GuideWordInfo.const_156_1, 0, 1, ModuleName.AR));
    this.stepList:add(GuideTimeShowStep.new(490, 2, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_158_0, GuideConst.GuideWordInfo.const_158_1, 0, 1, ModuleName.AR));
    this.stepList:add(GuideMouseGuideStep.new(490, 3, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_160, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(490, 4, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_160_0, 1, 1));--暂停，3-5关卡后继续
    this.stepList:add(GuideMouseGuideStep.new(500, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_161, 0, 0, ModuleName.COM));
    this.stepList:add(GuideMouseGuideStep.new(510, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_162, 0, 0, ModuleName.PVP));
    this.stepList:add(GuideWordStep.new(520, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_163, 0, 1));
    this.stepList:add(GuideWordStep.new(520, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_164, 0, 1));
    this.stepList:add(GuideTimeShowStep.new(520, 2, GuideConst.GuideType.TimeShow, 0, GuideConst.GuideWordInfo.const_165_0, GuideConst.GuideWordInfo.const_165_1, 0, 0, ModuleName.WB));
    this.stepList:add(GuideMouseGuideStep.new(520, 3, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_166, 0, 0, ModuleName.WB));
--    this.stepList:add(GuideMouseGuideStep.new(520, 4, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_166, 0, 0, ModuleName.WB));
    this.stepList:add(GuideMouseGuideStep.new(520, 4, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_166, 0, 0, ModuleName.WB));
    this.stepList:add(GuideWordStep.new(520, 5, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_167, 0, 1));
    this.stepList:add(GuideMouseGuideStep.new(521, 0, GuideConst.GuideType.MouseGuide, GuideConst.GuideWordInfo.const_169, 0, 2, ModuleName.WB));
    this.stepList:add(GuideWordStep.new(530, 0, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_170, 0, 1));
    this.stepList:add(GuideWordStep.new(530, 1, GuideConst.GuideType.NPC, GuideConst.GuideWordInfo.const_171, 2, 1));
end

--[[

]]
function GuideStep.getFinalGuideStep ()
    local maxStep = 0;

    maxStep = this.stepList[this.stepList:getSize()].bStep;

    return maxStep;
end

function GuideStep.getNextTab (_curBStep, _curSStep)
    local curTab, nextTab, idx = nil, nil, -1;
    local curSStep = nil;

    if (-1 == _curSStep) then
        curSStep = 0;
    else
        curSStep = _curSStep;
    end
    
    if (0 ~= _curBStep) then
        for i = 1, this.stepList:getSize() do
            preTab = this.stepList[i - 1];
            curTab = this.stepList[i];

            if (nil == preTab) then
                preTab = curTab;
            end
            
            if (
                curTab.bStep == _curBStep and curTab.sStep == curSStep
            ) then
                idx = i;
                break;
            elseif (curTab.bStep > _curBStep and preTab.bStep < _curBStep) then
                _curSStep = -1;
                -- curSStep = -1
                idx = i - 1;
                break ;
            end
        end
    else
        idx = 0;
    end
    
    if (-1 ~= idx and idx ~= this.stepList:getSize()) then
        idx = idx + 1;
        if (-1 ~= _curSStep) then
        -- if (-1 ~= curSStep) then
            nextTab = {idx, this.stepList[idx]};
        else
            for i = idx , this.stepList:getSize() do
                curTab = this.stepList[i];
                if (curTab.bStep > _curBStep) then
                    nextTab = {i, curTab};
                    break ;
                end
            end
        end
    end
    
    return nextTab;
end