--奖励面板
--2016-7-16 14:28:07 library

HeroStoryRwd = class()

--[[

]]
function HeroStoryRwd:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.closeBtn = nil;
    self.propsData = nil;--道具数据信息
    self.propGOList = List.new();
    self.propLogicList = List.new();
end

--[[

]]
function HeroStoryRwd:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.closeBtn = GetGameObject(self.transform, "CloseBtn");
    self.sv = GetGameObject(self.transform, "ScrollView");
    self.grid = GetGameObject(self.sv.transform, "grid");
    self.basePItem = GetGameObject(self.transform, "ScrollView/PropItemBase");

    ViewUtil.AddButtonClickEvent(self.closeBtn, function () self:hidePane(); end, true);
end

--[[
    
]]
function HeroStoryRwd:initData (_propsData)
    self.propsData = _propsData;
end

--[[
    显示奖励
]]
function HeroStoryRwd:showRwds ()
    local pData, pGO, propShowItem, pdLen, pGOLen = nil, nil, nil, #self.propsData, self.propGOList.size;

    for i = 1, #self.propsData do
        pData = self.propsData[i];

        if (i > pGOLen) then
            pGO = CreateObject(self.basePItem);
            HangObject(pGO, self.grid);
            propShowItem = PropShowItem.new();
            propShowItem:Awake(pGO, pData[1], pData[2]);
            propShowItem:Start();
            self.propGOList:add(pGO);
            self.propLogicList:add(propShowItem);
        else
            pGO = self.propGOList[i];
            propShowItem = self.propLogicList[i];
        end

        pGO:SetActive(true);
        propShowItem:setData(pData[1], pData[2]);
    end

    if (pdLen < pGOLen) then
        for i = pdLen + 1, pGOLen do
            pGO = self.propGOList[i];
            pGO:SetActive(false);
        end
    end

    ResetGrid(self.grid);
    ResetScrollView(self.sv);
    ViewUtil.sortLayerOrder(self.sv, LayerName.UI);
end

--[[

]]
function HeroStoryRwd:hidePane ()
    self.gameObject:SetActive(false);
end
