--英雄升级条目
--2016-6-23 15:39:05 library

local const_lvlupType = "experience";
local const_wakeType = "gold";
local const_lvlupBG = "btnSuperYellow";
local const_wakeBG = "btnSuperGreen";
local const_wake = "觉醒";
local const_lvlup = "升级";
local const_lackOfExp = "经验不足";
local const_lackOfGold = "金币不足";
local const_lvlupSuccess = "升级成功";
local const_wiseupSuccess = "觉醒成功";

local const_heroQuaPre = "class";

HULvlUpRow = class();

function HULvlUpRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;
    
    self.hData = nil;--HeroData
    self.heroCfg = nil;--table

    self.btn = nil;--GameObject
    self.heroSmall = nil;--GameObject
    self.hrSmlUISprt = nil;--UISprite
    self.hrSmlSprt = nil;--GameObject
    self.hrSmlSprtUISprt = nil;--UISprite
    self.rowName = nil;--GameObject
    self.rowNameUILbl = nil;--UILabel
    self.lvlUILbl = nil;--UILabel
    self.fightValueUILbl = nil;--UILabel
    self.bsAblyUILbl = nil;--UILabel
    self.bsExpUILabl = nil;--UILabel

    -- self.showBtnLabel = nil;
end

function HULvlUpRow:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

end

function HULvlUpRow:initData (_hData)
    self.hData = _hData;

    self.heroCfg = HeroDataProxy.getHeroCfgById(self.hData.heroId);
    
    self:initPanel();
end

function HULvlUpRow:initPanel ()
    self.btn = GetGameObject(self.transform, "Btn").gameObject;
    self.btnSprite = GetGameObject(self.btn.transform, "Sprite");
    self.btnPriceType = GetGameObject(self.btnSprite.transform, "priceType");
    self.inten2WiseEff = GetGameObject(self.btnSprite.transform, "Inten2WiseEff") --升级变为觉醒的特效 by iorinie
    self.wiseUpEff = GetGameObject(self.transform, "WiseUpEff") --觉醒成功的特效 by iorinie
    self.heroSmall = GetGameObject(self.transform, "HeroSmall").gameObject;
    self.hrSmlUISprt = GetComponent(self.heroSmall, "UISprite");
    self.hrSmlSprt = GetGameObject(self.heroSmall.transform, "Sprite").gameObject;
    self.hrSmlSprtUISprt = GetComponent(self.hrSmlSprt, "UISprite");
    self.rowName = GetGameObject(self.transform, "Name").gameObject;
    self.rowNameUILbl = GetComponent(self.rowName, "UILabel");
    self.lvlUILbl = GetPathComponent(self.transform, "Lvl", "UILabel");
    self.fightValueUILbl = GetPathComponent(self.transform, "FightValue", "UILabel");
    self.bsAblyUILbl = GetPathComponent(self.transform, "Btn/Sprite/Label", "UILabel");
    self.bsExpUILabl = GetPathComponent(self.transform, "Btn/Sprite/LabelExp", "UILabel");
    -- self.showBtnLabel = GetGameObject(self.transform, "Btn/Sprite/BtnLabel");
    self.upgrade = GetPathComponent(self.transform, "Btn/Sprite/Upgrade", "UISprite")
    self.wakeLvl = GetPathComponent(self.transform, "wakeLvl", "UILabel");
--	self.iconUpgrade = GetGameObject(self.transform, "Btn/Sprite/Upgrade")
--	self.iconWakeup = GetGameObject(self.transform, "Btn/Sprite/Wakeup")
    self.btnDirUp = GetGameObject(self.transform, "BtnDirUp")
    -- self.btnDirUpSpr = GetGameObject(self.btnDirUp.transform, "Sprite")
    -- self.btnDirUpAblyUILbl = GetPathComponent(self.btnDirUpSpr.transform, "Label", "UILabel");
    -- self.btnDirUpExpUILabl = GetPathComponent(self.btnDirUpSpr.transform, "LabelExp", "UILabel");
    -- self.showBtnDirUpLabel = GetPathComponent(self.btnDirUpSpr.transform, "BtnLabel", "UILabel");
    
    self.hrSmlUISprt.spriteName = const_heroQuaPre .. HeroDataProxy.getHeroQuality(self.heroCfg);
    self.hrSmlSprtUISprt.spriteName = HeroDataProxy.getHeroAtlasName(self.heroCfg);

    if (1 ~= self.hData.heroId and 2 ~= self.hData.heroId) then
        self.rowNameUILbl.text = HeroDataProxy.getHeroName(self.heroCfg);
    else
        self.rowNameUILbl.text = PlayerData.playerData.team.teamName;
    end
    
    self:changeRowShow();
end

function HULvlUpRow:Start ()
	-- UIEventListener.Get(self.btn).onClick = function () self:doClick(); end
    ViewUtil.AddClickEvent(self.btn, function () self:doClick(); end)
end

function HULvlUpRow:doClick ()
	local eff, effName, time, curExp, curMny, curOwn = nil, nil, 0, PlayerData.getMyExp(), PlayerData.getMyGold(), 0;
    local tp = 0;
    local cost = 0;
    local msgErr, msgSuc = "", "";
    local sID = 0;
    local curWiseVal, nextWiseVal = self.hData.wiseup, HeroDataProxy.getHeroWiseByLvl(self.hData.level + 1);
    local newLvl = 0;
    
    if (-1 == nextWiseVal) then
        --升级达到满级
        return ;
    end
--    error("------------------0|" .. self.hData.level .. "|" .. self.hData.wiseup .. "|" .. nextWiseVal .. "|" .. curWiseVal);
    if (nextWiseVal > curWiseVal) then
        --觉醒
        tp = 1;
        msgErr = const_lackOfGold;
        msgSuc = const_wiseupSuccess;
        cost = HeroDataProxy.getHeroWakeupGold(self.hData.wiseup + 1);
        curOwn = curMny;
        sID = ServerID.HU_WakeUp;
        newLvl = self.hData.wiseup + 1;
    else
        --升级
--        Util.EnableButton2D(self.btn, 3, false);
        tp = 0;
        msgErr = const_lackOfExp;
        msgSuc = const_lvlupSuccess;
        cost = HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + 1);
        curOwn = curExp;
        sID = ServerID.HU_LvlUp;
        newLvl = self.hData.level + 1;
    end
    
    if (1 == tp) then
        self:showWiseUpPane();
        return ;
    end

    if (cost > curOwn) then
        ViewUtil.showMsg(msgErr);
--        Util.EnableButton2D(self.btn, 0, true);
        return ;
    end
    
    local sendMsg = Map.new();
	sendMsg:put("id", self.hData.id);
    sendMsg:put("level", newLvl);
	local buffer = Network.reqParamEncode(sendMsg);
	NetManager:SendData(self, buffer, sID, nil, 
		function(sd)
    		local defData = nil;
    		defData = GetProtoTable("DefaultData", sd);
    		if (0 ~= defData.code) then
        		-- ViewUtil.showMsg(GetWord(defData.code));
                ViewUtil.showMsg(const_lackOfGold);
        		return ;
    		end

    		ViewUtil.showMsg(msgSuc);
    		self:changeData(tp);

            local HUCtrl = ModuleManager.GetCtrl(ModuleName.HU)
    		for i = 1, #HUCtrl.view.lvlUpRow do
                if HUCtrl.view.lvlUpRow[i] ~= self then
                    HUCtrl.view.lvlUpRow[i]:changeRowShow(2);
                else
                    self:changeRowShow();
                end
            end
    	end, 
    "", doNthFunc);

--    LuaCallManager:invokeCall(function () 
--        Util.EnableButton2D(self.btn, 0, true);
--    end, 1);

    if (PlayerData.guideNotEnd()) then
        Facade:sendNotification(MVCConst.GUIDE_SAVEGUIDE, {});
        Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
    end

    --金币、经验的同步，后台推包处理
--    PlayerData.setMyExp(cost);
--    Facade:sendNotification(MVCConst.UPDATE_MNY, 2, nil);
    
    --这里开始，取到的角色等级、金币、经验等数据，都是没有更新的，需要往后推一级
    local showLevel = tonumber(HeroDataProxy.getHeroShowLvl(self.hData.level, self.hData.wiseup))
    if showLevel < 28 then
        if (PlayerData.getMyExp() - HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + 1)) > (HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + 2) + HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + 3)) then
            -- self.btnDirUp:SetActive(true)
            local exsited = FindObject("BtnDirUp(Clone)")
            if exsited ~= nil then
                DestroyObject(exsited)
            end

            local btnDirUpObj = CreateObject(self.btnDirUp)
            btnDirUpObj:SetActive(true)
            HangObject(btnDirUpObj, self.gameObject);
            btnDirUpObj.transform.localPosition = self.btnDirUp.transform.localPosition
            DestroyObject(btnDirUpObj, 1.5)
            local maxUpLevel = 2    --默认经验能升两级才开启本按钮 by iorinie
            local maxUpExp = HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + 2) + HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + 3)
            local deltaStrength = HeroDataProxy.getHeroAbility(self.hData.heroId, self.hData.level + 2, self.hData.wiseup, self.hData.strengthen) - HeroDataProxy.getHeroAbility(self.hData.heroId, self.hData.level, self.hData.wiseup, self.hData.strengthen)

            for i = 3, (29 - showLevel) do
                maxUpExp = maxUpExp + HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + i + 1)
                if (PlayerData.getMyExp() - HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + 1)) < maxUpExp then
                    maxUpExp = maxUpExp - HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + i + 1)
                    break
                end

                maxUpLevel = maxUpLevel + 1
                deltaStrength = HeroDataProxy.getHeroAbility(self.hData.heroId, self.hData.level + i, self.hData.wiseup, self.hData.strengthen) - HeroDataProxy.getHeroAbility(self.hData.heroId, self.hData.level, self.hData.wiseup, self.hData.strengthen)
            end

            local btnDirUpSpr = GetGameObject(btnDirUpObj.transform, "Sprite")
            local btnDirUpAblyUILbl = GetPathComponent(btnDirUpSpr.transform, "Label", "UILabel")
            local btnDirUpExpUILabl = GetPathComponent(btnDirUpSpr.transform, "LabelExp", "UILabel")
            local showBtnDirUpLabel = GetPathComponent(btnDirUpSpr.transform, "BtnLabel", "UILabel")
            btnDirUpAblyUILbl.text = "+"..LogicUtil.getShowNum(deltaStrength)
            btnDirUpExpUILabl.text = ""..LogicUtil.getShowNum(maxUpExp)
            showBtnDirUpLabel.text = "+"..LogicUtil.getShowNum(maxUpLevel)
            ViewUtil.AddClickEvent(btnDirUpObj, function () self:doClickDirUp(maxUpLevel, btnDirUpObj); end)

            -- self.btnDirUpAblyUILbl.text = "+"..deltaStrength
            -- self.btnDirUpExpUILabl.text = ""..maxUpExp
            -- self.showBtnDirUpLabel.text = "+"..maxUpLevel
            -- ViewUtil.AddClickEvent(self.btnDirUp, function () self:doClickDirUp(maxUpLevel); end)
        end
    else
        local exsited = FindObject("BtnDirUp(Clone)")
		if exsited ~= nil then
			DestroyObject(exsited)
		end
    end
end


function HULvlUpRow:doClickDirUp(_maxlev, _obj)
    local sendMsg = Map.new()
    sendMsg:put("id", self.hData.id)
    sendMsg:put("level", self.hData.level + _maxlev)
    local buffer = Network.reqParamEncode(sendMsg);
    NetManager:SendData(self, buffer, ServerID.HU_LvlUp, nil, 
    	function(sd)
    		local defData = nil;
    		defData = GetProtoTable("DefaultData", sd);
    		if (0 ~= defData.code) then
        		-- ViewUtil.showMsg(GetWord(defData.code));
                ViewUtil.showMsg(const_lackOfGold);
        		return ;
    		end

    		ViewUtil.showMsg(const_lvlupSuccess)

    		local btnDirUpObj = _obj
    		DestroyObject(btnDirUpObj, 0)

    		self.hData.level = self.hData.level + _maxlev
    		
            local HUCtrl = ModuleManager.GetCtrl(ModuleName.HU)
            for i = 1, #HUCtrl.view.lvlUpRow do
                if HUCtrl.view.lvlUpRow[i] ~= self then
                    HUCtrl.view.lvlUpRow[i]:changeRowShow(2);
                else
                    self:changeRowShow();
                end
            end
    	end, 
    "", doNthFunc);	
end

--[[
    显示觉醒面板
]]
function HULvlUpRow:showWiseUpPane ()
    Facade:sendNotification(MVCConst.HU_INTENSIFY, {[1] = 2, [2] = self});
end

--[[
    修改数据
    return nil
]]
function HULvlUpRow:changeData(_tp)
    _tp = _tp or 0;

    if (0 == _tp) then
        self.hData.level = self.hData.level + 1;
    else
        self.hData.wiseup = self.hData.wiseup + 1;  --这里根本不走 by iorinie
    end
end

--[[
    更新数据之后，修改相关显示
    return nil
]]
function HULvlUpRow:changeRowShow(_wiseUpTp, _goldAfterWiseUp)
    local curAbility, nextAbility, deltaAbility = 0, 0;
    local curWakeLvl, totalWakeLvl = 0, 0;
    local curWiseVal, nextWiseVal = self.hData.wiseup, HeroDataProxy.getHeroWiseByLvl(self.hData.level + 1);
    
    curAbility = HeroDataProxy.getHeroAbility(self.hData.heroId, self.hData.level, self.hData.wiseup, self.hData.strengthen);
    if (curWiseVal == nextWiseVal) then
        nextAbility = HeroDataProxy.getHeroAbility(self.hData.heroId, self.hData.level + 1, nextWiseVal, self.hData.strengthen);
    else
        nextAbility = HeroDataProxy.getHeroAbility(self.hData.heroId, self.hData.level, nextWiseVal, self.hData.strengthen);
    end
    
    deltaAbility = nextAbility - curAbility;
    deltaAbility = (deltaAbility > 0 and deltaAbility or 0);

    self.fightValueUILbl.text = "" .. curAbility;
    self.bsAblyUILbl.text = "+" .. deltaAbility;
--    error("------------------1|" .. self.hData.id .. "|" .. self.hData.level .. "|" .. self.hData.wiseup .. "|" .. self.hData.strengthen .. "|" .. nextWiseVal .. "|" .. curWiseVal);
    if (nextWiseVal > curWiseVal) then
        --觉醒
        self.bsExpUILabl.text = "" .. LogicUtil.getShowNum(HeroDataProxy.getHeroWakeupGold(self.hData.wiseup + 1));
        -- GetComponent(self.showBtnLabel, "UILabel").text = const_wake;
        self.upgrade.spriteName = "juexing"
--		NGUITools.SetActive(self.iconUpgrade, false)
--		NGUITools.SetActive(self.iconWakeup, true)
        self.lvlUILbl.text = "LV" .. 30;
        GetComponent(self.btnSprite, "UISprite").spriteName = const_wakeBG;
        GetComponent(self.btn, "UIButton").normalSprite = const_wakeBG;
        GetComponent(self.btnPriceType, "UISprite").spriteName = const_wakeType;
        -- self.inten2WiseEff:SetActive(false)
        -- self.inten2WiseEff:SetActive(true)
        local goldAfter = _goldAfterWiseUp; --觉醒成功后需要判断特殊处理 by iorinie
        if goldAfter == nil then
            if _wiseUpTp ~= 2 then
                self.inten2WiseEff:SetActive(false)
                self.inten2WiseEff:SetActive(true)
            end
            if (HeroDataProxy.getHeroWakeupGold(self.hData.wiseup + 1) > PlayerData.getMyGold()) then
                Util.EnableButton(self.btn, ButtonState.Disabled, true);
            end
        else
            if (HeroDataProxy.getHeroWakeupGold(self.hData.wiseup + 1) > goldAfter) then
                Util.EnableButton(self.btn, ButtonState.Disabled, true);
            end
        end
    else
        --升级
        self.bsExpUILabl.text = "" .. LogicUtil.getShowNum(HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + 1));
        -- GetComponent(self.showBtnLabel, "UILabel").text = const_lvlup;
        self.upgrade.spriteName = "wUpgrade"
--		NGUITools.SetActive(self.iconUpgrade, true)
--		NGUITools.SetActive(self.iconWakeup, false)
        self.lvlUILbl.text = "LV" .. HeroDataProxy.getHeroShowLvl(self.hData.level, self.hData.wiseup);
        GetComponent(self.btnSprite, "UISprite").spriteName = const_lvlupBG;
        GetComponent(self.btn, "UIButton").normalSprite = const_lvlupBG;
        GetComponent(self.btnPriceType, "UISprite").spriteName = const_lvlupType;
        if _wiseUpTp == 1 then
            self.inten2WiseEff:SetActive(false)
            -- self.wiseUpEff:SetActive(false)
            self.wiseUpEff:SetActive(true)
            DelayCall(function() self.wiseUpEff:SetActive(false) end, 1)
        end
        if (HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + 1) > PlayerData.getMyExp()) then
            Util.EnableButton(self.btn, ButtonState.Disabled, false);
        end
        if nextWiseVal == -1 then --满级
            self.btn:SetActive(false)
        end
    end
    curWakeLvl = self.hData.wiseup;
    totalWakeLvl = HeroDataProxy.maxWakeLvl;
    self.wakeLvl.text = curWakeLvl .. "/" .. totalWakeLvl;

    ModuleManager.GetCtrl(ModuleName.HU).refreshTotalAbility();
end