--显示觉醒、强化、铸神兵消耗的道具
--2016-10-13 16:17:23 library

HUShowPropsPane = class();

--[[

]]
function HUShowPropsPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

--[[

]]
function HUShowPropsPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.pDataList = nil;
    self.pGOList = List.new();--存放复用的道具GO列表
end

--[[

]]
function HUShowPropsPane:initPanel ()

end

--[[

]]
function HUShowPropsPane:setData (_list)
    self.pDataList = _list;

    self:showProps();
end

--[[

]]
function HUShowPropsPane:showProps()
    local curIdx, propNum, isHide = 0, 0, true;
    local props = self.pDataList;
    local prop, goTmp = nil, nil;
    local luaBhvi, propShowItem = nil, nil;
    
    for i = 1, props:getSize() do
        prop = props[i];
        propNum = PropDataProxy.getPropNumByPropId(prop[1]);
        
        --复用之前存在的道具GO
        if (i <= self.pGOList:getSize()) then
            curIdx  = curIdx + 1;
            propShowItem = self.pGOList[i];
            goTmp = propShowItem.gameObject;
            propShowItem:Awake(goTmp, prop[1], propNum);
            propShowItem:Start();
            propShowItem:setNumText(propNum .. "/" .. prop[2]);
            propShowItem.gameObject:SetActive(true);
            HangObject(propShowItem.gameObject, self.gameObject);
        else
            isHide = false;
            goTmp = CreateObject(Util.LoadPrefab("UI/PropItem", AssetBundleInfo.assetBundles));
            propShowItem = PropShowItem.new();
            propShowItem:Awake(goTmp, prop[1], propNum);
            propShowItem:Start();
            propShowItem:setNumText(propNum .. "/" .. prop[2]);
            PanelManager:BindPanelScript(propShowItem, goTmp, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
            HangObject(goTmp, self.gameObject);
            self.pGOList:add(propShowItem);
        end

    end

    if (isHide) then
        for i = curIdx + 1, self.pGOList:getSize() do
            goTmp = self.pGOList[i].gameObject;
            HangObject(goTmp, self.gameObject.transform.parent.gameObject);
            goTmp:SetActive(false);
        end
    end

    GetComponent(self.gameObject, "UIGrid"):Reposition();
end