--[[
-- ս
--]]
require "Game/League/View/LeaguePVPFightOverView"
 
LeaguePVPFightOverControler = {}

local this = LeaguePVPFightOverControler

function LeaguePVPFightOverControler.New()
	return this
end

function LeaguePVPFightOverControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeagueFightOverView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function LeaguePVPFightOverControler.Awake()
end

function LeaguePVPFightOverControler.Start()
	this.view:Start(this.data)
end

function LeaguePVPFightOverControler.Update()
end

function LeaguePVPFightOverControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeaguePVPFightOverControler.initListener()
end

function LeaguePVPFightOverControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeaguePVPFightOverControler.handleNotification(notification)
end

function LeaguePVPFightOverControler.accept(data)
	ViewUtil.initData(this, data)
end
