--[[
-- ս
--]]
require "Game/League/View/LeaguePVPFightingView"
require "Game/League/View/LeaguePVPFightingRow"
require "Game/League/View/LeaguePVPFightingEnemy"
 
LeaguePVPFightingControler = {}

local this = LeaguePVPFightingControler

function LeaguePVPFightingControler.New()
	return this
end

function LeaguePVPFightingControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeaguePVPFightingView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject, this)
    this.initListener()
end

function LeaguePVPFightingControler.Awake()
end

function LeaguePVPFightingControler.Start()
	this.view:Start(this.data)
end

function LeaguePVPFightingControler.Update()
end

function LeaguePVPFightingControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeaguePVPFightingControler.initListener()
end

function LeaguePVPFightingControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeaguePVPFightingControler.handleNotification(notification)
end

function LeaguePVPFightingControler.accept(data)
	ViewUtil.initData(this, data)
end
