HeroHead = class(BaseHero)
 
function HeroHead:ctor()
end

function HeroHead:init(data)
	if IsEmpty(data) then return end
	self.heroId = tostring(data.heroId)

	local herosConf = Config.getHerosData()
	local conf = herosConf[self.heroId]
	self.prefabName = conf["#prefab_name"]
	self.quality = conf["quality"]
end

function HeroHead:createHero()
	local hero = self.super.createHero(self, "UI/Hero")
	ViewUtil.addDragScrollView(hero)
	self.heroObj = hero
	return hero
end
