
LeaguePVPReadyFightView = class(BaseView)

function LeaguePVPReadyFightView:ctor()
end  

function LeaguePVPReadyFightView:Awake(obj, ctrl)
	self.gameObject = obj
	self.transform = obj.transform
	self.ctrl = ctrl

	self.fieldList = {}
	self.pointLblList= {}
	self.slotList = {}
	self.chooseList = {}
	self.teamIdList = {}
	self.fieldCountList = {}
	self.scrList = {}
	self.nameList = {}
	-- self.hadChosenOne = false
	self.canUpdate = false
	self.firstTeamId = nil
	self.firstOnlyId = nil
	self.firstName = nil
	self.secondTeamId = nil
	self.secondOnlyId = nil
	self.secondName = nil
	--版本1
	-- self.dragObjs = {}
	-- self.dragPosis = {}
	-- self.curslotList = List.new()
	-- self.playerIdList = {}
	-- self.dragSprs = {}
	-- self.dragLbls = {}
	
	-- self.fieldResult = {}
	-- self.fieldResultLbl = {}

	self:initPanel()
end

function LeaguePVPReadyFightView:Start(data)
	-- self:initData(data)
end

function LeaguePVPReadyFightView:Update()
	if not self.canUpdate then return end

	if self.time <= -1 then
		Network.ReqLeaguePVPJoin()
		self.canUpdate = false
	else
		self.sumTime = Time.timeSinceLevelLoad
		if not self.preTime or self.preTime <= 0 then
			self.preTime = self.sumTime
		end
		local deltaTime = self.sumTime - self.preTime
		self.preTime = self.sumTime

		self.time = self.time - deltaTime
	
		self.tipTimeLbel.text = Time2String(self.time)
	end
end

function LeaguePVPReadyFightView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"
	self.leagueALbl = GetPathComponent(self.transform, topPath.."/BoardBG/LeagueA", "UILabel")
	self.leagueBLbl = GetPathComponent(self.transform, topPath.."/BoardBG/LeagueB", "UILabel")
	self.tipTimeLbel = GetPathComponent(self.transform, topPath.."/Tip", "UILabel")

	local centerPath = "Mode/Center/Panel"
	self.scrollViewPanel = GetPathComponent(self.transform, centerPath.."/ScrollViewBG/ScrollView", "UIScrollView")
	self.gridObj = GetGameObject(self.transform, centerPath.."/ScrollViewBG/ScrollView/Panel/Grid")
	self.choose = GetGameObject(self.gridObj.transform, "Choose")

	for i = 0, 2 do
		self.fieldList[i] = GetGameObject(self.gridObj.transform, "Field_"..i)
		self.pointLblList[i] = GetPathComponent(self.fieldList[i].transform, "FieldBG/Label", "UILabel")

		-- local slotList = {}
		for j = 0, 9 do
			local onlyId = self:ConvertToIndex(i, j)
			-- if self.curFieldIndex ~= nil and self.curSlotIndex ~= nil then
			-- 	self.curOnlyId = self:ConvertToIndex(self.curFieldIndex, self.curSlotIndex)
			-- end

			self.slotList[onlyId] = GetGameObject(self.fieldList[i].transform, "Slots/Slot_"..j)
			local function callback(obj)
				if obj == self.slotList[onlyId] then
					if self.firstTeamId == nil then
						-- local temp = self:FindOnlyIdByName(TeamData.GetRoleName())
						-- if temp == nil then
							Network.SendMoData(ServerID.LeaguePVPRFMove, {0, i, j}, function(session, params)
								local serviceId = tonumber(session.serviceId)
								local mo = GetProtoTable("DefaultData", session)
								if mo.code == 0 then
									-- if self.curChoose == nil then
									-- 	self.curChoose = CreateObject(self.choose)
									-- 	self.curChoose:SetActive(true)
									-- 	GetPathComponent(self.curChoose.transform, "Label", "UILabel").text = TeamData.GetRoleName()
									-- 	self.fieldCountList[i] = self.fieldCountList[i] + 1
									-- end
									-- HangObject(self.curChoose, self.slotList[onlyId])
									-- -- if self.curOnlyId ~= nil then
									-- -- 	self.nameList[self.curOnlyId] = nil
									-- -- end
									-- self.nameList[onlyId] = TeamData.GetRoleName()

									-- if LeagueData.IsCaptain() then
									-- 	-- if self.teamIdList[self.curOnlyId] ~= nil then
									-- 	-- 	self.teamIdList[self.curOnlyId] = nil
									-- 	-- 	self.scrList[self.curOnlyId] = nil
									-- 	-- end
									-- 	self.teamIdList[onlyId] = PlayerData.GetRoleTeamId()

									-- 	self.scrList[onlyId] = LeaguePVPRFChoose.new()
									-- 	self.scrList[onlyId]:Awake(self.curChoose)
									-- 	-- PanelManager:BindPanelScript(self.scrList[self:ConvertToIndex(i, j)], tempObj, doNthFunc, doNthFunc, doNthFunc, doNthFunc)
									-- 	self.scrList[onlyId]:Start()
									-- 	self.scrList[onlyId]:setData(PlayerData.GetRoleTeamId(), onlyId, TeamData.GetRoleName(), self.ctrl)
									-- end
									-- -- self.curFieldIndex = i
									-- -- self.curSlotIndex = j

									-- self.pointLblList[i].text = self.fieldCountList[i].."/10人"

									ViewUtil.showMsg("参与成功")
								else
									ViewUtil.showMsg("参与失败")
								end
							end, {})
						-- end
					else
						ViewUtil.comCfmPanel("是否确认变换位置？", function ()
							Network.SendMoData(ServerID.LeaguePVPRFMove, {self.firstTeamId, i, j}, function(session, params)
								local serviceId = tonumber(session.serviceId)
								local mo = GetProtoTable("DefaultData", session)
								if mo.code == 0 then
									-- self.chooseList[onlyId] = CreateObject(self.choose)
									-- self.chooseList[onlyId]:SetActive(true)
									-- HangObject(self.chooseList[onlyId], self.slotList[onlyId])
									-- GetPathComponent(self.chooseList[onlyId].transform, "Label", "UILabel").text = self.firstName

									-- self.teamIdList[onlyId] = self.firstTeamId
									-- self.scrList[onlyId] = LeaguePVPRFChoose.new()
									-- self.scrList[onlyId]:Awake(self.chooseList[onlyId])
									-- -- PanelManager:BindPanelScript(self.scrList[onlyId], self.chooseList[onlyId], doNthFunc, doNthFunc, doNthFunc, doNthFunc)
									-- self.scrList[onlyId]:Start()
									-- self.scrList[onlyId]:setData(self.firstTeamId, onlyId, self.firstName, self.ctrl)
									-- self.nameList[onlyId] = self.firstName
									-- error(self.firstOnlyId)
									-- DestroyObject(self.chooseList[self.firstOnlyId])
									-- error("!!!!")

									-- self.teamIdList[self.firstOnlyId] = nil
						   --          self.scrList[self.firstOnlyId] = nil
						   --          self.nameList[self.firstOnlyId] = nil

									self:RemoveSlt()
									self.firstTeamId = nil
						            self.firstOnlyId = nil
						            self.firstName = nil

									ViewUtil.showMsg("移动成功！")				
								else
									-- self:RemoveSlt()

									ViewUtil.showMsg("移动失败！")
								end
							end, {})
						end, function ()
				            self:RemoveSlt()
				            self.firstTeamId = nil
				            -- self.secondTeamId = nil
				            self.firstOnlyId = nil
				            -- self.secondOnlyId = nil
				            self.firstName = nil
				            -- self.secondName = nil
				        end)
					end
				end
			end
			ViewUtil.AddClickEvent(self.slotList[self:ConvertToIndex(i, j)], callback)
		end
	end

	--版本1
	-- for i = 1, 3 do
	-- 	self.fieldResult[i] = GetGameObject(self.transform, centerPath.."/Field/Field_"..i.."/StatusBG")
	-- 	self.fieldResultLbl[i] = GetPathComponent(self.fieldResult[i].transform, "Label", "UILabel")
	-- end

	-- self.gridObj = GetGameObject(self.transform, centerPath.."/Field/SpecialGrid")
	-- self.slotsObj = GetGameObject(self.transform, centerPath.."/Field/Slots")

-- 	for i = 0, 29 do
-- 		self.dragObjs[i] = GetGameObject(self.gridObj.transform, ""..i)
-- 		self.dragPosis[i] = self.dragObjs[i].transform.localPosition

-- 		local function _onDragStart(tbl)
-- 			if GetComponent(tbl.obj.transform, "UISprite").spriteName ~= "alpha" then
-- 				for i = 0, (#self.dragPosis - 1) do
-- 					if tbl.obj.transform.localPosition == self.dragPosis[i] then
-- 						self.dragStartId = i
-- 					end
-- 				end
-- 			end
-- 		end

-- 		local function _onDragEnd(tbl)
-- 			if GetComponent(tbl.obj.transform, "UISprite").spriteName ~= "alpha" then
-- 				DelayCall(function()
-- 					local endId = nil
-- 					for i = 0, (#self.dragPosis - 1) do
-- 						if tbl.obj.transform.localPosition == self.dragPosis[i] then
-- 							endId = i
-- 							for k, v in pairs(self.curslotList) do
-- 								if endId == v then
-- 									error("exchanging!!!!")
-- 								end
-- 							end
-- 						end
-- 					end
-- 					error("DragObj_"..tbl.obj.name.." move to slot_"..endId)
-- 					-- self.curslotList:remove(self.dragStartId)
-- 					-- if not self.curslotList:contains(endId) then
-- 					-- 	self.curslotList:add(endId)
-- 					-- end
-- 					-- error(tbl.obj.transform.localPosition)

-- 					local fieldIdx = nil
-- 					local localIdx = nil
-- 					if endId < 10 then
-- 						fieldIdx = 0
-- 					else
-- 						if endId < 20 then
-- 							fieldIdx = 1
-- 						elseif endId < 30 then
-- 							fieldIdx = 2
-- 						end
-- 					end
-- 					localIdx = fieldIdx * 10 + math.mod(fieldIdx, 10)

-- 					local teamId = nil
-- 					if tbl.id == PlayerData.GetRoleTeamId() then
-- 						teamId = 0
-- 					else
-- 						teamId = tbl.id
-- 					end
-- 					Network.SendMoData(ServerID.LeaguePVPRFMove, {teamId, fieldIdx, localIdx}, function(session, params)
-- 						local serviceId = tonumber(session.serviceId)
-- 						local mo = GetProtoTable("DefaultData", session)
-- 						if mo.code == 0 then													
-- 							ViewUtil.showMsg("移动成功！")				
-- 						else
-- 							ViewUtil.showMsg("移动失败！")
-- 						end
-- 					end, {})
-- 				end, 1)
-- 			end
-- 		end
-- 		ViewUtil.AddEventTrigger(self.dragObjs[i], EventConst.onDragStart, _onDragStart, {obj = self.dragObjs[i], id = self.playerIdList[i]})
-- 		ViewUtil.AddEventTrigger(self.dragObjs[i], EventConst.onDragEnd, _onDragEnd, {obj = self.dragObjs[i]})

-- 		self.dragSprs[i] = GetComponent(self.dragObjs[i].transform, "UISprite")
-- 		self.dragLbls[i] = GetPathComponent(self.dragObjs[i].transform, "Label", "UILabel")

-- 		local function callback(obj)
-- 			-- if obj == self.slots[i] then
-- 			if obj == self.dragObjs[i] then
-- 				if self.dragSprs[i].spriteName == "alpha" then --防止拖动空白位置时调用拖动方法
-- 					local fieldIdx = nil
-- 					local localIdx = nil
-- 					if i < 10 then
-- 						fieldIdx = 0
-- 					else
-- 						if i < 20 then
-- 							fieldIdx = 1
-- 						elseif i < 30 then
-- 							fieldIdx = 2
-- 						end
-- 					end
-- 					localIdx = fieldIdx * 10 + math.mod(i, 10)

-- 					Network.SendMoData(ServerID.LeaguePVPRFMove, {0, fieldIdx, localIdx}, function(session, params)
-- 						local serviceId = tonumber(session.serviceId)
-- 						local mo = GetProtoTable("DefaultData", session)
-- 						if mo.code == 0 then
-- 							if self.curSlotId ~= nil then
-- 								if LeagueData.IsCaptain() then
-- 									local scr = GetComponent(self.dragObjs[self.curSlotId].transform, "UIExtDragDropItem")
-- 									DestroyObject(scr)
-- 								end
-- 								self.dragSprs[self.curSlotId].spriteName = "alpha"
-- 								self.dragLbls[self.curSlotId].text = ""
-- 								self.curslotList:remove(self.curSlotId)
-- 							end

-- 							self.dragSprs[i].spriteName = "btnBiggestBlue"
-- 							self.dragLbls[i].text = TeamData.GetRoleName()
-- 							if LeagueData.IsCaptain() then
-- 								self.dragObjs[i]:AddComponent(UIExtDragDropItem.GetClassType())
-- 							end
-- 							self.curSlotId = i
-- 							if not self.curslotList:contains(self.curSlotId) then
-- 								self.curslotList:add(self.curSlotId)
-- 							end
-- 							ViewUtil.showMsg("参与成功")
-- 						else
-- 							ViewUtil.showMsg("参与失败")
-- 						end
-- 					end, {})
-- 				end
-- 			end
-- 		end

-- 		ViewUtil.AddClickEvent(self.dragObjs[i], callback)
-- 	end

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)		
		if obj == self.btnBack then
			-- self:closeView(true)
			Network.SendMoData(ServerID.LeaguePVPRFQuit)
			Network.ReqLeaguePVP()
		end
    end
	
	ViewUtil.AddClickEvent(self.btnBack, doClick)
end

function LeaguePVPReadyFightView:initData(data)
	if IsEmpty(data) then return end

	self.leagueALbl.text = data.otherLeagueName
	self.leagueBLbl.text = data.leagueName

	self.time = data.second or 0
	-- local minite = GetIntPart(self.time / 60)
	-- local second = math.mod(self.time, 60)
	-- if second < 10 then
	-- 	second = "0"..second
	-- end
	-- self.tipTimeLbel.text = "0"..minite..":"..second
	self.tipTimeLbel.text = Time2String(self.time)

	if self.time > 0 then
		self.canUpdate = true
	end

	-- local slotList = {}
	-- local nameList = {}
	-- local slotIdx = 1
	local randomList = List:new()
	for i = 0, 29 do
		randomList:add(i)
	end

	for i = 1, #data.battleList do
		local info = data.battleList[i]

		local fieldStatus = GetGameObject(self.fieldList[i - 1].transform, "Status")
		if info.status ~= 0 then
			fieldStatus:SetActive(true)

			if not info.isWin then
				GetComponent(fieldStatus.transform, "UISprite").spriteName = "League_PVPLose"
			else
				GetComponent(fieldStatus.transform, "UISprite").spriteName = "League_PVPWin"
			end
		end

		self.fieldCountList[0] = 0
		self.fieldCountList[1] = 0
		self.fieldCountList[2] = 0
		for j = 1, #info.teamList do
			local teamInfo = info.teamList[j]
			if teamInfo.teamId ~= 0 then
				local onlyId = self:ConvertToIndex(i - 1, teamInfo.pkIndex)
				self.chooseList[onlyId] = CreateObject(self.choose)
				self.chooseList[onlyId]:SetActive(true)
				HangObject(self.chooseList[onlyId], self.slotList[onlyId])
				GetPathComponent(self.chooseList[onlyId].transform, "Label", "UILabel").text = teamInfo.name
				self.nameList[onlyId] = teamInfo.name

				if LeagueData.IsCaptain() then
					self.teamIdList[onlyId] = teamInfo.teamId
					self.scrList[onlyId] = LeaguePVPRFChoose.new()
					self.scrList[onlyId]:Awake(self.chooseList[onlyId])
					-- PanelManager:BindPanelScript(self.scrList[onlyId], self.chooseList[onlyId], doNthFunc, doNthFunc, doNthFunc, doNthFunc)
					self.scrList[onlyId]:Start()
					self.scrList[onlyId]:setData(teamInfo.teamId, onlyId, teamInfo.name, self.ctrl)
				end
				self.fieldCountList[i - 1] = self.fieldCountList[i - 1] + 1
				randomList:remove(onlyId)
			end
		end
		self.pointLblList[i - 1].text = self.fieldCountList[i - 1].."/10人"
	end

	if data.second ~= 0 then
		local randomIdx = math.random(#randomList)
		local randomOnlyId = randomList[randomIdx]
		-- error("randomOnlyId = "..randomOnlyId)
		local randomFieldIdx = GetIntPart(randomOnlyId / 10)
		-- error("randomFieldIdx = "..randomFieldIdx)
		local randomSlotIdx = math.mod(randomOnlyId, 10)
		-- error("randomSlotIdx = "..randomSlotIdx)

		Network.SendMoData(ServerID.LeaguePVPRFMove, {0, randomFieldIdx, randomSlotIdx}, function(session, params)
			local serviceId = tonumber(session.serviceId)
			local mo = GetProtoTable("DefaultData", session)
			if mo.code == 0 then
				local offset = nil
				if randomFieldIdx == 1 then
					offset = 280
				elseif randomFieldIdx == 2 then
					offset = 520
				end
				self.scrollViewPanel:MoveRelative(Vector3.New(0, offset, 0))
				ViewUtil.showMsg("参与成功")
			else
				ViewUtil.showMsg("参与失败")
			end
		end, {})
	end
	--版本1
	-- for i = 1, #data.battleList do
	-- 	local info = data.battleList[i]
	-- 	if info.status == 1 then
	-- 		self.fieldResult[i]:SetActive(true)
	-- 		self.fieldResultLbl[i].text = "胜利"
	-- 	elseif info.status == 0 then
	-- 		self.fieldResult[i]:SetActive(true)
	-- 		self.fieldResultLbl[i].text = "失败"
	-- 	end

	-- 	for i = 1, #info.teamList do
	-- 		local temp = info.teamList[i]
	-- 		slotList[slotIdx] = temp.index
	-- 		nameList[slotIdx] = temp.name
	-- 		self.playerIdList[info.index * 10 + temp.index] = temp.teamId
	-- 	end
	-- end

	-- self:SetDragObjActive(slotList, nameList)
end

--[[
	--版本1
	--位置有变动时，保留的界面怎么处理更新？（前端点击或拖动生效后，后端广播状态变化进行处理。）
	--移动失败，界面怎么处理？
	slotList：所占空位的地址
	nameList：所占空位的玩家名字
]]
-- function LeaguePVPReadyFightView:SetDragObjActive(slotList, nameList)
-- 	--这里进行重置操作？
-- 	for i = 1, #slotList do
-- 		if not self.curslotList:contains(slotList[i]) then
-- 			self.curslotList:add(slotList[i])
-- 		end
-- 		self.dragSprs[slotList[i]].spriteName = "btnBiggestBlue"
-- 		self.dragLbls[slotList[i]].text = nameList[i]
-- 		if LeagueData.IsCaptain() then
-- 			self.dragObjs[slotList[i]]:AddComponent(UIExtDragDropItem.GetClassType())
-- 		end
-- 	end	
-- end

function LeaguePVPReadyFightView:AddSlt(obj)
	-- error("Add!!!!")
end

function LeaguePVPReadyFightView:RemoveSlt()
	--移除所有选择框
	-- error("Remove!!!!")
end

function LeaguePVPReadyFightView:ExchangeSlot()
	local fieldIdx = GetIntPart(self.secondOnlyId / 10)
	local slotIdx = math.mod(self.secondOnlyId, 10)

    Network.SendMoData(ServerID.LeaguePVPRFMove, {self.firstTeamId, fieldIdx, slotIdx}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("DefaultData", session)
		if mo.code == 0 then
			self:RemoveSlt()

			-- self.scrList[self.firstOnlyId]:SetTeamId(self.secondTeamId)
			-- self.scrList[self.secondOnlyId]:SetTeamId(self.firstTeamId)
			-- self.scrList[self.firstOnlyId]:SetName(self.secondName)
			-- self.scrList[self.secondOnlyId]:SetName(self.firstName)
			-- DestroyObject(self.chooseList[self.firstOnlyId])
			-- DestroyObject(self.chooseList[self.secondOnlyId])

			self.firstTeamId = nil
            self.secondTeamId = nil
            self.firstOnlyId = nil
            self.secondOnlyId = nil
            self.firstName = nil
            self.secondName = nil
			ViewUtil.showMsg("移动成功！")				
		else
			-- self:RemoveSlt()
			-- self.firstTeamId = nil
   --          self.secondTeamId = nil
   --          self.firstOnlyId = nil
   --          self.secondOnlyId = nil
   --          self.firstName = nil
   --          self.secondName = nil
			ViewUtil.showMsg("移动失败！")
		end
	end, {})
end

--[[
	根据战场号及战场中的位置换算唯一下标
]]
function LeaguePVPReadyFightView:ConvertToIndex(fieldIdx, slotIdx)
	local rzt = fieldIdx * 10 + slotIdx
	return rzt
end

function LeaguePVPReadyFightView:ChooseUpdate(_data)
	for i = 1, #_data.teamDatas do
		local info = _data.teamDatas[i]
		-- error("num_"..i)
		-- if info.name ~= TeamData.GetRoleName() then
			if info.teamId == 0 then
				-- error(info.name)
				-- error("0: "..info.index)
				-- error("0: "..info.pkIndex)
				self.fieldCountList[info.index] = self.fieldCountList[info.index] - 1

				local onlyId = self:ConvertToIndex(info.index, info.pkIndex)
				DestroyObject(self.chooseList[onlyId])
				self.chooseList[onlyId] = nil

				self.nameList[onlyId] = nil

				if LeagueData.IsCaptain() then
					self.teamIdList[onlyId] = nil
					self.scrList[onlyId] = nil
				end
			else
				-- error(info.name)
				-- error("return index: "..info.index)
				-- error("return pkIndex: "..info.pkIndex)
				local onlyId = self:ConvertToIndex(info.index, info.pkIndex)

				if self.chooseList[onlyId] ~= nil then
					DestroyObject(self.chooseList[onlyId])
					self.chooseList[onlyId] = nil
					self.fieldCountList[info.index] = self.fieldCountList[info.index] - 1
				end

				self.chooseList[onlyId] = CreateObject(self.choose)
				self.chooseList[onlyId]:SetActive(true)
				HangObject(self.chooseList[onlyId], self.slotList[onlyId])
				GetPathComponent(self.chooseList[onlyId].transform, "Label", "UILabel").text = info.name
				self.nameList[onlyId] = info.name

				if LeagueData.IsCaptain() then
					self.teamIdList[onlyId] = info.teamId
					self.scrList[onlyId] = LeaguePVPRFChoose.new()
					self.scrList[onlyId]:Awake(self.chooseList[onlyId])
					-- PanelManager:BindPanelScript(self.scrList[onlyId], self.chooseList[onlyId], doNthFunc, doNthFunc, doNthFunc, doNthFunc)
					self.scrList[onlyId]:Start()
					self.scrList[onlyId]:setData(info.teamId, onlyId, info.name, self.ctrl)
				end
				self.fieldCountList[info.index] = self.fieldCountList[info.index] + 1
			end
		-- end
		self.pointLblList[info.index].text = self.fieldCountList[info.index].."/10人"
	end
end

-- function LeaguePVPReadyFightView:FindOnlyIdByName(name)
-- 	local rzt = nil

-- 	for i = 1, #self.nameList do
-- 		if self.nameList[i] == name then
-- 			rzt = i
-- 			return rzt
-- 		end
-- 	end
-- end