--ٻģ
--2016-10-23 11:22:29 

require "Game/Lucky/View/LuckyBoxPick"
require "Game/Lucky/View/LuckyConvertHero"
require "Game/Lucky/View/LuckyPickCard"
require "Game/Lucky/View/LuckyView"
 
LuckyControler = {
    animating = false;
}

local this = LuckyControler

function LuckyControler.New()
	return this
end

function LuckyControler.OnCreate(obj, name)
    UpdateHelper.addUpdate(this.Update);
	this.root = ViewUtil.getRootView()
	this.view = LuckyView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = this.gameObject.transform
	HangObject(this.gameObject, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject, this);
    this.initListener();
	this.request()
end

function LuckyControler.Awake()

end

function LuckyControler.Start()
	
end

function LuckyControler.Update()
    this.view:Update();
end

function LuckyControler.OnDestroy()
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
    this.animating = false;
    
    UpdateHelper.removeUpdate(this.Update);
    HeroDataProxy.newHeroList:clear();

    ViewUtil.closeView(ModuleName.HP, false);
end

function LuckyControler.initListener()
end

function LuckyControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function LuckyControler.handleNotification(notification)

end

function LuckyControler.request(_tp)
    _tp = _tp or 0;
	Network.SendMoData(ServerID.Lucky_PropConvertEty, {}, function(session, params)
		local serviceId = tonumber(session.serviceId);
		local mo = GetProtoTable("AltarExchangeMainData", session);

        if (0 == _tp) then
		    this.view:initData(mo);
        else
            this.view:updateHeroDatas(mo);
        end
	end, {})
end

--[[
    ̳ļʱ
    return number 
]]
function LuckyControler.getRemainTime ()
    local refreshTime = tonumber(GameCfgDataProxy.getHeroCallRefreshTime());--ˢµʱ㣬
    local curTime = PlayerData.getCurSysTime();--ǰϵͳʱ--
    local timeTab = PlayerData.getCurTimeStr(curTime);
    local tyear, tmonth, tday, thour = timeTab[2], timeTab[3], timeTab[4], timeTab[5];
    local deltaTime = 0;

    if (thour > refreshTime) then
        tday = tday + 1;
    end
    
    deltaTime = os.time{year = tyear, month = tmonth, day = tday, hour = refreshTime} * 1000 - curTime;
    
    return deltaTime;
end