--抽卡，新动画 弃用
--2016-10-11 09:55:31 library

local const_pumpCostWord = "消耗";
local const_pumpGold = "金币：";
local const_pumpDiamond = "钻石：";
local const_lackOfGold = "金币不足";
local const_lackOfDiamond = "钻石不足";
local const_heroBackSpritePre = "class";
local const_QuaAnmtVal = 5;

local const_cfmWords = "抽{1}次将会消耗{2}{3}";
local const_cfgOne = "一";
local const_cfgTen = "十";
local const_maxHeroNum = "目前可拥有的英雄数量最多为 {1} 个";

local const_sltgoMoveTime = 0.05;
local const_heroGOMoveTime = 0.16;
local const_cardRotateTime = 0.08;

LuckyPickCard = class();

--[[

]]
function LuckyPickCard:ctor ()
    self.gameObject = nil;
    self.transform = nil;
    self.btnEable = true;
end

--[[

]]
function LuckyPickCard:Awake (_go, _tp)
    self.gameObject = _go;
    self.tp = _tp;--抽卡类型：1，金币；2，钻石；3，活动招募
    self.transform = self.gameObject.transform;

    self.heroTabs = List.new();--卡片GO表List DEL
    self.pickupBtns = List.new();--抽卡按钮List

    self.costLabel = nil;
    self.costNum = nil;
    self.sltbox = nil;--移动框 DEL
    self.stopPos = 0;--移动框停留的位置，对应self.heroTabs中的索引 DEL
    self.heros = nil;--抽卡的到的英雄
    self.showIdx = 0;--self.heros中的索引
    self.fullScreenPane = nil;--全屏遮挡面板
    self.herosContainer = nil;--英雄容器
    self.herosGOList = List.new();--在浮层显示的英雄GO表

    self:initPanel();
end

--[[

]]
function LuckyPickCard:initPanel ()
    local hero, heroCvtBtn, tmpTabs, pickupBtn = nil, nil, nil, nil;
    local costMnyInfo = "";
    
    for i = 1, 10 do
        hero = GetGameObject(self.transform, "heroPanel/Hero_" .. (i - 1));
        heroCvtBtn = GetGameObject(self.transform, "heroPanel/heroGet_" .. (i - 1));
        tmpTabs = {hero, heroCvtBtn};
        self.heroTabs:add(tmpTabs);
    end

    pickupBtn = GetGameObject(self.transform, "oneBtn");
    self.pickupBtns:add(pickupBtn);
    pickupBtn = GetGameObject(self.transform, "tenBtn");
    self.pickupBtns:add(pickupBtn);
    self.sltbox = GetGameObject(self.transform, "heroPanel/sltbox");
    self.costLabel = GetGameObject(self.transform, "costLabel");
    self.costNum = GetGameObject(self.transform, "costNum");

    if (1 == self.tp) then
        costMnyInfo = const_pumpCostWord .. const_pumpGold;
    elseif (2 == self.tp) then
        costMnyInfo = const_pumpCostWord .. const_pumpDiamond;
    end

    GetComponent(self.costLabel, "UILabel").text = costMnyInfo;
    GetComponent(self.costNum, "UILabel").text = GameCfgDataProxy.getLuckyPickupCostByType(self.tp);
end

--[[
    _data 英雄数据
    return nil
]]
function LuckyPickCard:setHeroData (_data)
    self.heroData = _data;
end

--[[
    显示卡片及抽卡按钮，隐藏招募按钮
    return nil
]]
function LuckyPickCard:showCards ()
    local pickupBtn, hero, heroBtn = nil, nil, nil;
    local heroPos = nil;
    local perHData, hCfgData = nil, nil;
    
    for i = 1, self.pickupBtns:getSize() do
        pickupBtn = self.pickupBtns[i];
        pickupBtn:SetActive(true);
        -- UIEventListener.Get(pickupBtn).onClick = function () self:pumpCard(i); end;
        ViewUtil.AddClickEvent(pickupBtn, function () self:pumpCard(i); end)
    end
    
    for i = 1, self.heroTabs:getSize() do
        hero = self.heroTabs[i][1];
        heroBtn = self.heroTabs[i][2];

        heroBtn:SetActive(false);
        GetGameObject(hero.transform, "mask"):SetActive(true);
        GetPathComponent(hero.transform, "BG", "UISprite").spriteName = const_heroBackSpritePre .. "6";
        GetComponent(hero.transform, "UIButton").normalSprite = const_heroBackSpritePre .. "6";

        if (i > 5) then
            heroPos = hero.transform.localPosition;
            hero.transform.localPosition = Vector3.New(heroPos.x, -276, heroPos.z);
        end
    end
    self.sltbox:SetActive(false);
end

--[[
    抽卡
    _idx number 1，抽一次；2，抽10次
    return nil
]]
function LuckyPickCard:pumpCard (_idx)
    local myMny, pId, costNum = 0, 0, 0;
    local errMsg = "";
    local myHerosNum = 0;

    myHerosNum = #TeamData.getMyHeros();

    if (myHerosNum >= GameCfgDataProxy.getMaxHeroNumPerTeam()) then
        ViewUtil.showMsg(string.gsub(const_maxHeroNum, "{1}", GameCfgDataProxy.getMaxHeroNumPerTeam()));
        return ;
    end

    _idx = _idx or 1;

    if (1 == self.tp) then
        myMny = PlayerData.getMyGold();
    elseif (2 == self.tp) then
        myMny = PlayerData.getMyDiamond();
    end

    costNum = GameCfgDataProxy.getLuckyPickupCostByType(self.tp) * ((2 == _idx) and 10 or 1);
    
    if (myMny < costNum) then
        if (1 == self.tp) then
            errMsg = const_lackOfGold;
        elseif (2 == self.tp) then
            errMsg = const_lackOfDiamond;
        end
        ViewUtil.showMsg(errMsg);
        return ;
    end
    
    local function okFunc ()
        local sendMsg = Map.new();
        local ctl = nil;
	    local buffer = nil;
    
        ctl = ModuleManager.GetCtrl(ModuleName.LUCK);
        ctl.animating = true;
	    sendMsg:put("type", self.tp + (_idx - 1) * 2);--1，金币；2，钻石；3，金币十连抽；4，钻石十连抽
        buffer = Network.reqParamEncode(sendMsg);
        NetManager:SendData(self, buffer, ServerID.Lucky_MnyConvert, nil, function (sd) self:pumpCallBack(sd); end, "", doNthFunc);
        --禁用游戏事件
        ViewUtil.gameEventEnabled(false);
        self.sltbox:SetActive(true);
        self:setSltboxPos(1);
        self.stopPos = 0;
        self:playerSltGOMoveAnmt(1);
    end

    cfmWords = string.gsub(const_cfmWords, "{1}", ((2 == _idx) and const_cfgTen or const_cfgOne));
    cfmWords = string.gsub(cfmWords,"{2}", ((1 == self.tp) and const_pumpGold or const_pumpDiamond));
    cfmWords = string.gsub(cfmWords,"{3}", costNum);
    ViewUtil.comCfmPanel(cfmWords, okFunc);
end

--[[
    抽卡回调
    _sd session
]]
function LuckyPickCard:pumpCallBack (_sd)
    local defData = nil;
    
    defData = GetProtoTable("DefaultData", _sd);
    
    self.heros = StrSplit(defData.msg, ",");
    self:delBadElems();
    self.showIdx = 0;
   
    self:setSltStopCondition();
end

--[[
    清除self.heros中的无效英雄ID
]]
function LuckyPickCard:delBadElems ()
    local hId, hCfg = nil, nil;
    
    if (nil == self.heros or #self.heros < 1) then
        return ;
    end
    
    for i = #self.heros, 1, -1 do
        hId = self.heros[i];
        hCfg = HeroDataProxy.getHeroCfgById(hId);
        
        if (nil == hCfg) then
            table.remove(self.heros, i);
        end
    end
end

--[[
    设置移动框停止的条件
]]
function LuckyPickCard:setSltStopCondition ()
    self.showIdx = self.showIdx + 1;
    
    if (nil == self.heros or self.showIdx > #self.heros) then
        return ;
    end
    
    LuaCallManager:invokeCall(function () 
        self.stopPos = math.random(1, 10); 
    end, 5 * const_sltgoMoveTime);
end

--[[
    播放显示英雄动画
]]
function LuckyPickCard:showPlayerAnimation ()
    local hId, hCfg = nil, nil;
    local tmpHeroGO = nil;
    
    if (1 == self.showIdx) then
        self.fullScreenPane = ViewUtil.showScreenMask();
        self.herosContainer = CreateObject(Util.LoadPrefab("UI/PaneContainer", AssetBundleInfo.assetBundles));
        HangObject(self.herosContainer, ViewUtil.getRootView());
        self:addAllPickedHeros();
    end

    LuaCallManager:invokeCall(function () 
        local endPos, beginPos = nil, Vector3.New(300, 600, 0);
        
        tmpHeroGO = self.herosGOList[self.showIdx];
        
        tmpHeroGO:SetActive(true);
        endPos = tmpHeroGO.transform.localPosition;
        tmpHeroGO.transform.localPosition = beginPos;
        iTween.MoveTo(tmpHeroGO, iTween.Hash(
            "position", endPos,
            "islocal", true,
            "time", const_heroGOMoveTime,
            "easeType", iTween.EaseType.easeOutQuad,
            "oncomplete", function () 
                local heroTmp = self.heroTabs[self.stopPos][1];
                GetPathComponent(heroTmp.transform, "BG", "UISprite").spriteName = const_heroBackSpritePre .. const_QuaAnmtVal;
                GetGameObject(heroTmp.transform, "mask"):SetActive(true);
                if (self.heros and self.showIdx < #self.heros) then
                    local info = self:stayOnHeroInfo();
                    if (not info[1]) then
                        self:setSltboxPos(1);
                        info[2] = 1;
                    end
                    self.stopPos = 0;
                    self:playerSltGOMoveAnmt(info[2]);
                    self:setSltStopCondition();
                else
                    ViewUtil.gameEventEnabled(true);
                    self:setSltboxPos(0);
                    self.sltbox:SetActive(false);
                    self.herosGOList:clear();
                    -- UIEventListener.Get(self.fullScreenPane).onClick = function () 
                    --     local ctl = ModuleManager.GetCtrl(ModuleName.LUCK);
                    --     DestroyObject(self.fullScreenPane);
                    --     DestroyObject(self.herosContainer);
                    --     HeroDataProxy.newHeroList:clear();
                    --     ctl.animating = false;
                    -- end;
                    ViewUtil.AddClickEvent(self.fullScreenPane, function () 
                        local ctl = ModuleManager.GetCtrl(ModuleName.LUCK);
                        DestroyObject(self.fullScreenPane);
                        DestroyObject(self.herosContainer);
                        HeroDataProxy.newHeroList:clear();
                        ctl.animating = false;
                    end)
                end
            end
        ));
    end, 5 * const_sltgoMoveTime);
end

--[[
    移动选中框到指定位置
    _curPos number 当前位置
]]
function LuckyPickCard:playerSltGOMoveAnmt (_curPos)
    local hero, nextPos = nil, -1;
    
    if (_curPos == self.stopPos) then
        self:showPerPumpCardAnmt(self.heroTabs[self.stopPos][1], 90, function ()
            local heroTmp = self.heroTabs[self.stopPos][1];
            local hIdTmp = self.heros[self.showIdx];
            local hCfgTmp = HeroDataProxy.getHeroCfgById(hIdTmp);
            GetPathComponent(heroTmp.transform, "BG", "UISprite").spriteName = const_heroBackSpritePre .. HeroDataProxy.getHeroQuality(hCfgTmp);
            GetPathComponent(heroTmp.transform, "Sprite", "UISprite").spriteName = HeroDataProxy.getHeroAtlasName(hCfgTmp);
            GetGameObject(heroTmp.transform, "mask"):SetActive(false);
            self:showPerPumpCardAnmt(self.heroTabs[self.stopPos][1], 0);
        end);
        self:showPlayerAnimation();
        return ;
    end
    nextPos = (_curPos + 1);
    nextPos = (nextPos > 10 and 1 or nextPos);
    hero = self.heroTabs[nextPos][1];
    tarPos = hero.transform.localPosition;
    
    iTween.MoveTo(self.sltbox, iTween.Hash(
        "position", tarPos,
        "easetype", iTween.EaseType.linear,
        "islocal", true,
        "time", const_sltgoMoveTime,
        "oncomplete", function () self:playerSltGOMoveAnmt(nextPos); end
    ));
end

--[[
    单抽的翻牌动画
    _idx number
    _val number
    _callBack
]]
function LuckyPickCard:showPerPumpCardAnmt (_go, _val, _callBack)
    iTween.RotateTo(_go, iTween.Hash(
        "y", _val,
        "islocal", true,
        "time", const_cardRotateTime,
        "oncomplete", function () 
                if (nil ~= _callBack) then
                    _callBack(); 
                end
            end
    ));
end

--[[
    判断移动框是否正好停留在某张卡片上面
    return table{boolean, number} 是否停留及停留的位置
]]
function LuckyPickCard:stayOnHeroInfo ()
    local isStay, idx = false, 0;
    local sltPos, heroPos = nil, nil;

    sltPos = self.sltbox.transform.localPosition;

    for i = 1, 10 do
        heroPos = self.heroTabs[i][1].transform.localPosition;

        if (sltPos.x == heroPos.x and sltPos.y == heroPos.y) then
            isStay = true;
            idx = i;
            break ;
        end
    end

    return {isStay, idx};
end

--[[
    将self.sltbox放到指定位置
    _pos number 
]]
function LuckyPickCard:setSltboxPos (_pos)
    local pos = _pos or 0;

    if (0 == pos) then
        self.sltbox.transform.localPosition = Vector3.zero;
    elseif (pos > 0 and pos <= 10) then
        self.sltbox.transform.localPosition = self.heroTabs[pos][1].transform.localPosition;
    end
end

--[[

]]
function LuckyPickCard:addAllPickedHeros ()
    local hId, hCfg, hero = nil, nil, nil;
    local grid = nil;
    
    self.herosGOList:clear();
    grid = GetGameObject(self.herosContainer.transform, "Grid");

    if (nil == self.heros) then
        return ;
    end
    
    for i = 1, #self.heros do
        hCfg = HeroDataProxy.getHeroCfgById(self.heros[i]);
        hero = self:getHeroGO(hCfg);
        self.herosGOList:add(hero);
    end
    
    ResetGrid(grid);
    
    for i = 1, self.herosGOList.size do
        self.herosGOList[i]:SetActive(false);
    end
end

--[[
    取英雄图片GO
]]
function LuckyPickCard:getHeroGO (_hCfg)
    local hero = nil;
    local grid = nil;
    
    grid = GetGameObject(self.herosContainer.transform, "Grid");
    hCfg = _hCfg;
    baseHero = BaseHero.new();
    baseHero:setData(hCfg);
    hero = baseHero:createHero("UI/Hero");
    HangObject(hero, grid);
--    ResetGrid(grid);
--    hero:SetActive(false);

    return hero;
end

--[[

]]
function LuckyPickCard:OnDestroy ()

end