--金币、钻石、活动抽卡 弃用
--2016-6-28 10:59:24 library

local const_pumpGold = "金币：";
local const_pumpDiamond = "钻石：";
local const_lackOfGold = "金币不足";
local const_lackOfDiamond = "钻石不足";
local const_heroBackSpritePre = "class";
local const_QuaAnmtVal = 5;

local const_cfmWords = "抽{1}次将会消耗{2}{3}";
local const_cfgOne = "一";
local const_cfgTen = "十";

LuckyPumpHero = class();

--[[

]]
function LuckyPumpHero:ctor ()
    self.gameObject = nil;
    self.transform = nil;
    self.btnEable = true;
end

--[[

]]
function LuckyPumpHero:Awake (_go, _tp)
    self.gameObject = _go;
    self.tp = _tp;--抽卡类型：1，金币；2，钻石；3，活动招募
    self.transform = self.gameObject.transform;

    self.heroTabs = List.new();
    self.multiBtns = List.new();
    self.spclHeroAnmtList = List.new();

    self.costLabel = nil;
    self.costNum = nil;

    self.heroData = nil;
    self.anmtIdx = 0;
    self.anmtMove = nil;--移动动画GO
    self.heros = nil;
    self.maskPanel = nil;--手机全屏幕遮罩
    self.spcHeroAnmt = nil;--特殊英雄动画的prefab

    self:initPanel();
end

--[[

]]
function LuckyPumpHero:initPanel ()
    local hero, heroCvtBtn, tmpTabs, multiBtn = nil, nil, nil, nil;
    local costMnyInfo = "";
    
    for i = 1, 9 do
        hero = GetGameObject(self.transform, "heroPanel/Hero_" .. (i - 1));
        heroCvtBtn = GetGameObject(self.transform, "heroPanel/heroGet_" .. (i - 1));
        tmpTabs = {hero, heroCvtBtn};
        self.heroTabs:add(tmpTabs);
    end

    multiBtn = GetGameObject(self.transform, "oneBtn");
    self.multiBtns:add(multiBtn);
    multiBtn = GetGameObject(self.transform, "tenBtn");
    self.multiBtns:add(multiBtn);

    self.costLabel = GetGameObject(self.transform, "costLabel");
    self.costNum = GetGameObject(self.transform, "costNum");

    if (1 == self.tp) then
        costMnyInfo = const_pumpGold;
    elseif (2 == self.tp) then
        costMnyInfo = const_pumpDiamond;
    end

    GetComponent(self.costLabel, "UILabel").text = costMnyInfo;
    GetComponent(self.costNum, "UILabel").text = GameCfgDataProxy.getLuckyPickupCostByType(self.tp);
end


--[[
    _data 英雄数据
    return nil
]]
function LuckyPumpHero:setHeroData (_data)
    self.heroData = _data;
end

--[[
    显示卡片--英雄被覆盖
    return nil
]]
function LuckyPumpHero:showCards ()
    local multiBtn, hero, heroBtn = nil, nil, nil;
    local heroPos = nil;
    local perHData, hCfgData = nil, nil;
    
    for i = 1, self.multiBtns:getSize() do
        multiBtn = self.multiBtns[i];
        multiBtn:SetActive(true);
        ViewUtil.AddButtonClickEvent(multiBtn, function () self:pumpCard(i); end);
    end
    
    for i = 1, self.heroTabs:getSize() do
        hero = self.heroTabs[i][1];
        heroBtn = self.heroTabs[i][2];
        heroBtn:SetActive(false);
        GetGameObject(hero.transform, "mask"):SetActive(true);
        GetPathComponent(hero.transform, "BG", "UISprite").spriteName = const_heroBackSpritePre .. "6";
--        ViewUtil.RemoveButtonClickEvent(hero);
        -- UIEventListener.Get(hero).onClick = doNthFunc;
        ViewUtil.AddClickEvent(hero, doNthFunc)

        if (i > 5) then
            heroPos = hero.transform.localPosition;
            hero.transform.localPosition = Vector3.New(heroPos.x, -276, heroPos.z);
        end
    end
end

--[[
    抽卡
    _idx number 1，抽一次；2，抽10次
    return nil
]]
function LuckyPumpHero:pumpCard (_idx)
    local pNum, pId, costNum = 0, 0, 0;
    local errMsg = "";
    local ctl = nil;

    _idx = _idx or 1;

    if (1 == self.tp) then
        pNum = PlayerData.getMyGold();
    elseif (2 == self.tp) then
        pNum = PlayerData.getMyDiamond();
    end
    costNum = GameCfgDataProxy.getLuckyPickupCostByType(self.tp) * ((2 == _idx) and 10 or 1);
    if (pNum < costNum) then
        if (1 == self.tp) then
            errMsg = const_lackOfGold;
        elseif (2 == self.tp) then
            errMsg = const_lackOfDiamond;
        end
        ViewUtil.showMsg(errMsg);
        return ;
    end
    
    local function okFunc ()
        local sendMsg = Map.new();
	    sendMsg:put("type", self.tp + (_idx - 1) * 2);--1，金币；2，钻石；3，金币十连抽；4，钻石十连抽
	    local buffer = Network.reqParamEncode(sendMsg);
    
        ctl = ModuleManager.GetCtrl(ModuleName.LUCK);
        ctl.animating = true;
        NetManager:SendData(self, buffer, ServerID.Lucky_MnyConvert, nil, function (sd) self:pumpBack(_idx, sd); end, "", doNthFunc);
    end

    cfmWords = string.gsub(const_cfmWords, "{1}", ((2 == _idx) and const_cfgTen or const_cfgOne));
    cfmWords = string.gsub(cfmWords,"{2}", ((1 == self.tp) and const_pumpGold or const_pumpDiamond));
    cfmWords = string.gsub(cfmWords,"{3}", costNum);
    ViewUtil.comCfmPanel(cfmWords, okFunc);
end

--[[
    _idx number 1，单抽；2，十连抽
    sd SessionData 抽卡回包数据
    return nil
]]
function LuckyPumpHero:pumpBack (_idx, sd)
    local defData = nil;
    local anmtGet = nil;--英雄动画
    
    defData = GetProtoTable("DefaultData", sd);
    
    self.heros = StrSplit(defData.msg, ",");
    if (nil == self.maskPanel) then
        self.maskPanel = ViewUtil.showScreenMask(nil, nil, nil, 1);
    end
    if (1 == _idx) then
        local heroPanelTmp = GetGameObject(self.transform, "heroPanel");
        self.anmtIdx = math.random(2, 10);--特效展示，从2开始比较好看
        self.anmtMove = CreateObject(Util.LoadPrefab("UI/ui_zhaomu03", AssetBundleInfo.assetBundles));
        self.anmtMove:SetActive(true);
        HangObject(self.anmtMove, heroPanelTmp);
        self.anmtMove.transform.localPosition = self.heroTabs[1][1].transform.localPosition;
        self:perPumpAnmt(self.anmtMove, 1);
        ViewUtil.sortLayerOrder(self.anmtMove, LayerName.UI);
    elseif (2 == _idx) then
        for i = 1, #self.heros do
            self:showPerPumpCardAnmt(i, 90, function () 
                self:showPerPumpHero(i, self.heroTabs[i][1]);
                self:showHerosAfterPump(i, i);
                if (1 == i) then
                    self:addFullMaskEvt();
                end;
            end);
        end
    end
end

--[[
    单抽时的移动动画
    _go 被移动的GO
    _idx 当前移动位置
    return nil
]]
function LuckyPumpHero:perPumpAnmt (_go, _idx)
    local tarPos = nil;
    
    if (_idx < self.anmtIdx) then
        _idx = _idx + 1;
        
        tarPos = self.heroTabs[_idx][1].transform.localPosition;
        iTween.MoveTo(_go, iTween.Hash(
            "position", tarPos,
            "easetype", iTween.EaseType.linear,
            "islocal", true,
            "time", 0.1,
            "oncomplete", function () self:perPumpAnmt(_go, _idx); end
        ));
    else 
        self:showPerPumpCardAnmt(self.anmtIdx, 90, function () 
            self:showPerPumpHero(self.anmtIdx, self.anmtMove); 
            self:showHerosAfterPump(1, self.anmtIdx);
            self:addFullMaskEvt();
        end);
    end
end

--[[
    单抽的翻牌动画
    _idx number
    _val number
    _callBack
]]
function LuckyPumpHero:showPerPumpCardAnmt (_idx, _val, _callBack)
    iTween.RotateTo(self.heroTabs[_idx][1], iTween.Hash(
        "y", _val,
        "islocal", true,
        "time", 1,
        "oncomplete", function () 
                if (nil ~= _callBack) then
                    _callBack(); 
                end
            end
    ));
end

--[[
    单抽的翻牌后英雄展示动画
]]
function LuckyPumpHero:showPerPumpHero (_idx, _go)
    local anmtMove = CreateObject(Util.LoadPrefab("UI/ui_zhaomu04", AssetBundleInfo.assetBundles));

    self:showPerPumpCardAnmt(_idx, 0);

    anmtMove:SetActive(true);
    HangObject(anmtMove, _go);
	ViewUtil.sortLayerOrder(anmtMove, LayerName.Dialog)
    anmtMove.transform.localPosition = Vector3.New(0, 0, 1);
    DestroyObject(anmtMove, 2);
end

--[[
    显示英雄
    _valIdx number
    _goIdx number
    return ;
]]
function LuckyPumpHero:showHerosAfterPump (_valIdx, _goIdx)
    local heroCfg, heroQua, anmtTmp = nil, 0, nil;
    
    if (nil ~= self.heros) then
        heroCfg = HeroDataProxy.getHeroCfgById(tonumber(self.heros[_valIdx]));
        heroQua = HeroDataProxy.getHeroQuality(heroCfg);
        GetGameObject(self.heroTabs[_goIdx][1].transform, "mask"):SetActive(false);
        GetPathComponent(self.heroTabs[_goIdx][1].transform, "Sprite", "UISprite").spriteName = HeroDataProxy.getHeroAtlasName(heroCfg);
        GetPathComponent(self.heroTabs[_goIdx][1].transform, "BG", "UISprite").spriteName = const_heroBackSpritePre .. HeroDataProxy.getHeroQuality(heroCfg);
        
        if (heroQua >= const_QuaAnmtVal) then
            if (nil == self.spcHeroAnmt) then
                self.spcHeroAnmt = Util.LoadPrefab("UI/ui_zhaomu05", AssetBundleInfo.assetBundles);
            end
            anmtTmp = CreateObject(self.spcHeroAnmt);
            self.spclHeroAnmtList:add(anmtTmp);
            anmtTmp:SetActive(true);
            HangObject(anmtTmp, self.heroTabs[_goIdx][1]);
			ViewUtil.sortLayerOrder(anmtTmp, LayerName.Dialog)
            anmtTmp.transform.localPosition = Vector3.New(0, 0, 1);
            anmtTmp.name = "hero_inner_anmt";
        end
    end
--    ComControler.ShadowEvt(function ()
--        self:addFullMaskEvt();
--    end);
end

--[[
    全屏遮罩事件控制
    return nil
]]
function LuckyPumpHero:addFullMaskEvt ()
    if (nil ~= self.maskPanel) then
        ViewUtil.AddButtonClickEvent(self.maskPanel, function () 
            
            DestroyObject(self.maskPanel);
            self.maskPanel = nil;
            self:OnDestroy();
        end);
    end
end

--[[

]]
function LuckyPumpHero:OnDestroy ()
    local hero, hero_inner_anmt, maskTmp = nil, nil, nil;
    local ctl = nil;
    
    if (nil ~= self.anmtMove) then
        DestroyObject(self.anmtMove);
    end

    for i = 1, #self.heroTabs do
        hero = self.heroTabs[i][1];
        GetPathComponent(self.heroTabs[i][1].transform, "BG", "UISprite").spriteName = const_heroBackSpritePre .. "5";
        hero_inner_anmt = GetGameObject(hero.transform, "hero_inner_anmt");
        maskTmp = GetGameObject(hero.transform, "mask");
        if (nil ~= hero_inner_anmt) then
            DestroyObject(hero_inner_anmt);
        end
        if (nil ~= maskTmp) then
            maskTmp:SetActive(true);
        end
    end

    ctl = ModuleManager.GetCtrl(ModuleName.LUCK);
    ctl.animating = false;
    ViewUtil.showNewHeros();
end