require "Game/MonthCard/View/MonthCardView"
 
MonthCardControler = {}

local this = MonthCardControler

function MonthCardControler.New()
	return this
end

function MonthCardControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = MonthCardView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	this.request()
end

function MonthCardControler.Awake()
end

function MonthCardControler.Start()

end

function MonthCardControler.Update()
end

function MonthCardControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function MonthCardControler.initListener()
end

function MonthCardControler.listNotificationInterests()
    
end

function MonthCardControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function MonthCardControler.request()
	Network.SendMoData(ServerID.MonthCard_Ety, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("DefaultData", session)
		this.accept(mo)
	end, {})
end

function MonthCardControler.accept(data)
	ViewUtil.initData(this, data)
end
