require "Game/MyHero/View/MyHeroView"
 
MyHeroControler = {}

local this = MyHeroControler

function MyHeroControler.New()
	return this
end

function MyHeroControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = MyHeroView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function MyHeroControler.Awake()
end

function MyHeroControler.Start()
	this.view:Start(this.data)
end

function MyHeroControler.Update()
end

function MyHeroControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function MyHeroControler.initListener()
end

function MyHeroControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA, MVCConst.HERO_SORTCHOSENOTE}
    return unpack(list)
end

function MyHeroControler.handleNotification(notification)
    local nName = notification:getName()
    local nBody = notification:getBody()
	local isChge = false

    if nName ==MVCConst.HERO_SORTCHOSENOTE then
		this.view:sortHeroListNow(tonumber(nBody[1]), tonumber(nBody[2]))
    end
end

--function MyHeroControler.accept(data)
--	ViewUtil.initData(this, data)
--end
