--背包通用存储
--2016-7-9 11:10:55 library

PropCusData = class();

--[[

]]
function PropCusData:ctor ()
    self.propsData = nil;

    self.idx = 0;
end

--[[
    idx 存储的道具类型
]]
function PropCusData:Awake (_idx)
    self.idx = _idx;
end

--[[

]]
function PropCusData:Start ()
    self:initData();
end

--[[

]]
function PropCusData:initData ()
--    if (1 == self.idx) then
--        --暂时显示所有道具
--        self.propsData = PropDataProxy.getMyPropsByType(0);
--    else
--        self.propsData = PropDataProxy.getMyPropsByType(self.idx);
--    end
    self.propsData = PropDataProxy.getMyPropsByType(self.idx);
    self:sortPropsData();
    --背包数据相同道具数量叠加，不需要再进行分组，id、endTime不同的不叠加，分开显示
    --2016-8-21 12:16:38 library modify
--    self:setPropsData();
end

--[[
    对List排序
    根据propId、endTime从小到大排序
    return nil
]]
function PropCusData:sortPropsData ()
    local pDataFir, pDataSec = nil, nil;

    for i = 1, self.propsData:getSize() do
        pDataFir = self.propsData[i];
        for j = i + 1, self.propsData:getSize() do
            pDataSec = self.propsData[j];
            if (pDataFir.propId > pDataSec.propId) then
                self.propsData[i] = self.propsData[j];
                self.propsData[j] = pDataFir;
                pDataFir = self.propsData[i];
            elseif (pDataFir.propId == pDataSec.propId) then
                if (pDataFir.endTime > pDataSec.endTime) then
                    self.propsData[i] = self.propsData[j];
                    self.propsData[j] = pDataFir;
                    pDataFir = self.propsData[i];
                end
            end
        end
    end
end

--[[
    将道具数据按照PropId分组
    方便背包中显示数量
    return 
]]
function PropCusData:setPropsData ()
    local pCur, pPre, tmpList, perList = nil, nil, List.new(), nil;
    
    for i = 1, self.propsData:getSize() do
        pCur = self.propsData[i];

        if (nil == pPre or pPre.propId ~= pCur.propId) then
            perList = List.new();
            perList:add(pCur);
            tmpList:add(perList);
        else
            tmpList[tmpList:getSize()]:add(pCur);
        end

        pPre = pCur;
    end

    self.propsData = tmpList;
end

