require "Game/Role/View/RoleView"
 
RoleControler = {}

local this = RoleControler

function RoleControler.New()
	return this
end

function RoleControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = RoleView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()

	this.request()
end

function RoleControler.Awake()
end

function RoleControler.Start()
	this.view:Start()
end

function RoleControler.Update()
	this.view:Update()
end

function RoleControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function RoleControler.initListener()
end

function RoleControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function RoleControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function RoleControler.request()
end

function RoleControler.accept(data)
	ViewUtil.initData(this, data)
end
