require "Game/Space/View/SpaceView"
 
SpaceControler = {}

local this = SpaceControler

function SpaceControler.New()
	return this
end

function SpaceControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = SpaceView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function SpaceControler.Awake()
end

function SpaceControler.Start()
	this.view:Start(this.data)
end

function SpaceControler.Update()
end

function SpaceControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function SpaceControler.initListener()
end

function SpaceControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function SpaceControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function SpaceControler.accept(data)
	ViewUtil.initData(this, data)
end
