
TreasureView = class(BaseView)

 function TreasureView:ctor()
end  

function TreasureView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
end

function TreasureView:Start(data)
	self.sw = 1
	self:initData(data)
end

function TreasureView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local bottomPath = "Mode/Bottom/Panel/"
 	self.btnBack = GetGameObject(self.transform, bottomPath.."BtnBack")
	
    local function doClick(obj)
		if obj == self.btnBack then
			self:closeView(true)
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
end

function TreasureView:initData(data)
	if IsEmpty(data) then return end
end
