--礼上加礼活动条件基类
--2016-11-22 00:00:00 iorinie

ActExchangeContentBaseBar = class();

--[[

]]
function ActExchangeContentBaseBar:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

--[[

]]
function ActExchangeContentBaseBar:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.propBase = nil;
    -- self.propBtn = nil
    self.grid = nil;
    self.condition = nil;
    self.progress = nil;
    self.btn = nil;
    self.complete = nil;


    self.state = 0;--当前按钮状态
    self.data = nil;--tab
    self.btnClickCallBack = nil;--function

    self:initPanel();
    self:initListener();
end

--[[

]]
function ActExchangeContentBaseBar:initPanel ()
    self.grid = GetGameObject(self.transform, "Scroll View/Panel/Grid");
    self.propBase = GetGameObject(self.grid.transform, "PropItemNPBase");
    -- self.propBtn = GetGameObject(self.grid.transform, "PropItemBtn")
    self.btn = GetGameObject(self.transform, "BtnObtain");
    
    self.conditionSpr = GetPathComponent(self.transform, "Condition/Prop1", "UISprite");
    self.progress = GetGameObject(self.transform, "Progress");
    self.complete = GetGameObject(self.transform, "complete");
end

--[[

]]
function ActExchangeContentBaseBar:initListener ()
    -- UIEventListener.Get(self.btn).onClick = function ()
    --     if (nil ~= self.btnClickCallBack) then
    --         self.btnClickCallBack(self.data);
    --     end
    -- end
    ViewUtil.AddClickEvent(self.btn, function ()
        if (nil ~= self.btnClickCallBack) then
            self.btnClickCallBack(self.data);
        end
    end)
end

--[[

]]
function ActExchangeContentBaseBar:setCondition (_id)
    self.conditionSpr.spriteName = tostring(_id)
end

--[[

]]
function ActExchangeContentBaseBar:setProgress (_str)
    GetComponent(self.progress, "UILabel").text = _str;
end

--[[
    _data table 当前条的基础信息
    _btnCallBack 按钮事件回调
]]
function ActExchangeContentBaseBar:setData (_data, _btnCallBack)
    self.data = _data;
    self.btnClickCallBack = _btnCallBack;

    self:showProps();
end

--[[

]]
function ActExchangeContentBaseBar:showProps ()
    local propShowItem, propTab, propTmp = nil, nil, nil;
    
    for i = 1, #self.data[3] do
        propTab = self.data[3][i];
        propTmp = CreateObject(self.propBase);
        propTmp:SetActive(true);
        propShowItem = ActPropShow.new();
        propShowItem:Awake(propTmp, propTab[1], propTab[2]);
        propShowItem:Start();
        -- propTmp = CreateObject(self.propBtn)
        -- propTmp:SetActive(true)
        -- local cfg = HeroDataProxy.getHeroCfgById(propTab[1])
        -- GetComponent(propTmp.transform, "UIButton").normalSprite = HeroDataProxy.getHeroAtlasName(cfg)
        local pCfg = HeroDataProxy.getHeroCfgById(propTab[1])
        GetPathComponent(propTmp.transform, "BG", "UISprite").spriteName = "class"..HeroDataProxy.getHeroQuality(pCfg)
        HangObject(propTmp, self.grid);
    end

    ResetGrid(self.grid);
end

--[[
    设置按钮的状态
]]
function ActExchangeContentBaseBar:setBtn ()
    if (0 == self.state) then
        self.btn:SetActive(true);
        self.complete:SetActive(false);
    else
        self.btn:SetActive(false);
        self.complete:SetActive(true);
    end
end