
local this = LoginConst;

LoginConst = {
	--当前app的大版本
	appVersion = "1",
	--安装包的StreamingAssets/nbaDll.dlls版本号
	installDllVerison = "10",
	--安装包的登录背景版本号
	installBgVerison = "1",
	--安装包的资源版本号
	installSourceVerison = "1_0",
	--版本文件名
	versionFileName = "version.php",
	--代码dll文件名
	dll_Name = "nbaDll.dll",
	--登录界面背景名
	loginbgfilename = "login_bg.png",
	--资源更新列表文件名
	loginupdateVersion = "login_updateVersion",
	--本地服务器列表更新时间
	sververs_update_time = "login_sververs_update_time",
	--本地公告更新时间
	notice_update_time = "notice_update_time",
	--本地dll版本
	dll_version = "login_dll_version",
	--本地资源版本
	source_version = "login_source_version",
	--本地登录界面背景版本
	login_bg_version = "login_bg_version",
	--本地登录界面背景音乐开关
	music_enable = "g_TEAM_MUSIC", --对应DataManager.TEAM_MUSIC
	--是否在登录时播放CG
	
	--本地默认账号
	default_name = "login_default_name",
	--本地球队等级
	team_level = "g_TEAM_LEVEL", --DataManager.TEAM_LEVEL,
}

function LoginConst.GetCacheDir()
	if GameManager.DevicePlatform() == "ios" or GameManager.DevicePlatform() == "android" then
		return "/loginCache/";
	else 
		return "/cache/loginCache/";
	end	
end	

function LoginConst.GetPlatFormDir()
	if GameManager.DevicePlatform() == "ios" then
		return "/IOS/";
	elseif GameManager.DevicePlatform() == "android" then
		return "/And/";
	else 
		return "/Win/";
	end 	
end	