
LeagueData = {}
local this = LeagueData

MemberClass =
{
	"Normal",
	"Normal2",
	"Normal3",
	"Normal4",
	"Captain", -- 5:ų
}
MemberClass = EnumGenerator(MemberClass)

this.data = {}
this.myClass = MemberClass.Normal -- ׼

function LeagueData.New()
	return this
end

function LeagueData.Init(teamData)
	if IsEmpty(teamData) then return end
	this.data = teamData
end

function LeagueData.GetLeagueBadgeId()
	if IsEmpty(this.data) then return 0 end
	return this.data.league.logoId or 0
end

function LeagueData.GetLeagueBadgeLevel()
	if IsEmpty(this.data) then return 0 end
	return this.data.league.logoLevel or 0
end

function LeagueData.GetLeagueFunds()
	if IsEmpty(this.data) then return 0 end
	return this.data.league.gold or 0
end

-- ȡǰû׼
function LeagueData.GetMyClass()
	return this.myClass
end

-- ȡǰû׼
function LeagueData.SetMyClass(level)
	if IsMember(level, MemberClass) then
		this.myClass = level
	end
end

-- жǷų
function LeagueData.IsCaptain()
	if this.myClass == MemberClass.Captain then
		return true
	end
	return false
end
