--签到数据
--2016-8-27 11:18:06 library

SignInDataProxy = {
    signInCfg = {
        {"Sign_Total_Gift_1_Drop", 2}, 
        {"Sign_Total_Gift_2_Drop", 5}, 
        {"Sign_Total_Gift_3_Drop", 10}, 
        {"Sign_Total_Gift_4_Drop", 17}, 
        {"Sign_Total_Gift_5_Drop", 26}, 
    };
};

local this = SignInDataProxy;

--[[
    签到累计天数的对应奖励
    _sumIdx 累计签到索引
    return string 
]]
function SignInDataProxy.getSumSignRwd (_sumIdx)
    local rwd = "";
    local dropTable = nil;
    local perTable, propId, num = nil, 0, 0;

    _sumIdx = _sumIdx or 1;
    dropTable = GameCfgDataProxy.getDropValueByName(this.signInCfg[_sumIdx][1]);

    for i = 1, #dropTable do
        perTable = dropTable[i];
        propId = GameCfgDataProxy.getPropId(perTable);
        num = GameCfgDataProxy.getMinNum(perTable);
        rwd = rwd .. "," .. propId .. ":" .. num;
    end

    rwd = rwd or "";
    
    return rwd;
end