
ChannelName = {
	[0] = "FTX",			-- 无第三方SDK母包
	[1] = "YYH",			-- 应用汇
	[2] = "UC",			-- 九游UC
	[3] = "MI",	-- 小米
	[4] = "360",			-- 360
    [5] = "HUAWEI",               -- 华为
}

Global = {
-------------------------------- 打包时必改选项 --------------------------------
	isRelease =  true,										-- 内网测试为: false，外网包为: true
	chIndex = 2,												-- 渠道名下标，在上面的ChannelName类可以查询下标
	openGuide =  true,									-- 打开新手引导
	isSDKLogin =  true,									-- 是否SDK登录
	showLog = false,										-- 是否显示日志: false
	showNetLog = false,									-- 是否显示网络日志: false
---------------------------------------------------------------------------------

	showErrorOnScreen = false,					-- 是否显示错误在屏幕
	showFrameRate = false,							-- 是否显示帧率
	isLocal = false,											-- 本地不联网: true
	localLang = Language.SimpleChinese,	-- 本地化语言
}

function Global.Init()
	Const.isRelease = Global.isRelease and true or false
	GameDefine.ShowLog = Global.showLog and true or false
	GameDefine.ShowNetLog = Global.showNetLog and true or false
	Const.showErrorOnScreen = Global.showErrorOnScreen and true or false
	Const.showFrameRate = Global.showFrameRate and true or false
end

function Global.Reset()
    GameDefine.initData = false;				-- 是否初始化用户数据
    GameDefine.GameInited = false;		-- 是否初始化好资源
    GameDefine.EnterGame = false;			-- 进入了游戏登录后的第一个场景
    GameDefine.IsLossLogined = false;
    GameDefine.UpdateVersion = "";
end
