--轻信息本地缓存
--2016-8-4 17:55:17 library

SimpleCache = {
    soundBtn = "soundBtn",
    soundBG = "soundBG",

    --选服信息
    serverName1 = "serverName1",
    serverId1 = "serverId1",
    serverIp1 = "serverIp1",
    serverName2 = "serverName2",
    serverId2 = "serverId2",
    serverIp2 = "serverIp2",
    serverName3 = "serverName3",
    serverId3 = "serverId3",
    serverIp3 = "serverIp3",

    --简易引导
    simpleCacheFBPkFail = "fbPkFail",
    simpleCacheFBMidCard = "fbMidCard",
    simpleCacheFBHardCard = "fbHardCard",
    simpleCacheExplore = "explore"
};

local this = SimpleCache;

--[[
    根据key取缓存的值
]]
function SimpleCache.getCacheVal (key, _tp)
    local val = nil;

    key = PlayerData.GetRoleTeamId() .. "_" .. key;

    _tp = _tp or 0;
    if (0 == _tp) then
        val = PlayerPrefs.GetString(key, "1");
    elseif (1 == _tp) then
        val = PlayerPrefs.GetFloat(key, 0.0);
    elseif (2 == _tp) then
        val = PlayerPrefs.GetInt(key, 0);
    end
    
    return val;
end

--[[

]]
function SimpleCache.setCache (_key, _val, _tp)
    _tp = _tp or 0;
    _key = PlayerData.GetRoleTeamId() .. "_" .. _key;
    
    if (0 == _tp) then
        val = PlayerPrefs.SetString(_key, _val);
    elseif (1 == _tp) then
        val = PlayerPrefs.SetFloat(_key, _val);
    elseif (2 == _tp) then
        val = PlayerPrefs.SetInt(_key, _val);
    end
end

--[[
    根据key取缓存的值，不带用户ID，用于登录页存取服务器信息，首次登录无法取得用户ID。 by iorinie
]]
function SimpleCache.getCacheValWithoutID (key, _tp)
    local val = nil;

    _tp = _tp or 0;
    if (0 == _tp) then
        val = PlayerPrefs.GetString(key, "1");
    elseif (1 == _tp) then
        val = PlayerPrefs.GetFloat(key, 0.0);
    elseif (2 == _tp) then
        val = PlayerPrefs.GetInt(key, 0);
    end
    
    return val;
end

--[[

]]
function SimpleCache.setCacheWithoutID (_key, _val, _tp)
    _tp = _tp or 0;
    
    if (0 == _tp) then
        val = PlayerPrefs.SetString(_key, _val);
    elseif (1 == _tp) then
        val = PlayerPrefs.SetFloat(_key, _val);
    elseif (2 == _tp) then
        val = PlayerPrefs.SetInt(_key, _val);
    end
end