--通用商城
--2016-10-31 15:30:21 library

local const_title = "兑换奖励";

local const_suipian = 1061;
local const_xunzhang = 1062;

ComShopPane = class();

--[[

]]
function ComShopPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

--[[

]]
function ComShopPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.listData = nil;
    self.closeCallBack = nil;
    self.buyCallBack = nil;
    
    self.title = GetGameObject(self.transform, "title");
    self.own_xunzhang = GetGameObject(self.transform, "mny/own_xunzhang");
    self.own_suipian = GetGameObject(self.transform, "mny/own_suipian");
    self.sv = GetGameObject(self.transform, "ScrollView");
    self.grid = GetGameObject(self.sv.transform, "Panel/Grid");
    self.heroRowBase = GetGameObject(self.grid.transform, "HeroBarBase");
    self.closeBtn = GetGameObject(self.transform, "closeBtn");
    
    self:initPanel();
    self:initListener();
end

--[[

]]
function ComShopPane:initPanel ()
    GetComponent(self.title, "UILabel").text = const_title;
    self:showMyMny();
end

--[[

]]
function ComShopPane:initListener ()
    UIEventListener.Get(self.closeBtn).onClick = function ()
        if (self.callBackFunc) then
            self.closeCallBack();
        end
        DestroyObject(self.gameObject);

        if (PlayerData.guideNotEnd()) then
            Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
        end
    end
end

--[[

]]
function ComShopPane:setData (_data, _closeCallBack, _buyCallBack)
    self.listData = _data;
    self.closeCallBack = _closeCallBack;
    self.buyCallBack = _buyCallBack;

    self:showHeroRows();
end

--[[

]]
function ComShopPane:showMyMny ()
    local pNum = PropDataProxy.getPropNumByPropId(const_suipian);

    GetComponent(self.own_suipian, "UILabel").text = "" .. pNum;
    pNum = PropDataProxy.getPropNumByPropId(const_xunzhang);
    GetComponent(self.own_xunzhang, "UILabel").text = "" .. pNum;
end

--[[

]]
function ComShopPane:showHeroRows ()
    local data, heroRowTmp, cshRow = nil, nil, nil;

    for i = 1, #self.listData do
        data = self.listData[i];
        heroRowTmp = CreateObject(self.heroRowBase);
        HangObject(heroRowTmp, self.grid);
        heroRowTmp:SetActive(true);
        cshRow = ComShopHeroRow.new();
        cshRow:Awake(heroRowTmp, self);
        cshRow:setData(data.propId, data.honor, data.medal);
        PanelManager:BindPanelScript(cshRow, heroRowTmp, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end
    ResetScrollView(self.sv);
    ResetGrid(self.grid);
end