UILang = { };

local this = UILang;

local textString = nil;

local strings = Map.new();

function UILang.init(str)  
	textString = str;

	local texts = StrSplit(textString , "\n");
    if texts ~= nil and #texts > 0 then
    	
    	for i = 1 , #texts do
    		
    		local text = texts[i];
         
            local strs = StrSplit(text , "=");

            if strs ~= nil and #strs >= 2 then
                strings:put(Trim(strs[1]), Trim(Replace(strs[2], "\\n", "\n")));
            end
        end
    end
end	

function UILang.FormatUIString(key , ...)
	local str = String.Empty;
    return String.Format(strings[key], ...);
end	