require "Game/Common/List"

UpdateHelper = {}

UpdateHelper.updateFunctionList = List.new()

local this = UpdateHelper

function UpdateHelper.addUpdate(func)
	if not func then return end
	if not IsMember(func, this.updateFunctionList, true) then
		this.updateFunctionList:add(func)
	end
end

function UpdateHelper.removeUpdate(func)
	if not func then return end
    this.updateFunctionList:remove(func)
end
