--地图预设管理器
--2016-7-25 10:09:03 library

local const_BGName = "";
local const_DecorateName = "";
local const_SquareName = "ExploreSquare";
local const_NPCName = "";
local const_HeroName = "ExplorePlayer";
local const_LuoYangchanName = "Effects/Explore/Explore_LuoYangChanAnmt";
local const_TimeBar = "ExploreTimeBar";
local const_Rsrcs = "ExplorePropItem";

ExplorePrefabMgr = {
    --背景sprite
    bgPre = nil;

    --第二层元素的预设
    decoratePre = nil;

    --单元格
    squarePre = nil;

    --NPC
    npcPre = nil;

    --hero
    heroPre = nil;

    --洛阳铲
    luoYangchan = nil;

    --资源
    rsrcs = nil;
};

local this = ExplorePrefabMgr;

--[[
    地图的背景
]]
function ExplorePrefabMgr.getBG ()
    if (nil == this.bgPre) then
        this.bgPre = Util.LoadPrefab("UI/" .. const_BGName, AssetBundleInfo.assetBundles);
    end

    return CreateObject(this.bgPre);
end

--[[
    树木、沙滩等元素
]]
function ExplorePrefabMgr.getDecorate ()
    if (nil == this.decoratePre) then
        this.decoratePre = Util.LoadPrefab("UI/" .. const_DecorateName, AssetBundleInfo.assetBundles);
    end

    return CreateObject(this.decoratePre);
end

--[[
    地图的单元格
]]
function ExplorePrefabMgr.getSquare ()
    if (nil == this.squarePre) then
        this.squarePre = Util.LoadPrefab("UI/" .. const_SquareName, AssetBundleInfo.assetBundles);
    end

    return CreateObject(this.squarePre);
end

--[[
    NPC
]]
function ExplorePrefabMgr.getNPC ()
    if (nil == this.npcPre) then
        this.npcPre = Util.LoadPrefab("UI/" .. const_NPCName, AssetBundleInfo.assetBundles);
    end

    return CreateObject(this.npcPre);
end

--[[
    玩家
]]
function ExplorePrefabMgr.getHero ()
    if (nil == this.heroPre) then
        this.heroPre = Util.LoadPrefab("UI/" .. const_HeroName, AssetBundleInfo.assetBundles);
    end
    
    return CreateObject(this.heroPre);
end

--[[
    洛阳铲
]]
function ExplorePrefabMgr.getLuoYangchan ()
    if (nil == this.luoYangchan) then
        --this.luoYangchan = Util.LoadPrefab("Effects/Explore/" .. const_LuoYangchanName);
        this.luoYangchan = Util.LoadPrefab(const_LuoYangchanName, AssetBundleInfo.assetBundles);
    end

    return CreateObject(this.luoYangchan);
end

--[[
    时间条
]]
function ExplorePrefabMgr.getTimeBar ()
    if (nil == this.timeBar) then
        this.timeBar = Util.LoadPrefab("UI/" .. const_TimeBar, AssetBundleInfo.assetBundles);
    end

    return CreateObject(this.timeBar);
end

--[[

]]
function ExplorePrefabMgr.getExploreRsrcs ()
    if (nil == this.rsrcs) then
        this.rsrcs = Util.LoadPrefab("UI/" .. const_Rsrcs, AssetBundleInfo.assetBundles);
    end

    return CreateObject(this.rsrcs);
end