--奖励领取条
--2016-7-30 09:10:48 library

local const_totalInfoWord = "已累积";
local const_buJi = "补给：";
local const_getRwdTips = "获得了";
local const_per = "个";
local const_second = "秒";
local const_timeNotEnd = "倒计时尚未结束";
local const_timeCount = "倒计时";

ExploreGetRwdRow = class();

--[[

]]
function ExploreGetRwdRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.rwdItem = nil;
    self.itemDesc = nil;
    self.upTxt = nil;
    self.totalInfo = nil;
    self.totalVal = nil;
    self.getBtn = nil;
    self.buJiInfo = nil;
    self.buJiWord = nil;

    self.rPanel = nil;--ExploreRwdPanel
    self.gift = nil;--ArcTeamGiftData
    self.pCfg = nil;--道具Cfg
    self.tp = 0;--类型 0，可累计重复领奖；1，单次领奖
    self.isRemove = false;

    self.beginTime = 0;--创建条目时的游戏运行时间 秒
    self.curTime = 0;--当前的游戏运行时间 秒
    self.addDelta = 0;--增加的数量
end

--[[

]]
function ExploreGetRwdRow:Awake (_go, _rPanel)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.rPanel = _rPanel;
    self.beginTime = Time.time;
end

--[[

]]
function ExploreGetRwdRow:Start ()
    self:initPanel();
    self:addListener();
end

--[[
    计时更新
]]
function ExploreGetRwdRow:Update ()
    if (0 == self.tp) then
        self.curTime = Time.time;
        if (self.curTime - self.beginTime - self.addDelta - 1 > 0) then
            self.addDelta = self.addDelta + 1;
            self.gift.num = self.num + 1;
            self:drawRow();
        end
    else
        if (self.gift.second > 0) then
            self.gift.second = self.gift.second - Time.deltaTime / 1000;
            self:drawRow(1);
        end
    end
end

--[[

]]
function ExploreGetRwdRow:initPanel ()
    self.rwdItem = GetGameObject(self.transform, "RwdItem");
    self.itemDesc = GetGameObject(self.transform, "ItemDesc");
    self.upTxt = GetGameObject(self.transform, "UpTxt");
    self.totalInfo = GetGameObject(self.transform, "TotalInfo");
    self.totalVal = GetGameObject(self.transform, "TotalVal");
    self.getBtn = GetGameObject(self.transform, "GetBtn");
    self.buJiInfo = GetGameObject(self.transform, "buJiInfo");  
    self.buJiWord = GetGameObject(self.transform, "buJiWord");  
end

--[[

]]
function ExploreGetRwdRow:addListener ()
    ViewUtil.AddClickEvent(self.getBtn, function () self:getRwdHandle(); end)
end

--[[

]]
function ExploreGetRwdRow:getRwdHandle ()
    local mapData, buf = Map.new(), nil;

    mapData:put("propId", self.gift.propId);
    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.ExploreGetRwd, nil, function (sd) self:getRwdSuccess(sd) end, "", doNthFunc);
end

--[[

]]
function ExploreGetRwdRow:getRwdSuccess (sd)
    local def, sts, State = nil, nil, nil;
    local pName = PropDataProxy.getPropName(self.pCfg);

    def = GetProtoTable("ArcMapPoinData", sd);

    if (0 < def.second) then
        ViewUtil.showMsg(const_timeNotEnd);
        return ;
    end

    ViewUtil.showMsg(const_getRwdTips .. self.gift.num .. const_per .. pName);
    
    if (0 == self.tp) then
        self.gift.num = 0;
        self.gift.second = 0;
        self.curTime = Time.time;
        self.beginTime = self.curTime;
        self:drawRow();
    else
        ViewUtil.AddClickEvent(self.getBtn, nil)
        --删除本条目
        self.isRemove = true;
        self.rPanel:removeItems();
    end
end

--[[

]]
function ExploreGetRwdRow:setData (_data)
    self.gift = _data;

    if (nil == gift) then
        gift = {propId = 1041, num = 1, second = 0};
    end
    
    self.pCfg = PropDataProxy.getPropCfgById(self.gift.propId);
    self:drawRow();
end

--[[
    绘制面板
    _tp number 
]]
function ExploreGetRwdRow:drawRow (_tp)
    local propCfg = nil;
    local numPerSecond, maxCnt, buJiCost = 1, 1, 1;
    
    propCfg = self.pCfg;
    GetComponent(self.rwdItem, "UISprite").spriteName = self.gift.propId;
    GetComponent(self.itemDesc, "UILabel").text = PropDataProxy.getPropName(propCfg);

    if (0 == self.tp) then
        numPerSecond = ExploreMapDataProxy.getPropGetNumPerSecond(self.gift.propId);
        maxCnt = ExploreMapDataProxy.getPropGetMaxCnt(self.gift.propId);
        buJiCost = ExploreMapDataProxy.getPropCostPerSecond(self.gift.propId);
        GetComponent(self.upTxt, "UILabel").text = numPerSecond .. const_per .. "/" .. const_second;
        GetComponent(self.totalInfo, "UILabel").text = const_totalInfoWord;
        GetComponent(self.totalVal, "UILabel").text = self.gift.num .. "|" .. maxCnt;
        GetComponent(self.buJiInfo, "UILabel").text = const_buJi;
        GetComponent(self.buJiWord, "UILabel").text = self.gift.num * buJiCost;
    else
        GetComponent(self.upTxt, "UILabel").text = self.gift.num .. "";
        GetComponent(self.totalInfo, "UILabel").text = const_timeCount;
        GetComponent(self.totalVal, "UILabel").text = LogicUtil.getCountTimeStr(self.gift.second * 1000);
        self.buJiInfo:SetActive(false);
        self.buJiWord:SetActive(false);
    end
end

--[[

]]
--function ExploreGetRwdRow:propAnalysis (_data)
--    local msg, perProp, propCfg = "", nil, nil;

--    if (nil ~= _data) then
--        for i = 1, #_data do
--            perProp = _data[i];
--            propCfg = PropDataProxy.getPropCfgById(perProp.propId);
--            if (nil ~= propCfg) then

--                msg = " " .. msg  .. PropDataProxy.getPropName(propCfg) .. "X" .. perProp.num;
--            end
--        end
--    end

--    return msg;
--end
