HeroDrop = class(BaseHero)
 
function HeroDrop:ctor()
	self.prefabName = nil
	self.quality = nil
end

function HeroDrop:init(heroId)
	self.heroId = tostring(heroId)
	local herosConf = Config.getHerosData()
	local conf = herosConf[self.heroId]
	if IsEmptyTable(conf) then
		return
	end
	self.conf = conf
	self.prefabName = conf["#prefab_name"]
	self.quality = conf["quality"]
	self.heroName = conf["hero_name"]
end

function HeroDrop:createHero()
	local hero = self.super.createHero(self, "UI/Hero")
	self.heroObj = hero
	return hero
end

function HeroDrop:refresh(heroId)
	self:init(heroId)
	self:refreshHero()
end
