--[[
-- Desc: ׼
-- Author: kenny
-- Date: 2016
--]]
ReadyAction = class(BaseAction);

function ReadyAction:ctor()
	self.root = ViewUtil.getRootView()
	self.fightObj = FightControler.gameObject
end

function ReadyAction:onBegin()
	self.super.onBegin(self)
	self.go = CreateObject(Util.LoadPrefab("Effects/ReadyGo", AssetBundleInfo.assetBundles))
	self.endCond[2] = GetParticleTime(self.go)
	self:doAction()
end

function ReadyAction:onEnd()
	self.super.onEnd(self)
--	self.fightView.readyGo:SetActive(false)
	DestroyObject(self.go)
end

function ReadyAction:doAction()    
    self.super.doAction(self)
	
--    self.fightView.readyGo.transform.localPosition = Vector3(0, 0, 0)
--    self.fightView.readyGo.transform.localScale = Vector3(4, 4, 0)

--  	local lastTime = self:getEndCondition()[2]
--    iTween.ScaleTo(self.fightView.readyGo, iTween.Hash("scale", Vector3(0.7, 0.7, 0) , "islocal" , true, "time", lastTime / 3, "easeType", iTween.EaseType.easeOutQuint))
--    iTween.ScaleTo(self.fightView.readyGo, iTween.Hash("scale", Vector3(0, 0, 0) , "delay" , lastTime / 3 , "islocal" , true, "time", lastTime / 3, "easeType", iTween.EaseType.easeOutQuint , "oncomplete" , self.onCallback , "luaobj" , self))

	HangObject(self.go, self.fightObj)
end

function ReadyAction.onCallback(luaobj)
	FightControler.getActionManager():endAction(luaobj)
end
