require "Game/GM/View/GMView"
 
GMControler = {}
local this = GMControler

function GMControler.New()
	return this
end

function GMControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = GMView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()

    this.view:initPanel();
end

function GMControler.Awake()
end

function GMControler.Start()
--	this.view:Start(this.data)
end

function GMControler.Update()
end

function GMControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function GMControler.initListener()
end

function GMControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function GMControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function GMControler.accept(data)
	ViewUtil.initData(this, data)
end
