
HeroView = class(BaseView)

function HeroView:ctor()
    self.gameObject = nil;
    self.transform = nil;
end  

function HeroView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()

	if AudioConst.GetBgmName() ~= "main" then
		SimpleAudio.StopMusic(doNthFunc)
		SimpleAudio.PlayMusic("main")
		AudioConst.SetBgmName("main")
	end
end

function HeroView:Start(data)
	self:initData(data)
end

function HeroView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
--	local scvPath = "Mode/Top/Panel/ScrollBG/"
--	self.scvBGSpr = GetPathComponent(self.transform, scvPath, "UISprite")
--	self.scvPanel = GetPathComponent(self.transform, scvPath.."ScrollView", "UIPanel")
--	ViewUtil.adaptScrollViewHeight(self.scvBGSpr, self.scvPanel, 110)

	local centerPath = "Mode/Center/Panel"
	self.scvBG = GetGameObject(self.transform, centerPath.."/ScrollBG")
	self.scvObj = GetGameObject(self.scvBG.transform, "ScrollView")
	self.gridObj = GetGameObject(self.scvObj.transform, "Panel/Grid")
	self.grid = GetComponent(self.gridObj.transform, "UIGrid")
	ViewUtil.adaptUISize(self.scvBG, true, 40, 20, 0, 0)
	ViewUtil.adaptUISize(self.scvObj, false, 40, 20, 0, 0)

	DelayCall(function() 
        if (not (GuideControler and GuideControler.isGuideShowing())) then
		    ResetScrollView(self.scvObj)
        end
	end, 0.1)

 	self.heroBtn01 = GetGameObject(self.gridObj.transform, "heroBtn01")
 	self.heroBtn02 = GetGameObject(self.gridObj.transform, "heroBtn02")
 	self.heroBtn03 = GetGameObject(self.gridObj.transform, "heroBtn03")
 	self.heroBtn04 = GetGameObject(self.gridObj.transform, "heroBtn04")
 	self.heroBtn05 = GetGameObject(self.gridObj.transform, "heroBtn05")
 	self.heroBtn06 = GetGameObject(self.gridObj.transform, "heroBtn06")
 	self.heroBtn07 = GetGameObject(self.gridObj.transform, "heroBtn07")
 	self.heroBtn08 = GetGameObject(self.gridObj.transform, "heroBtn08");
 	self.heroBtn09 = GetGameObject(self.gridObj.transform, "heroBtn09")    

    --ǰ汾εù 2016-10-18 17:13:59 library
   self.heroBtn08:SetActive(false);

    local function doClick(obj)
		if obj == self.heroBtn01 then
			ViewUtil.openView(ModuleName.FC)
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {[1] = 0, [2] = TeamData.GetCurPageIndex()});
            end
		elseif obj == self.heroBtn02 then
			ViewUtil.openView(ModuleName.MH)
		elseif obj == self.heroBtn03 then
			ViewUtil.openView(ModuleName.HI)
		elseif obj == self.heroBtn04 then
		elseif obj == self.heroBtn05 then
			ViewUtil.openView(ModuleName.TJ, false, function () 
                Facade:sendNotification(MVCConst.REFRESHPANE, {ModuleName.TJ})
            end)
		elseif obj == self.heroBtn06 then
            if (FBData.IsPassedGate(FBData.OpenData.FouthOpen[1], 1)) then
			    ViewUtil.openView(ModuleName.BF)
            else
                ViewUtil.showMsg(FBData.OpenData.FouthOpen[2]);
            end
		elseif obj == self.heroBtn07 then
			ViewUtil.openView(ModuleName.HU);
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
		elseif obj == self.heroBtn08 then
			ViewUtil.goto(ModuleName.HEROSTORY, nil, function () 
                    ViewUtil.openView(ModuleName.HEROSTORY);
                end, 
            nil);
		elseif obj == self.heroBtn09 then
			ViewUtil.openView(ModuleName.ROLE)
		end
    end
	-- UIEventListener.Get(self.heroBtn01).onClick = doClick
	-- UIEventListener.Get(self.heroBtn02).onClick = doClick
	-- UIEventListener.Get(self.heroBtn03).onClick = doClick
	-- UIEventListener.Get(self.heroBtn04).onClick = doClick
	-- UIEventListener.Get(self.heroBtn05).onClick = doClick
	-- UIEventListener.Get(self.heroBtn06).onClick = doClick
	-- UIEventListener.Get(self.heroBtn07).onClick = doClick
	-- UIEventListener.Get(self.heroBtn08).onClick = doClick
	-- UIEventListener.Get(self.heroBtn09).onClick = doClick
	ViewUtil.AddClickEvent(self.heroBtn01, doClick)
	ViewUtil.AddClickEvent(self.heroBtn02, doClick)
	ViewUtil.AddClickEvent(self.heroBtn03, doClick)
	ViewUtil.AddClickEvent(self.heroBtn04, doClick)
	ViewUtil.AddClickEvent(self.heroBtn05, doClick)
	ViewUtil.AddClickEvent(self.heroBtn06, doClick)
	ViewUtil.AddClickEvent(self.heroBtn07, doClick)
	ViewUtil.AddClickEvent(self.heroBtn08, doClick)
	ViewUtil.AddClickEvent(self.heroBtn09, doClick)
end

function HeroView:initData(data)
end
