require "Game/HeroChange/View/HeroChangeView"
 
HeroChangeControler = {}

local this = HeroChangeControler

function HeroChangeControler.New()
	return this
end

function HeroChangeControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = HeroChangeView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function HeroChangeControler.Awake()
end

function HeroChangeControler.Start()
	this.view:Start(this.data)
end

function HeroChangeControler.Update()
end

function HeroChangeControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function HeroChangeControler.initListener()
end

function HeroChangeControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA, MVCConst.HERO_SORTCHOSENOTE}
    return unpack(list)
end

function HeroChangeControler.handleNotification(notification)
    local nName = notification:getName()
    local nBody = notification:getBody()
	local isChge = false

    if nName ==MVCConst.HERO_SORTCHOSENOTE then
		this.view:sortHeroListNow(tonumber(nBody[1]), tonumber(nBody[2]))
    end
end

function HeroChangeControler.accept(data)
	ViewUtil.initData(this, data)
end
