--单个hero的逻辑类
--2016-7-1 17:23:22 library

HeroGuidePerHero = class();

--[[

]]
function HeroGuidePerHero:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.heroBG = nil;
    self.heroSprite = nil;
    self.mask = nil;
    self.goSprite = nil;

    self.hCfg = nil;
    self.heroId = 0;
end

--[[

]]
function HeroGuidePerHero:Awake (_go, _goSprite)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.goSprite = _goSprite;

    self:initPanel();
end

--[[

]]
function HeroGuidePerHero:Start ()
    
end

--[[

]]
function HeroGuidePerHero:initPanel ()
    self.heroBG = GetGameObject(self.gameObject.transform, "BG");
    self.heroSprite = GetGameObject(self.gameObject.transform, "Sprite");

    ViewUtil.AddClickEvent(self.gameObject, function () self:goHeroDetail(); end)
end

--[[

]]
function HeroGuidePerHero:setData (_heroId, _hCfg)
    self.heroId = _heroId;
    self.hCfg = _hCfg;

    self:showHero();
    self:drawMask();
end

--[[

]]
function HeroGuidePerHero:showHero ()
    GetComponent(self.heroBG, "UISprite").spriteName = "class" .. HeroDataProxy.getHeroQuality(self.hCfg);
    GetComponent(self.heroSprite, "UISprite").spriteName = HeroDataProxy.getHeroAtlasName(self.hCfg);
    GetComponent(self.gameObject, "UIButton").normalSprite = "class" .. HeroDataProxy.getHeroQuality(self.hCfg);
end

--[[

]]
function HeroGuidePerHero:drawMask ()
    local tab = {heroId = self.heroId};
    
    if (not HeroDataProxy.isEverGet(tab)) then
        if (nil == self.mask) then
            self.mask = CreateObject(self.goSprite);
            GetComponent(self.mask, "UISprite").width = 105;
            GetComponent(self.mask, "UISprite").height = 105;
            self.mask:SetActive(true);
            HangObject(self.mask, self.gameObject);
            ViewManager.SortDepth(self.gameObject);
        end
    else
        if (nil ~= self.mask) then
            DestroyObject(self.mask);
            self.mask = nil;
        end
    end
end

--[[
    查看英雄详细
    return nil
]]
function HeroGuidePerHero:goHeroDetail ()
    HeroPropControler.accept(self.hCfg);
    ViewUtil.openView(ModuleName.HP, true);
end
