require "Game/HeroInherit/View/HeroInheritView"
 
HeroInheritControler = {}

local this = HeroInheritControler

function HeroInheritControler.New()
	return this
end

function HeroInheritControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = HeroInheritView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function HeroInheritControler.Awake()
end

function HeroInheritControler.Start()
	this.view:Start(this.data)
end

function HeroInheritControler.Update()
end

function HeroInheritControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function HeroInheritControler.initListener()
end

function HeroInheritControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function HeroInheritControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function HeroInheritControler.accept(data)
	ViewUtil.initData(this, data)
end

function HeroInheritControler.changeHero(heroClass, extra)
	this.view:changeHero(heroClass, extra)
end
