require "Game/HeroUpgrade/View/HeroUpgradeView"
require "Game/HeroUpgrade/View/HUAllUpPane"
require "Game/HeroUpgrade/View/HUIntensifyDetailPane"
require "Game/HeroUpgrade/View/HULvlUpRow"
require "Game/HeroUpgrade/View/HUIntensifyRow"
require "Game/HeroUpgrade/View/HUShowPropsPane"
require "Game/HeroUpgrade/View/HUStrongPane"
require "Game/HeroUpgrade/View/HUWakeupPane"
 
HeroUpgradeControler = {
    heros = nil;
}

local this = HeroUpgradeControler

function HeroUpgradeControler.New()
	return this
end

function HeroUpgradeControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = HeroUpgradeView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)
    
	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function HeroUpgradeControler.Awake()
    
end

function HeroUpgradeControler.Start()
	this.view:Start()
end

function HeroUpgradeControler.Update()
end

function HeroUpgradeControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function HeroUpgradeControler.initListener()
end

function HeroUpgradeControler.slideTab(sw)
	this.view:slideTab(sw)
end

--[[
    刷新攻防显示
]]
function HeroUpgradeControler.refreshTotalAbility ()
    this.view:calculateTotalAbility();
    Facade:sendNotification(MVCConst.UPDATE_MNY, 7);
end

function HeroUpgradeControler.listNotificationInterests()
    local list = {
        MVCConst.ON_RECV_DATA,
        MVCConst.HU_INTENSIFY,
        MVCConst.HEROUPGRADE_GUIDEINTENSIFY
    }
    return unpack(list)
end

function HeroUpgradeControler.handleNotification(note)
    local nName = note:getName();
    local nBody = note:getBody();
    local nType = note:getType();

    if (MVCConst.HU_INTENSIFY == nName) then
        --nBody[1],0，强化详细面板；1，铸神兵详细面板；2，觉醒详细面板
        this.view:showStrongPane(nBody[1], nBody[2]);
    elseif (MVCConst.HEROUPGRADE_GUIDEINTENSIFY == nName) then
--        this.view:slideTab(2);
--        local iBarGO = this.view.contentIntensify.transform:GetChild(0).gameObject;
--        local luaBhvi, lua = nil, nil;
--        if (nil ~= iBarGO) then
--            luaBhvi = GetComponent(iBarGO, "LuaBehaviour");
--            if (nil ~= luaBhvi) then
--                lua = luaBhvi.sourceLuaObj;
--                this.view:showStrongPane(0, lua);
--            end
--        end
    end
end

function HeroUpgradeControler.accept(data)
    this.heros = data;
end

