--[[
-- PVP
--]]
require "Game/League/View/LeaguePVPView"
 
LeaguePVPControler = {}

local this = LeaguePVPControler

function LeaguePVPControler.New()
	return this
end

function LeaguePVPControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeaguePVPView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function LeaguePVPControler.Awake()
end

function LeaguePVPControler.Start()
	this.view:Start(this.data)
end

function LeaguePVPControler.Update()
end

function LeaguePVPControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeaguePVPControler.initListener()
end

function LeaguePVPControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeaguePVPControler.handleNotification(notification)
end

function LeaguePVPControler.accept(data)
	ViewUtil.initData(this, data)
end
