--[[
-- սƥ
--]]
require "Game/League/View/LeaguePVPFinalView"
 
LeaguePVPFinalControler = {}

local this = LeaguePVPFinalControler

function LeaguePVPFinalControler.New()
	return this
end

function LeaguePVPFinalControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeaguePVPFinalView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function LeaguePVPFinalControler.Awake()
end

function LeaguePVPFinalControler.Start()
	this.view:Start(this.data)
end

function LeaguePVPFinalControler.Update()
end

function LeaguePVPFinalControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeaguePVPFinalControler.initListener()
end

function LeaguePVPFinalControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeaguePVPFinalControler.handleNotification(notification)
end

function LeaguePVPFinalControler.accept(data)
	ViewUtil.initData(this, data)
end
