--[[
-- սƥ
--]]
require "Game/League/View/LeaguePVPPreView"
 
LeaguePVPPreControler = {}

local this = LeaguePVPPreControler

function LeaguePVPPreControler.New()
	return this
end

function LeaguePVPPreControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeaguePVPPreView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function LeaguePVPPreControler.Awake()
end

function LeaguePVPPreControler.Start()
	this.view:Start(this.data)
end

function LeaguePVPPreControler.Update()
end

function LeaguePVPPreControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeaguePVPPreControler.initListener()
end

function LeaguePVPPreControler.listNotificationInterests()
    -- local list = {MVCConst.LEAGUEPVP_MATCHED}

    -- return unpack(list)
end

function LeaguePVPPreControler.handleNotification(notification)
	-- local notiName = notification:getName();
 --    local notiBody = notification:getBody();
 --    local notyType = notification:getType();

 --    local def = notiBody[1]
 --    if notiName == MVCConst.LEAGUEPVP_MATCHED then
 --    	this.view:RefreshStatus(def.msg)
 --    end
end

function LeaguePVPPreControler.accept(data)
	ViewUtil.initData(this, data)
end
