--[[
-- ս׼
--]]
require "Game/League/View/LeaguePVPReadyFightView"
require "Game/League/View/LeaguePVPRFChoose"
 
LeaguePVPReadyFightControler = {}

local this = LeaguePVPReadyFightControler

function LeaguePVPReadyFightControler.New()
	return this
end

function LeaguePVPReadyFightControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeaguePVPReadyFightView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject, this)
    this.initListener()
    UpdateHelper.addUpdate(this.Update)
end

function LeaguePVPReadyFightControler.Awake()
end

function LeaguePVPReadyFightControler.Start()
	this.view:Start(this.data)
end

function LeaguePVPReadyFightControler.Update()
	this.view:Update()
end

function LeaguePVPReadyFightControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeaguePVPReadyFightControler.initListener()
end

function LeaguePVPReadyFightControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeaguePVPReadyFightControler.handleNotification(notification)
end

function LeaguePVPReadyFightControler.accept(data)
	ViewUtil.initData(this, data)
end
