--[[
-- 
--]]
require "Game/League/View/LeagueRankingView"
 
LeagueRankingControler = {}

local this = LeagueRankingControler

function LeagueRankingControler.New()
	return this
end

function LeagueRankingControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeagueRankingView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function LeagueRankingControler.Awake()
end

function LeagueRankingControler.Start()
	this.view:Start(this.data)
end

function LeagueRankingControler.Update()
end

function LeagueRankingControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeagueRankingControler.initListener()
end

function LeagueRankingControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeagueRankingControler.handleNotification(notification)
end

function LeagueRankingControler.accept(data)
	ViewUtil.initData(this, data)
	Facade:sendNotification(MVCConst.OPEN_MODULE, {[1]=ModuleName.LeagueApply})
end
