
LeaguePVPFightingEnemy = class();

--[[

]]
function LeaguePVPFightingEnemy:ctor ()
    self.gameObject = nil
    self.transform = nil
end

--[[

]]
function LeaguePVPFightingEnemy:Awake (_go)
    self.gameObject = _go
    self.transform = self.gameObject.transform
end

--[[

]]
function LeaguePVPFightingEnemy:Start ()
    self:initPanel()
end

--[[

]]
function LeaguePVPFightingEnemy:initPanel ()
    ViewUtil.AddClickEvent(self.gameObject, function () self:clickFight() end)
end

--[[

]]
function LeaguePVPFightingEnemy:setData (_vector2, _teamId, _ctrl)
    self.posVec = _vector2
    self.teamId = _teamId
    self.ctrl = _ctrl
end

--[[
    
]]
function LeaguePVPFightingEnemy:clickFight ()
    if Vector2.Distance(self.posVec, self.ctrl.view.playerPosition) == 1 then
        Network.SendMoData(ServerID.LeaguePVPFightEnemy, {self.teamId}, function(session, params)
            local serviceId = tonumber(session.serviceId)
            local mo = GetProtoTable("DefaultData", session)
            if mo.code == 0 then
                ViewUtil.showMsg("开始挑战！")
            else
                ViewUtil.showMsg(GetWord(defData.code))
            end
        end, {})
    end
end

function LeaguePVPFightingEnemy:UpdatePosVec(_vector2)
    self.posVec = _vector2
end

--[[

]]
function LeaguePVPFightingEnemy:OnDestroy ()
    self.transform = nil
    self.gameObject = nil
end
