
LeaguePVPFightingRow = class();

--[[

]]
function LeaguePVPFightingRow:ctor ()
    self.gameObject = nil
    self.transform = nil

    self.bg = nil

    self.posVec = nil    --整张地图中的坐标
end

--[[

]]
function LeaguePVPFightingRow:Awake (_go)
    self.gameObject = _go
    self.transform = self.gameObject.transform
end

--[[

]]
function LeaguePVPFightingRow:Start ()
    self:initPanel()
end

--[[

]]
function LeaguePVPFightingRow:initPanel ()
    self.bg = GetGameObject(self.transform, "BG")

    ViewUtil.AddClickEvent(self.gameObject, function () self:clickSqu() end)
end

--[[
    _vector2 Vector2 整张地图的相对坐标
]]
function LeaguePVPFightingRow:setData (_vector2, _ctrl)
    self.posVec = _vector2
    self.ctrl = _ctrl
end

--[[
    
]]
function LeaguePVPFightingRow:clickSqu ()
    if Vector2.Distance(self.posVec, self.ctrl.view.playerPosition) == 1 then
        local direction = nil
        local tempVector = self.posVec - self.ctrl.view.playerPosition
        if tempVector.y == 1 then
            direction = 0
        elseif tempVector.y == -1 then
            direction = 1
        elseif tempVector.x == -1 then
            direction = 2
        elseif tempVector.x == 1 then
            direction = 3
        end

        if self.ctrl.view.canClickMove then
            self.ctrl.view.canClickMove = false
            Network.SendMoData(ServerID.LeaguePVPFightMove, {direction}, function(session, params)
                local serviceId = tonumber(session.serviceId)
                local mo = GetProtoTable("LeagueFightBattleTeamPositionData", session)
                -- error("x = "..mo.x.." y = "..mo.y)
                if mo.x == self.posVec.x and mo.y == self.posVec.y then
                    self.ctrl.view:SetPlayerPosition(self.posVec.x, self.posVec.y)
                    -- ViewUtil.showMsg("移动！")
                    self.ctrl.view.canClickMove = true
                else
                    ViewUtil.showMsg("移动失败！")
                    self.ctrl.view.canClickMove = true
                end
            end, {})
        end
    end
end

--[[
    
]]
function LeaguePVPFightingRow:moveHandle (sd)
    
end

--[[

]]
function LeaguePVPFightingRow:OnDestroy ()
    self.transform = nil
    self.gameObject = nil
    -- self.bg = nil
    -- self.posVec = nil
    -- self.ctrl = nil
end
