
LeaguePVPRFChoose = class();

--[[

]]
function LeaguePVPRFChoose:ctor ()
    self.gameObject = nil
    self.transform = nil
end

--[[

]]
function LeaguePVPRFChoose:Awake (_go)
    self.gameObject = _go
    self.transform = self.gameObject.transform

    self.isChosen = false
end

--[[

]]
function LeaguePVPRFChoose:Start ()
    self:initPanel()
end

--[[

]]
function LeaguePVPRFChoose:initPanel ()
    self.nameLbl = GetPathComponent(self.transform, "Label", "UILabel")

    ViewUtil.AddClickEvent(self.gameObject, function () self:doClick() end)
end

--[[
    
]]
function LeaguePVPRFChoose:setData (_teamId, _onlyId, _name, _ctrl)
    self.teamId = _teamId
    self.onlyId = _onlyId
    self.name = _name
    self.ctrl = _ctrl
end

--[[
    
]]
function LeaguePVPRFChoose:doClick ()
    -- self.ctrl.view.hadChosenOne = not self.ctrl.view.hadChosenOne

    if self.ctrl.view.firstTeamId == nil then
        self.ctrl.view.firstTeamId = self.teamId
        self.ctrl.view.firstOnlyId = self.onlyId
        self.ctrl.view.firstName = self.name
        -- error("firstOnlyId = "..self.ctrl.view.firstOnlyId)
    else
        if self.ctrl.view.firstTeamId == self.teamId then
            self.ctrl.view.firstTeamId = nil
            self.ctrl.view.firstOnlyId = nil
            self.ctrl.view.firstName = nil
        else
            self.ctrl.view.secondTeamId = self.teamId
            self.ctrl.view.secondOnlyId = self.onlyId
            self.ctrl.view.secondName = self.name
            -- error("secondOnlyId = "..self.ctrl.view.secondOnlyId)
        end
    end

    if self.isChosen then
        self.ctrl.view:RemoveSlt()
        self.isChosen = false
    else
        self.ctrl.view:AddSlt(self.gameObject)
        self.isChosen = true

    end
    -- if self.ctrl.view.hadChosenOne then
    if self.ctrl.view.secondTeamId ~= nil then
        ViewUtil.comCfmPanel("是否确认变换位置？", function () self.ctrl.view:ExchangeSlot() end, function ()
            self.ctrl.view:RemoveSlt()
            self.ctrl.view.firstTeamId = nil
            self.ctrl.view.secondTeamId = nil
            self.ctrl.view.firstOnlyId = nil
            self.ctrl.view.secondOnlyId = nil
            self.ctrl.view.firstName = nil
            self.ctrl.view.secondName = nil
        end)
    end
end

--[[
    
]]
function LeaguePVPRFChoose:moveHandle (sd)
    
end

--[[

]]
function LeaguePVPRFChoose:OnDestroy ()
    self.transform = nil
    self.gameObject = nil
end

--[[

]]
function LeaguePVPRFChoose:SetTeamId (_teamId)
    self.teamId = _teamId
end

--[[
    
]]
function LeaguePVPRFChoose:SetName (_name)
    self.name = _name
    self.nameLbl.text = _name
end