
LeaguePVPReadyFightView = class(BaseView)

function LeaguePVPReadyFightView:ctor()
end  

function LeaguePVPReadyFightView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
end

function LeaguePVPReadyFightView:Start(data)
	self:initData(data)
end

function LeaguePVPReadyFightView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)
		
		if obj == self.btnBack then
			self:closeView(true)
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
end

function LeaguePVPReadyFightView:initData(data)
	if IsEmpty(data) then return end
end

