require "Game/Login/View/LoginView"
 
LoginControler = {}

local this = LoginControler

function LoginControler.New()
	return this
end

function LoginControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LoginView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()

--	UpdateHelper.addUpdate(this.Update)
end

function LoginControler.Awake()
end

function LoginControler.Start()
	this.view:Start(this.data)
end

function LoginControler.Update()
	this.view:Update()
end

function LoginControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LoginControler.initListener()
end

function LoginControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LoginControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function LoginControler.accept(data)
	ViewUtil.initData(this, data)
end
