require "Game/Login/View/RegisterView"
 
RegisterControler = {}

local this = RegisterControler

function RegisterControler.New()
	return this
end

function RegisterControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = RegisterView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function RegisterControler.Awake()
end

function RegisterControler.Start()
	this.view:Start(this.data)
end

function RegisterControler.Update()
end

function RegisterControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function RegisterControler.initListener()
end

function RegisterControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function RegisterControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function RegisterControler.accept(data)
	ViewUtil.initData(this, data)
end
