require "Game/Login/View/SelectRoleView"
 
SelectRoleControler = {}

local this = SelectRoleControler

function SelectRoleControler.New()
	return this
end

function SelectRoleControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = SelectRoleView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function SelectRoleControler.Awake()
end

function SelectRoleControler.Start()
	this.view:Start(this.data)
end

function SelectRoleControler.Update()
end

function SelectRoleControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function SelectRoleControler.initListener()
end

function SelectRoleControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function SelectRoleControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function SelectRoleControler.accept(data)
	ViewUtil.initData(this, data)
end
