require "Game/Main/View/MainView"
 
MainControler = {}

local this = MainControler

function MainControler.New()
	return this
end

function MainControler.OnCreate(obj, name)
	UpdateHelper.addUpdate(this.Update)
	this.root = ViewUtil.getRootView()
	this.view = MainView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
    this.view:Start(this.data);
end

function MainControler.Awake()
end

function MainControler.Update()
	this.view:Update()
end

function MainControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function MainControler.initListener()
end

function MainControler.listNotificationInterests()
    local list = {
        MVCConst.ON_RECV_DATA, 
        MVCConst.SHOWREDICON
    }
    return unpack(list)
end

function MainControler.handleNotification(notification)
	local notiName = notification:getName();
    local notiBody = notification:getBody();
    local notyType = notification:getType();

    if (MVCConst.SHOWREDICON == notiName) then
        this.view:showRedTips();
    end
end

function MainControler.accept(data)
	ViewUtil.initData(this, data)
end
