require "Game/Pay/View/PayView"
 
PayControler = {}

local this = PayControler

function PayControler.New()
	return this
end

function PayControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = PayView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function PayControler.Awake()
end

function PayControler.Start()
	this.view:Start()
end

function PayControler.Update()
end

function PayControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function PayControler.initListener()
end

function PayControler.listNotificationInterests()
    local list = {
        MVCConst.REFRESH_PAY
    }
    return unpack(list)
end

function PayControler.handleNotification(notification)
	local notiName = notification:getName();
    local notiBody = notification:getBody();
    local notyType = notification:getType();

    if (MVCConst.REFRESH_PAY == nName) then
        this.view:Request();
    end
end
