--主角装备
--2016-11-22 00:00:00 iorinie

require "Game/Role/View/RoleEquipView"
 
RoleEquipControler = {}

local this = RoleEquipControler

function RoleEquipControler.New()
	return this
end

function RoleEquipControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = RoleEquipView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()

	this.request()
end

function RoleEquipControler.Awake()
end

function RoleEquipControler.Start()
end

function RoleEquipControler.Update()
	this.view:Update()
end

function RoleEquipControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function RoleEquipControler.initListener()
end

function RoleEquipControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function RoleEquipControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function RoleEquipControler.request()
end

function RoleEquipControler.accept(data)
	ViewUtil.initData(this, data)
end
