require "Game/SignIn/View/SignInView"
 
SignInControler = {}

local this = SignInControler

function SignInControler.New()
	return this
end

function SignInControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = SignInView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	this.request()
end

function SignInControler.Awake()
end

function SignInControler.Start()
--	this.view:Start(this.data)
end

function SignInControler.Update()
end

function SignInControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
	this.data = nil;
end

function SignInControler.initListener()
end

function SignInControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function SignInControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function SignInControler.request()
	Network.SendMoData(ServerID.SignInWnd, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("DefaultData", session)
        
		this.view:initData(mo)
	end, {})
end

function SignInControler.accept(data)
	ViewUtil.initData(this, data)
end
