
SortCondView = class(BaseView)

local const_condPre = "Cond";

local condLen = 8;


function SortCondView:ctor()
	self.shadeOpacity = true
    self.gameObject = nil;
    self.transform = nil;
    
    self.maskPanel = nil;--ֻȫĻ
    self.panel = nil;

    self.condList = nil;
    self.iconCorrect = nil;

    self.condType = 0;--0ȫ12ɫ3ɫ4ɫ5ɫ6ɫ7սȨ
    self.sortType = 0;--0Ʒ1ս23ȼ4
end  

function SortCondView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	
    self.condList = List.new();

	self:initPanel();
    self:sortTypeShow(self.condType);
end

function SortCondView:Start(data)
--	ComControler.SetShadow(true)
	self:initData(data)
end

function SortCondView:initPanel()
	local btnPath = "Mode/Center/Panel/sortCond/"
    local condPath = "Mode/Center/Panel/selBG/";
    local condTmp, iconTmp = nil, nil;

 	self.btn01 = GetGameObject(self.transform, btnPath.."btn01")
 	self.btn02 = GetGameObject(self.transform, btnPath.."btn02")
 	self.btn03 = GetGameObject(self.transform, btnPath.."btn03")
 	self.btn04 = GetGameObject(self.transform, btnPath.."btn04")
 	self.btn05 = GetGameObject(self.transform, btnPath.."btn05")
	
	local centerPath = "Mode/Center/Panel"
    self.panel = GetGameObject(self.transform, centerPath);
--    GetComponent(self.panel, "UIPanel").depth = GetComponent(self.maskPanel, "UIPanel").depth + 1;
 	self.btnExit = GetGameObject(self.transform, centerPath.."/btnExit");

    local function doClick(obj)
        local isSort = false;
		if obj == self.btn01 then
            isSort = true;
            self.sortType = 0;
		elseif obj == self.btn02 then
            isSort = true;
            self.sortType = 1;
		elseif obj == self.btn03 then
            isSort = true;
            self.sortType = 2;
		elseif obj == self.btn04 then
            isSort = true;
            self.sortType = 3;
		elseif obj == self.btn05 then
            isSort = true;
            self.sortType = 4;
		elseif obj == self.btnExit then
            
		end
        if (isSort) then
            Facade:sendNotification(MVCConst.HERO_SORTCHOSENOTE, {[1] = 1, [2] = self.sortType}, nil);--Body:0,showType;1,sortType
        end
        self:closeView(true);
        DestroyObject(self.maskPanel);
        self.maskPanel = nil;
    end
	-- UIEventListener.Get(self.btn01).onClick = doClick
	-- UIEventListener.Get(self.btn02).onClick = doClick
	-- UIEventListener.Get(self.btn03).onClick = doClick
	-- UIEventListener.Get(self.btn04).onClick = doClick
	-- UIEventListener.Get(self.btn05).onClick = doClick
	-- UIEventListener.Get(self.btnExit).onClick = doClick
    ViewUtil.AddClickEvent(self.btn01, doClick)
    ViewUtil.AddClickEvent(self.btn02, doClick)
    ViewUtil.AddClickEvent(self.btn03, doClick)
    ViewUtil.AddClickEvent(self.btn04, doClick)
    ViewUtil.AddClickEvent(self.btn05, doClick)
    ViewUtil.AddClickEvent(self.btnExit, doClick)
    
    for i = 1, condLen do
        condTmp = GetGameObject(self.transform, condPath .. const_condPre .. i);
        if (nil ~= condTmp) then
            if (8 == i) then
                --غսȨ
                condTmp:SetActive(false);
            end
            if (nil == self.iconCorrect) then
                iconTmp = GetGameObject(condTmp.transform, "IconCorrect");
                if (nil ~= iconTmp) then
                    self.iconCorrect = iconTmp;
                end
            end
            self.condList:add(condTmp);
            ViewUtil.AddButtonClickEvent(condTmp, function () self:condBtnClick(i - 1); end, true);
        end
    end
    --modify by library 2016-11-21 09:51:16 Ӣ
    self.btn05:SetActive(false);
--    self:forCheckVersion();
end

--[[

]]
function SortCondView:forCheckVersion ()
    GetGameObject(self.transform, "Mode/Center/Panel/sortCond"):SetActive(false);
end

--[[
    _idx number
    return nil
]]
function SortCondView:condBtnClick (_idx)
    if (self.condType == _idx) then
        return ;
    end
    self.condType = _idx;
    HangObject(self.iconCorrect, self.condList[self.condType + 1]);
    Facade:sendNotification(MVCConst.HERO_SORTCHOSENOTE, {[1] = 0, [2] = LogicUtil.showTypeToQua(self.condType)}, nil);--Body:0,showType;1,sortType
    LuaCallManager:invokeCall(function () 
        self:closeView(true);
        DestroyObject(self.maskPanel);
        self.maskPanel = nil;
    end, 0);
end

--[[
    ǰʾ
    _showType number
    return nil
]]
function SortCondView:sortTypeShow (_showType)
    self.condType = _showType;
    HangObject(self.iconCorrect, self.condList[self.condType + 1]);
end

function SortCondView:initData(data)
	if IsEmpty(data) then return end
end

