require "Game/Treasure/View/TreasureView"
 
TreasureControler = {}

local this = TreasureControler

function TreasureControler.New()
	return this
end

function TreasureControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = TreasureView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function TreasureControler.Awake()
end

function TreasureControler.Start()
	this.view:Start(this.data)
end

function TreasureControler.slideTab(sw)
	this.view:slideTab(sw)
end

function TreasureControler.Update()
end

function TreasureControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function TreasureControler.initListener()
end

function TreasureControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function TreasureControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function TreasureControler.accept(data)
	ViewUtil.initData(this, data)
end
